#include "../../Library/SDK_Manila_Sense.h"


DIRECTDRAW_GDI *ChildSection::backgroundLeft=NULL;
DIRECTDRAW_GDI *ChildSection::backgroundRight=NULL;
int ChildSection::arrowWidth=0;
int ChildSection::arrowHeight=0;
int ChildSection::backgroundHeight=0;
int ChildSection::backgroundWidth=0;

void ChildSection::loadSurf(){
	if(backgroundLeft==NULL){
		//load backgound images :
		backgroundLeft=loadImage(gi->btn_common_listitem);//patch img on it...
		backgroundRight=loadImage(gi->btn_common_listitem);

		backgroundHeight=backgroundLeft->height;
		backgroundWidth=backgroundLeft->width/4;


		RECT imgSize=patchImage(backgroundLeft,gi->pivot_leftarrow,4,PADDING_ARROW,backgroundHeight/15);
		arrowWidth=imgSize.right;
		arrowHeight=imgSize.bottom;

		patchImage(backgroundRight,gi->pivot_rightarrow,4,backgroundWidth-PADDING_ARROW-arrowWidth,backgroundHeight/15);
	}
	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);

	if(this->getRight()==dwHeight){
		this->setRight(dwWidth);
	}
	
}

ChildSection::ChildSection(int idElement,int x,int y,wstring t,wstring subT):Element(idElement,x,y,TYPE_CHILD_SECTION)
{
	if(backgroundLeft==NULL){
		loadSurf();
	}

	int myHeight=backgroundHeight;
	if(subT!=L""){//title and subtitle
		title=new MyLabel(-1,arrowWidth+2*PADDING_ARROW,5,t,TEXT_NORMAL,(DWORD)0,true);
		subTitle=new MyLabel(-1,arrowWidth+2*PADDING_ARROW,5,subT,TEXT_ITALIC,(DWORD)0,true);
		if(myHeight<title->getBottom())
			myHeight=title->getBottom()*2;
		subTitle->setPaddingTop(myHeight/2);
		if(myHeight<subTitle->getBottom())
			myHeight=subTitle->getBottom();
	}else{//only title
		title=new MyLabel(-1,arrowWidth+2*PADDING_ARROW,5,t,TEXT_NORMAL,(DWORD)0,true);
		title->setPaddingTop(backgroundHeight/4);
		subTitle=NULL;
		if(myHeight<title->getBottom())
			myHeight=title->getBottom()*2;
	}
	state=STATE_NORMAL;
	this->setHeight(myHeight);
	this->setWidth(gi->rs.right);

	sliding=false;
	isInOurSection=false;
	container=NULL;

	slidToLeft=true;
	durationSlide=200;

	ourSection=new Section(-1,0,0,gi->rs.right,t);
	ourSection->owner=this;
	ourSection->add(this,false);
}

ChildSection::~ChildSection(void)
{
	delete title;
	delete subTitle;
}


Element* ChildSection::isClicked(int x,int y){
	if(positionAbsolute.right==positionAbsolute.bottom&&
		positionAbsolute.bottom==0)
		return NULL;//OUT of screen, can't be clicked !

	positionAbsolute.right=positionAbsolute.left+this->getWidth();
	if(x>positionAbsolute.left-5&&x<positionAbsolute.right+5&&y>positionAbsolute.top-10-gi->rcVisibleDesktopTOP.top&&//increase the size
		y<positionAbsolute.top+this->getHeight()-gi->rcVisibleDesktopTOP.top){
			this->isActivated=true;
			if(this->state==STATE_NORMAL||this->state==STATE_SELECTED){
				this->state=STATE_HOVER;
				setMustRedraw();
			}
			return this;
	}
	return NULL;
};

bool ChildSection::run(bool isRightClicked){
	Element::run(isRightClicked);

	if(this->state==STATE_HOVER||
		(mouseEvent->isSlidingLeft()&&!slidToLeft)){//EventHandler::messageTreatment has maybe changed the state of element !
		this->state=STATE_SELECTED;

		if(!isInOurSection){
			container=(Section*)this->mouseEvent->changeMouseAnalyse(this);
			container->setDrawingHook(this);//take responsibility for drawing now !
		}

		sliding=true;
		slideScreen(gi->primaryBuffer);
		return true;//true because take control of events !
	}
	return false;
};
void ChildSection::unClick(){
	if(this->state==STATE_HOVER){
		this->state=STATE_NORMAL;
		setMustRedraw();
		return;
	}
	//give the mouse control :
	if(container!=NULL){
		container->setDrawingHook(NULL);
		this->mouseEvent->changeMouseAnalyse(container);
		mouseEvent->setClickSelected(false);
		container=NULL;
	}else
		return;//call by container, so we have nothing to do...

	this->setMustRedraw();
	gi->rcUpdateRegion=gi->rs;
};

void ChildSection::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){

	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.bottom=positionAbsolute.top+this->getHeight();
	positionAbsolute.left=this->getLeft()+x;
	positionAbsolute.right=positionAbsolute.left+getWidth();

	//are we in the window ?
	//if out of screen, do nothing...
	if(positionAbsolute.top>=gi->rcUpdateRegion.bottom||positionAbsolute.bottom<=gi->rcUpdateRegion.top||
		positionAbsolute.left>=gi->rcUpdateRegion.right||positionAbsolute.right<=gi->rcUpdateRegion.left)
		return;

	if(positionAbsolute.top<gi->rcUpdateRegion.top){
		clipping.top=gi->rcUpdateRegion.top-positionAbsolute.top;
		positionAbsolute.top=gi->rcUpdateRegion.top;
	}else{
		clipping.top=0;
	}
	if(positionAbsolute.bottom>gi->rcUpdateRegion.bottom){
		clipping.bottom=this->getHeight()-(positionAbsolute.bottom-gi->rcUpdateRegion.bottom);
		positionAbsolute.bottom=gi->rcUpdateRegion.bottom;
	}else{
		clipping.bottom=this->getHeight();
	}
	if(positionAbsolute.left<gi->rcUpdateRegion.left){
		clipping.left=(state)*backgroundWidth+gi->rcUpdateRegion.left-positionAbsolute.left;
		positionAbsolute.left=gi->rcUpdateRegion.left;
	}else{
		clipping.left=(state)*backgroundWidth;
	}
	if(positionAbsolute.right>gi->rcUpdateRegion.right){
		positionAbsolute.right=gi->rcUpdateRegion.right;
		clipping.right=clipping.left+(positionAbsolute.right-positionAbsolute.left);
	}else{
		clipping.right=(state+1)*backgroundWidth;
	}
	//now print image :
	HRESULT hres;
	if(slidToLeft){
		if(clipping.right-clipping.left>4&&clipping.left>=0){
			while(backgroundWidth<positionAbsolute.right-positionAbsolute.left){
				RECT clTmp={clipping.left+3,clipping.top,
					clipping.left+4,clipping.bottom};
				RECT posTmp={positionAbsolute.left,positionAbsolute.top,
					positionAbsolute.left+((positionAbsolute.right-positionAbsolute.left)-backgroundWidth),positionAbsolute.bottom};

				hres= gi->window->BltFast(lpDDraw,&posTmp, backgroundRight,&clTmp, DDBLT_WAITNOTBUSY,NULL);
				if (hres != DD_OK){
					LocalisedString::explainFailDirectDraw(hres,L"ChildSection Blt(backgroundRight);");
					return;
				}
				positionAbsolute.left=posTmp.right;
			}
			hres= gi->window->BltFast(lpDDraw,&positionAbsolute, backgroundRight,&clipping, DDBLT_WAITNOTBUSY,NULL);
			if (hres != DD_OK){
				LocalisedString::explainFailDirectDraw(hres,L"ChildSection Blt(backgroundRight);");
				return;
			}
		}
		//print text :
		if(state!=STATE_NORMAL)
			this->title->paintColor(lpDDraw,x,y,RGB(196,196,196),RGB565to32(6,12,6));
		else
			this->title->paintColor(lpDDraw,x,y,RGB(5,5,5),RGB565to32(28,56,28));
		if(subTitle!=NULL){
			if(state!=STATE_NORMAL)
				this->subTitle->paintColor(lpDDraw,x,y,RGB(196,196,196),RGB565to32(6,12,6));
			else
				this->subTitle->paintColor(lpDDraw,x,y,RGB(5,5,5),RGB565to32(28,56,28));
		}
	}else{
		if(clipping.right-clipping.left>4&&clipping.left>=0){
			while(backgroundWidth<positionAbsolute.right-positionAbsolute.left){
				RECT clTmp={clipping.left+3,clipping.top,
					clipping.left+4,clipping.bottom};
				RECT posTmp={positionAbsolute.right-((positionAbsolute.right-positionAbsolute.left)-backgroundWidth),positionAbsolute.top,
					positionAbsolute.right,positionAbsolute.bottom};

				hres= gi->window->BltFast(lpDDraw,&posTmp, backgroundLeft,&clTmp, DDBLT_WAITNOTBUSY,NULL);
				if (hres != DD_OK){
					LocalisedString::explainFailDirectDraw(hres,L"ChildSection Blt(backgroundLeft);");
					return;
				}
				positionAbsolute.right=posTmp.left;
				clipping.right=clipping.left+positionAbsolute.right-positionAbsolute.left;
			}
			HRESULT hres= gi->window->BltFast(lpDDraw,&positionAbsolute, backgroundLeft,&clipping, DDBLT_WAITNOTBUSY,NULL);
			if (hres != DD_OK){
				LocalisedString::explainFailDirectDraw(hres,L"ChildSection Blt(backgroundLeft);");
				return;
			}
		}
		//print text :
		if(state!=STATE_NORMAL)
			this->title->paintColor(lpDDraw,x,y,RGB(196,196,196),RGB565to32(6,12,6));
		else
			this->title->paintColor(lpDDraw,x,y,RGB(5,5,5),RGB565to32(28,56,28));
	}

	//set the real positions...
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.left=this->getLeft()+x;
};


int ChildSection::mouseGesture(){

	if(mouseEvent->isClicked()||mouseEvent->isDblClicked()){
		this->unClick();
		return 0;
	}

	return 0;
};


void ChildSection::slideScreen(DIRECTDRAW_GDI* lpDDraw){

	slidToLeft=!slidToLeft;//inverse the direction of slide
	isInOurSection=!isInOurSection;
	sliding=false;//after this function, we don't slide any more...

	this->state=STATE_NORMAL;//unclick the item...

	if(slidToLeft){
		this->title->setPaddingTop(savPaddingTopTitle);
		this->title->setText(savTitle,false);
	}else{
		savTitle=this->title->getText();
		savPaddingTopTitle=this->title->getPaddingTop();
		this->title->setPaddingTop(backgroundHeight/4);
		this->title->setText(L"Back",false);
	}

	RECT dest=gi->rs;
	RECT src=dest;
	int distancePrev=0;
	int distance=0;
	double speed=1;
	double accel=((double)gi->rs.right-speed*durationSlide)/(durationSlide*durationSlide);
	HRESULT hRet;

	//now render backbuff using our section or father:
	gi->rcUpdateRegion=gi->rs;
	gi->rcUpdateRegion.top=gi->rcVisibleDesktopTOP.top;
	dest.top=gi->rcVisibleDesktopTOP.top;
	src.top=gi->rcVisibleDesktopTOP.top;


	DWORD lastTickMouse=GetTickCount();

	/*
	//clear backbuffer:
	DDBLTFX ddbltfx;
	memset(&ddbltfx, 0, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwFillColor = BACKGROUND_COLOR_MANILA;
	hRet = gi->window->BltFast(gi->backBuffer, NULL,NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);
	if (hRet != DD_OK)
		LocalisedString::explainFailDirectDraw(hRet,L"clear backbuff error");
		*/
	gi->window->BltFast(gi->backBuffer,NULL, gi->background,NULL, DDBLT_WAITNOTBUSY,NULL);

	//not needed : is already started in DDwarp...
	//gi->window->beginPaint();
	if(!isInOurSection){

		//give control of painting and mouse to our container :
		mouseEvent->changeMouseAnalyse(container);
		mouseEvent->setClickSelected(false);
		container->setDrawingHook(NULL);//give responsibility for drawing
		container->paint(gi->backBuffer,0,0);
	}else{
		//set control of painting and mouse to our section :
		mouseEvent->changeMouseAnalyse(ourSection);
		mouseEvent->setClickSelected(false);
		container->setDrawingHook(ourSection);//take responsibility for drawing now !
		ourSection->paint(gi->backBuffer,0,0);
	}


	DWORD timeAnim=10;
	DWORD timeDiff=0;
	lastTickMouse=GetTickCount();
	int nbSlide=0;
	distance=speed*timeAnim+(accel*(timeAnim*timeAnim))/2.0;
	gi->window->beginPaint();
	while(distance<gi->rs.right){
		nbSlide++;
		if(!slidToLeft){
			dest.left=0;
			dest.right=gi->rs.right-((LONG)distance-(LONG)distancePrev);
			src.left=((int)distance-(int)distancePrev);
			src.right=gi->rs.right;
		}else{
			dest.left=((int)distance-(int)distancePrev);
			dest.right=gi->rs.right;
			src.left=0;
			src.right=gi->rs.right-((LONG)distance-(LONG)distancePrev);
		}
		hRet = gi->window->BltFast(lpDDraw, &dest, lpDDraw, &src, DDBLT_WAITNOTBUSY, NULL );
		if (hRet != DD_OK)
			LocalisedString::explainFailDirectDraw(hRet,L"slideScreen error");

		if(!slidToLeft){
			dest.left=gi->rs.right-((LONG)distance-(LONG)distancePrev);
			dest.right=gi->rs.right;
			src.left=(LONG)distancePrev;
			src.right=(LONG)distance;
		}else{
			dest.left=0;
			dest.right=((LONG)distance-(LONG)distancePrev);
			src.left=gi->rs.right-(LONG)distance;
			src.right=gi->rs.right-(LONG)distancePrev;
		}
		hRet = gi->window->BltFast(lpDDraw, &dest, gi->backBuffer, &src, DDBLT_WAITNOTBUSY, NULL );
		if (hRet != DD_OK)
			LocalisedString::explainFailDirectDraw(hRet,L"slideScreen error");
		gi->window->endPaint();

		timeDiff=GetTickCount()-lastTickMouse;
		//timeAnim+=20;
		lastTickMouse=GetTickCount();
		distancePrev=distance;
		if(timeDiff>30){
			timeAnim+=timeDiff;
		}else{
			Sleep(30-timeDiff);
			timeAnim+=30;
		}
		gi->window->beginPaint();
		
		distance=(speed*timeAnim+(accel*(timeAnim*timeAnim))/2.0);
		if(distance<=distancePrev){
			distance=distancePrev+1;
		}

	}

	gi->window->BltFast(gi->primaryBuffer,&gi->rcUpdateRegion,
		gi->backBuffer,&gi->rcUpdateRegion,
		DDBLT_WAITNOTBUSY, NULL );
	//not needed : will be ended in DDwarp...
	//gi->window->endPaint();

	gi->rcUpdateRegion=gi->rs;
};