#include "../../Library/SDK_Manila_Sense.h"
int DirectDrawWarp::background_color=RGB565to32(29,58,29);
GlobalInformations* DirectDrawWarp::gi=NULL;

#ifdef _DEBUG
HANDLE _hFichierDebug = NULL;
#endif

DirectDrawWarp::DirectDrawWarp()
{
	gi=GlobalInformations::getInstance();
#ifdef _DEBUG
	_hFichierDebug = CreateFile((gi->userDirectory+L"GeneralLog.txt").c_str(),GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,0,NULL);
#endif
	g_hWndMenuBar=NULL;
	sectionActiv=-1;
	hasBackground=false;
	isWindowInitialized=false;
	isTopMost=false;
	messageBox=NULL;
	mouse=MouseCtrl::getInstance();
	numRefreash=0;
	hMenuArea.top=hMenuArea.bottom=hMenuArea.left=hMenuArea.right=0;
}
DirectDrawWarp::DirectDrawWarp(HINSTANCE hInstance,const TCHAR* name,bool topmost,HMENU menuBottom)
{
	gi=GlobalInformations::getInstance();
#ifdef _DEBUG//L"\\storage card\\GeneralLog.txt"
	_hFichierDebug = CreateFile((gi->userDirectory+L"GeneralLog.txt").c_str(),GENERIC_WRITE,FILE_SHARE_READ,NULL,CREATE_ALWAYS,0,NULL);
#endif
	g_hWndMenuBar=NULL;
	numRefreash=0;
	this->sectionActiv=-1;//no activ section...
	hasBackground=false;
	isWindowInitialized=false;
	hMenuArea.top=hMenuArea.bottom=hMenuArea.left=hMenuArea.right=0;
	isTopMost=topmost;
	messageBox=NULL;
	gi->window=this;
	mouse=MouseCtrl::getInstance();
	gi->m_hInstance=hInstance;

	gi->m_hWnd=NULL;

	WNDCLASS                    wc;
	DDSURFACEDESC               ddsd;
	HRESULT                     hRet;
	DWORD                       dwUpdateFlags = 0;


	this->name=name;
	// Set up and register window class __declspec(dllexport).

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = DirectDrawWarp::StaticWndProc;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = hInstance;
	wc.hIcon = LoadIcon(hInstance, NULL);
	wc.hCursor = LoadCursor(hInstance, IDC_ARROW);
	wc.hbrBackground = (HBRUSH )GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = this->name;
	RegisterClass(&wc);

	// Create a window.
	if(topmost){
		gi->m_hWnd = CreateWindowEx(WS_EX_TOPMOST,
			this->name,
			this->name,
			WS_POPUP,
			0,
			0,
			GetSystemMetrics(SM_CXSCREEN),
			GetSystemMetrics(SM_CYSCREEN),
			NULL,
			menuBottom,
			hInstance,
			this);
		if (!gi->m_hWnd)
			return;
	}else{
		gi->m_hWnd = CreateWindow(
			this->name,
			this->name,
			WS_SYSMENU,//WS_POPUP
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			NULL,
			menuBottom,
			hInstance,
			this);
			if (!gi->m_hWnd)
				return;
	}

	if(!SipShowIM(SIPF_OFF)){
		LocalisedString::explainFail( LocalisedString::szCreateInputText,L"SipShowIM(SIPF_ON)");
	}
	SHFullScreen(gi->m_hWnd,SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);


	GetClientRect(gi->m_hWnd, &gi->rs);
	if(gi->ldDDraw==NULL){
		gi->ldDDraw=new LPDIRECTDRAW;
	/*
		if(!MoveWindow(gi->m_hWnd,
			(GetSystemMetrics(SM_CXSCREEN)-gi->rs.right)/2,
			GetSystemMetrics(SM_CYSCREEN)-gi->rs.bottom,
			gi->rs.right,
			gi->rs.bottom,
			true));
	*/

	/*
		gi->rs.top=GetSystemMetrics(SM_CYSCREEN)-gi->rs.bottom;
		gi->rs.bottom=GetSystemMetrics(SM_CYSCREEN);
	*/
		gi->rcUpdateRegion=gi->rs;
		gi->rcVisibleDesktopTOP=gi->rs;

		gi->primaryBuffer=new DIRECTDRAW_GDI;
		gi->primaryBuffer->bitmap=0;
		gi->primaryBuffer->directDrawSurf=NULL;
		gi->primaryBuffer->deviceInterface=0;
		gi->primaryBuffer->height=GetSystemMetrics(SM_CYSCREEN)-gi->rcVisibleDesktopTOP.top;
		gi->primaryBuffer->width=GetSystemMetrics(SM_CXSCREEN);
		gi->primaryBuffer->nbBPP=16;

		
		///////////////////////////////////////////////////////////////////////////
		// Create the main DirectDraw object
		///////////////////////////////////////////////////////////////////////////
		hRet = DirectDrawCreate(NULL, gi->ldDDraw, NULL);
		if (hRet != DD_OK){//DDERR_DCALREADYCREATED
			LocalisedString::explainFailDirectDraw(hRet, LocalisedString::szDDrawFailedMsg);
			return;
		}
		// Get exclusive mode
		hRet = (*gi->ldDDraw)->SetCooperativeLevel(gi->m_hWnd, DDSCL_NORMAL);
		if (hRet != DD_OK){
			LocalisedString::explainFail( LocalisedString::szSetCooperativeFailMsg,L"SetCooperativeLevel");
			return;
			}

		/*
		DDSURFACEDESC DDSurfDesc;
		memset(&DDSurfDesc, 0, sizeof(DDSurfDesc));
		DDSurfDesc.dwSize = sizeof(DDSurfDesc);

		hRet = g_pDD->GetDisplayMode(&DDSurfDesc );
		if ( hRet != DD_OK ){
			LocalisedString::explainFail( L"GetDisplayMode",L"GetDisplayMode Failed!");
			return;
		}
		gi->rs.top=0;
		gi->rs.left=0;
		gi->rs.right= DDSurfDesc.dwWidth;
		gi->rs.bottom= DDSurfDesc.dwHeight;
		ScreenBpp = DDSurfDesc.ddpfPixelFormat.dwRGBBitCount;
		*/

		// Create the primary surface (only for overlay caps):
		memset(&ddsd, 0, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwHeight=1;
		ddsd.dwWidth=1;
		ddsd.dwFlags = DDSD_CAPS;
		ddsd.ddsCaps.dwCaps = DDSCAPS_PRIMARYSURFACE;

		hRet = (*gi->ldDDraw)->CreateSurface(&ddsd, &gi->primaryBuffer->directDrawSurf, NULL);
		if (hRet != DD_OK)
		{
			LocalisedString::explainFailDirectDraw(hRet,L"CreateSurface(Primary SglBuff)");
			return;
		}
	}
	gi->primaryBuffer->directDrawSurf->GetDC(&gi->primaryBuffer->deviceInterface);

	ShowWindow(gi->m_hWnd, true);
	UpdateWindow(gi->m_hWnd);
	SetFocus(gi->m_hWnd);

	DDSURFACEDESC DDSurfDesc;
	memset(&DDSurfDesc, 0, sizeof(DDSurfDesc));
	DDSurfDesc.dwSize = sizeof(DDSurfDesc);
	DDSurfDesc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT;
	DDSurfDesc.dwWidth = gi->rs.right;
	DDSurfDesc.dwHeight = gi->rs.bottom;

	gi->background=new DIRECTDRAW_GDI;
	//HRESULT hret=(*gi->ldDDraw)->CreateSurface(&DDSurfDesc, &gi->background->directDrawSurface, NULL );
	HRESULT hret=createSurf(&DDSurfDesc, gi->background);
	if (hret != DD_OK)
		LocalisedString::explainFailDirectDraw(hret,L"DirectDrawWarp ctor CreateSurface1");

	gi->backBuffer=new DIRECTDRAW_GDI;
	//hret=(*gi->ldDDraw)->CreateSurface(&DDSurfDesc, &gi->backBuffer->directDrawSurface, NULL );
	hret=createSurf(&DDSurfDesc, gi->backBuffer);
	if (hret != DD_OK)
		LocalisedString::explainFailDirectDraw(hret,L"DirectDrawWarp ctor CreateSurface2");
/*
	// Get NORMAL mode
	hRet = g_pDD->SetCooperativeLevel(gi->m_hWnd, DDSCL_NORMAL);
	if (hRet != DD_OK)
		LocalisedString::explainFail( LocalisedString::szSetCooperativeFailMsg,L"SetCooperativeLevel");
*/
	if(isTopMost){
		hRet = gi->window->BltFast(gi->background, NULL, gi->primaryBuffer, NULL, DDBLT_WAITNOTBUSY, NULL );
		if (hRet != DD_OK)
			LocalisedString::explainFailDirectDraw(hRet,L"DirectDrawWarp ctor Blt1");
		hRet = gi->window->BltFast(gi->backBuffer, NULL, gi->primaryBuffer, NULL, DDBLT_WAITNOTBUSY, NULL );
		if (hRet != DD_OK)
			LocalisedString::explainFailDirectDraw(hRet,L"DirectDrawWarp ctor Blt2");
		SetTimer(gi->m_hWnd, 3, 200,NULL);
	}else{
		DDBLTFX ddbltfx;
		memset(&ddbltfx, 0, sizeof(ddbltfx));
		ddbltfx.dwSize = sizeof(ddbltfx);
		ddbltfx.dwFillColor = DirectDrawWarp::background_color;
		gi->window->BltFast(gi->backBuffer,NULL, NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);
		gi->window->BltFast(gi->background,NULL, NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);
	}
	gi->primaryBuffer->directDrawSurf->ReleaseDC(gi->primaryBuffer->deviceInterface);
	gi->primaryBuffer->deviceInterface=0;

	PostMessage(NULL,WM_USER,0,NULL);//post start message to the thread (init the application)

	if(!SipShowIM(SIPF_OFF)){
		LocalisedString::explainFail( LocalisedString::szCreateInputText,L"SipShowIM(SIPF_ON)");
	}
	SHFullScreen(gi->m_hWnd,SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);
	SIPINFO si = {0};
	si.cbSize = sizeof(SIPINFO);
	SHSipInfo(SPI_GETSIPINFO, 0, &si, 0);
	si.fdwFlags = SIPF_OFF;
	SHSipInfo(SPI_SETSIPINFO, 0, &si, 0);
}
void DirectDrawWarp::add(Section* e){
	this->section.push_back(e);
	sectionActiv=0;
};


DirectDrawWarp::~DirectDrawWarp(void)
{
#ifdef _DEBUG
	DWORD NbrElemEcrits=0;
	WriteFile(_hFichierDebug,(LPCVOID)L"Bye",4*sizeof(WCHAR),&NbrElemEcrits,NULL);
	CloseHandle(_hFichierDebug);//empty file
#endif

	if(messageBox!=NULL)
		DestroyWindow(messageBox->hWnd);
	if(gi->m_hWnd!=NULL)
		DestroyWindow(gi->m_hWnd);

	delete mouse;

	/*deleteSurf(&gi->primaryBuffer);//can be reused (if created 2times in the same thread)
	if (g_pDD != NULL)
	{
		g_pDD->Release();
		g_pDD = NULL;
		gi->ldDDraw=NULL;
	}
	*/
	deleteSurf(&gi->backBuffer);
	deleteSurf(&gi->background);


	int taille=this->section.size();
	for(int i=0;i<taille;i++){
		if(this->section[i]!=NULL){
			delete this->section[i];
			this->section[i]=NULL;
		}
	}
}


long FAR PASCAL DirectDrawWarp::StaticWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	DirectDrawWarp* pParent;

	// Get pointer to window
	if(message == WM_CREATE)
	{
		pParent = (DirectDrawWarp*)((LPCREATESTRUCT)lParam)->lpCreateParams;
		SetWindowLong(hWnd,GWL_USERDATA,(LONG_PTR)pParent);
	}
	else
	{
		pParent = (DirectDrawWarp*)GetWindowLong(hWnd,GWL_USERDATA);
		if(!pParent)
			return DefWindowProc(hWnd,message,wParam,lParam);
	}

	return pParent->WindowProc(message,wParam,lParam);
}


//-----------------------------------------------------------------------------
// Name: WindowProc()
// Desc: The Main Window Procedure
//-----------------------------------------------------------------------------
long DirectDrawWarp::WindowProc(UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
#ifdef UNDER_CE
		case WM_ACTIVATE:
#else
		case WM_ACTIVATEAPP:
#endif
			// Pause if minimized or not the top window
			if(gi->isActiv==wParam!=0)
				return 0L;
			Element::sendMsg(WM_ACTIVATE,(void*)wParam);
			gi->isActiv = wParam!=0;
			if(wParam==WA_INACTIVE){
				/*if(isTopMost){
					PostQuitMessage(0);//if minimized, close the app ;-)
				}else{*/
					if(sectionActiv>=0&&sectionActiv<section.size())
						this->section[sectionActiv]->overlayVisibility(false);
					ShowWindow(gi->m_hWnd, SW_MINIMIZED);	//SW_HIDE);
					//SetForegroundWindow((HWND)(((ULONG) GetForegroundWindow()) | 0x01));//To ensure that the last active owned window is reactivated
				//}
			}else{
				SetForegroundWindow((HWND)(((ULONG) gi->m_hWnd) | 0x01));//To ensure that our window is reactivated
				//SHFullScreen(gi->m_hWnd,SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);
				SetFocus(gi->m_hWnd);
				if(messageBox!=NULL){
					PostMessage(messageBox->hWnd, WM_ACTIVATE,WA_ACTIVE,NULL);
				}

				if(!gi->hasMenuBar)
					SHFullScreen(gi->m_hWnd,SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);
				gi->rcUpdateRegion=gi->rs;
				gi->rcUpdateRegion.top=0;
				addToRedraw(gi->rcUpdateRegion,true);
			}
			return 0L;

		case WM_SETFOCUS:

			gi->mustRender=true;
			gi->mustRedraw=true;
			ShowWindow(gi->m_hWnd, SW_SHOW);//test SW_MINIMIZED
			UpdateWindow(gi->m_hWnd);

			//InvalidateRect(gi->m_hWnd,NULL,true);
			return 0L;

		case WM_CANCELMODE:
		case WM_KILLFOCUS:
			/*
			if(isTopMost)
				PostQuitMessage(0);//if loose focus, close the app ;-)
				*/
			break;
		case WM_USER:
		case WM_COMMAND:
			Element::sendMsg(wParam,(void*)lParam);
			break;

		case WM_WINDOWPOSCHANGED:{
			DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
			DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);
			bool change=false;
			if(gi->isLandscape&&(dwWidth < dwHeight)){
				//change orientation!
				gi->isLandscape=!gi->isLandscape;
				change=true;
			}
			if(!gi->isLandscape&&(dwWidth > dwHeight)){
				//change orientation!
				gi->isLandscape=!gi->isLandscape;
				change=true;
			}
			if(change){
				//mouse->giveControlBack();
				gi->isActiv=false;

				GetClientRect(gi->m_hWnd, &gi->rs);
				if(g_hWndMenuBar!=0){
					GetWindowRect(g_hWndMenuBar, &hMenuArea);
					int heightTmp=hMenuArea.bottom-hMenuArea.top;
					gi->rs.bottom=gi->rs.bottom-heightTmp;
				}
/*
				gi->rs.top=dwHeight-gi->rs.bottom;
				gi->rs.bottom=dwHeight;*/
				gi->rcUpdateRegion=gi->rs;
				gi->rcVisibleDesktopTOP=gi->rs;


				//(*gi->ldDDraw)->RestoreAllSurfaces();
				EnterCriticalSection(&gi->criticPaint);
				Element::reloadAllSurface();
				LeaveCriticalSection(&gi->criticPaint);
				gi->rcUpdateRegion=gi->rs;
				gi->isActiv=true;
				Element* out=mouse->giveControlBack();
				gi->mustRedraw=true;
				/*
				if(out!=NULL&&out->getType()==TYPE_EDIT_CTRL){
				out->run();
				}
				*/

				if(messageBox!=NULL)
					messageBox->loadSurf();

				//send message to client :
				Element::sendMsg(WM_WINDOWPOSCHANGED,NULL);

				addToRedraw(gi->rcVisibleDesktopTOP,true);

				SHFullScreen(gi->m_hWnd,SHFS_HIDESIPBUTTON|SHFS_HIDETASKBAR);
			}
								 }
								 break;
/*
		case WM_KILLFOCUS:

			// We do not allow anyone else to have the keyboard focus until
			// we are done.
			if(gi->mustRender){
				gi->isActiv=false;
				//ShowWindow(gi->m_hWnd, SW_MINIMIZED);	//SW_HIDE);
				SetForegroundWindow((HWND)(((ULONG) GetForegroundWindow()) | 0x01));//To ensure that the last active owned window is reactivated
				return 0L;
			}
			break;
			*/
		case WM_QUIT:
		case WM_CLOSE:
		case WM_DESTROY:
			if(gi->cantBeClosed){
				PostMessage(gi->m_hWnd,WM_QUIT,(WPARAM)1,(LPARAM)NULL);//close the application!
				return 1;
			}else{
				break;
			}

/*
		case WM_KEYDOWN:
			// Handle any non-accelerated key commands
			this->mouse=this->mouse;
			switch (wParam)
			{
			}
			return 0;*/
			

		case WM_ERASEBKGND:{
			return 1;
						   }

		case MSG_USER_PAINT:
			doRepaintBuffered(0);
			break;
		case WM_PAINT:
			{
				HRGN update_rgn = CreateRectRgn( 0, 0, 0, 0 );
				int complexity=GetUpdateRgn(gi->m_hWnd,update_rgn,true);
				if(gi->isActiv&&messageBox==NULL&&
					complexity!=ERROR&&complexity!=NULLREGION){
					//Declare all variables
					DWORD dwSize;
					RECT *pRects;
					RGNDATA* pRgnData;

					//Get the size needed to obtain the region data, and allocate so needed memory
					dwSize = GetRegionData(update_rgn, 0, NULL);
					pRgnData = (RGNDATA*)malloc(dwSize);

					//Get the region data (mainly rects and more)
					GetRegionData(update_rgn, dwSize, pRgnData);
					pRects = (RECT*)malloc(pRgnData->rdh.nRgnSize);

					//Copy the rects into out buffer
					memcpy(pRects, pRgnData->Buffer, pRgnData->rdh.nRgnSize);

					bool redraw=true;
					int nbRect=pRgnData->rdh.nRgnSize/sizeof(RECT);
					for(int i=0;i<nbRect;i++){
						gi->rcUpdateRegion=pRects[i];
						gi->rcUpdateRegion.top+=gi->rcVisibleDesktopTOP.top;
						gi->rcUpdateRegion.bottom+=gi->rcVisibleDesktopTOP.top;
						gi->mustRedraw=true;
						if (MyEditControl::pEditCtrl!=NULL){
							if(gi->rcUpdateRegion.top>=gi->rcVisibleDesktopBOTTOM.top)
								redraw=false;
							else{
								if (gi->rcUpdateRegion.bottom>gi->rcVisibleDesktopBOTTOM.top)
									gi->rcUpdateRegion.bottom=gi->rcVisibleDesktopBOTTOM.top;
							}
						}
						if(redraw)
							UpdateFrame(true);
					}
					free(pRgnData);
					free(pRects);
				}
				DeleteObject(update_rgn);
			}
			PAINTSTRUCT ps;
			BeginPaint( gi->m_hWnd, &ps );
			EndPaint( gi->m_hWnd, &ps );
			return 1;

		case WM_TIMER:
			//update the positions :
			if (wParam==1)//(update scrolling ==1)
			{
				if(gi->mustRender)
					gi->window->UpdateFrame();
				else
					gi->window->updateElements();
				break;
			}
			if (wParam==2)//(update slider ==2)
			{
				MySlider::slideRunning->updatePosition();
				break;
			}
			if (wParam==3)//(Background anim)
			{
				gi->window->UpdateFrame(true);
				numRefreash++;
				break;
			}
			break;

		case WM_LBUTTONDOWN:{
			mouse->leftBtnDown(LOWORD(lParam),HIWORD(lParam));
			gi->mustRedraw=false;
			UpdateFrame();
			//SHRecognizeGesture to enable tap-and-hold function...
			SHRGINFO    shrg;
			//HMENU       hmenu;//if wanted...
			shrg.cbSize = sizeof(shrg);
			shrg.hwndClient = gi->m_hWnd;
			shrg.ptDown.x = LOWORD(lParam);
			shrg.ptDown.y = HIWORD(lParam);
			shrg.dwFlags = SHRG_RETURNCMD;
			if (SHRecognizeGesture(&shrg) == GN_CONTEXTMENU) {
				mouse->rightBtnDown(LOWORD(lParam),HIWORD(lParam));
			}
			break;
							}
		case WM_LBUTTONUP:{
			mouse->leftBtnUp(LOWORD(lParam),HIWORD(lParam));
			gi->mustRedraw=false;
			UpdateFrame();
			break;
						  }
		case WM_MOUSEMOVE:{
			mouse->leftBtnMove(LOWORD(lParam),HIWORD(lParam));
			gi->mustRedraw=false;
			UpdateFrame();
			break;
						  }

		case WM_KEYDOWN:{
			switch(wParam){
			case 0x1:
				UpdateFrame();
				break;
			}
			break;
						}

		case WM_SETTINGCHANGE:
			{//Software-based Input Panel changed...
				if(wParam==SETTINGCHANGE_RESET&&lParam==0){//screen has been rotated
					//gi->isActiv=true;
				}
				
			SIPINFO pSipInfo;
			memset(&pSipInfo, 0, sizeof(pSipInfo));
			pSipInfo.cbSize=sizeof(pSipInfo);
			if(!SipGetInfo(&pSipInfo)){
				LocalisedString::explainFail(L"Internal Failure...",L"SipGetInfo(&pSipInfo)");
			}
/*
			if((pSipInfo.fdwFlags&0x0001)==0){
				//gi->mustRender=true;//no input panel
			}else{
				//gi->mustRender=false;
			}
			*/
							  }

	}
#ifdef _DEBUG
	DWORD NbrElemEcrits=0;
	ostringstream msgString;
	SYSTEMTIME time;
	GetLocalTime(&time);
	msgString<<time.wMinute<<" "<<time.wSecond<<" -- ";
	msgString<<"WindowProc MSG : "<<hex<<message<<", wParam : "<<wParam<<dec<<endl;
	WriteFile(_hFichierDebug,(LPCVOID)msgString.str().c_str(),msgString.str().length(),&NbrElemEcrits,NULL);
#endif
	return DefWindowProc(gi->m_hWnd, message, wParam, lParam);
}

void DirectDrawWarp::changeControl(MessageBoxSense* mb){
	messageBox=mb;
}

void DirectDrawWarp::initWindow(){
	EnterCriticalSection(&gi->criticPaint);
	if(messageBox!=NULL){
		EnterCriticalSection(&gi->criticPaint);
		beginPaint();
		messageBox->updateFrame(gi->primaryBuffer);
		endPaint();
		LeaveCriticalSection(&gi->criticPaint);
		return;
	}
	isWindowInitialized=true;
	beginPaint();
	if(isTopMost){
		KillTimer(gi->m_hWnd,3);
		UCHAR red=0,green=0,blue=0;
		WORD* pixel;
		WORD* ScreenData = new WORD[gi->background->width*gi->background->height]; 
		HDC srcDC= gi->background->deviceInterface;

		BITMAPINFOHEADER bmi = {0}; 
		bmi.biSize = sizeof(BITMAPINFOHEADER); 
		bmi.biPlanes = 1; 
		bmi.biBitCount = 16;
		bmi.biWidth = gi->background->width; 
		bmi.biHeight = -gi->background->height; 
		bmi.biCompression = BI_RGB;

		BITMAPINFO bmInf;
		bmInf.bmiColors[0].rgbBlue=0;
		bmInf.bmiColors[0].rgbGreen=0;
		bmInf.bmiColors[0].rgbRed=0;
		bmInf.bmiColors[0].rgbReserved=0;
		bmInf.bmiHeader=bmi;

		HBITMAP hbmp = CreateDIBSection( srcDC,&bmInf,
			DIB_RGB_COLORS,(void**) &ScreenData, NULL,0 );

		HDC newDC = CreateCompatibleDC(srcDC);
		HGDIOBJ hObj=SelectObject( newDC, hbmp);

		if(0==BitBlt( newDC, 0, 0, gi->background->width,
			gi->background->height, srcDC, 0, 0, SRCCOPY ))
			LocalisedString::explainFailWinAPI(L"background creation");

		WORD * pPixelOffset = ScreenData;
		pixel=pPixelOffset;
		for(int j=0;j<gi->background->height;j++){
			for(int i=0;i<gi->background->width;i++){
				//red=((pixel[i]>>10)&0x001F);
				green=((pixel[i]>>5)&0x001F);
				blue=(pixel[i]&0x001F);
				//red=(red+blue+green)/4;
				red=(blue+green)/5;
				//pixel[i]=RGB555(red,green,blue);
				pixel[i]=RGB555(red,red,red);
			}
			pPixelOffset=(pPixelOffset+gi->background->width);
			pixel=pPixelOffset;
		}

		//copy to front buff :
		if(0==BitBlt( gi->background->deviceInterface, 0, 0, gi->background->width,
			gi->background->height, newDC, 0, 0, SRCCOPY))
			LocalisedString::explainFailWinAPI(L"background creation");

		delete[] ScreenData;

		SelectObject( newDC, hObj);
		DeleteDC( newDC );
		if(DeleteObject(hbmp)==0)
			LocalisedString::explainFailWinAPI(L"Delete BmpTMP");
		
		if(NB_FRAME_ANIM>1)
			SetTimer(gi->m_hWnd, 3, 200,NULL);
		else{
			numRefreash++;
			gi->window->BltFast(gi->backBuffer,NULL,gi->background,NULL,  DDBLT_WAITNOTBUSY, NULL);
			//gi->window->BltFast(gi->primaryBuffer,&gi->rs,gi->background,&gi->rs,  DDBLT_WAITNOTBUSY, NULL);
		}
	}else{
		gi->window->BltFast(gi->backBuffer,&gi->rs, gi->background,&gi->rs, DDBLT_WAITNOTBUSY|DDBLT_WAITVSYNC,NULL);
	}

	if(sectionActiv>=0||section.size()>0)
		section[sectionActiv]->paint(gi->backBuffer,0,0);

	gi->window->BltFast(gi->primaryBuffer,&gi->rcUpdateRegion, gi->backBuffer,&gi->rcUpdateRegion, DDBLT_WAITNOTBUSY|DDBLT_WAITVSYNC,NULL);
	endPaint();
	LeaveCriticalSection(&gi->criticPaint);
}

void DirectDrawWarp::doRepaintBuffered(int dy){
	if ((!gi->isActiv||sectionActiv<0||section.size()<=0)&&
		messageBox==NULL)
		return;

	EnterCriticalSection(&gi->criticAddBufPaint);
	int bufSize=bufferPaint.size();
	LeaveCriticalSection(&gi->criticAddBufPaint);
	int nbBufferTreated=0;
	if(bufSize>0){
		bool eraseBack;
		while(nbBufferTreated<bufSize){
			nbBufferTreated++;
			gi->rcUpdateRegion=bufferPaint[0];
			eraseBack=bufferPaintBack[0];
			gi->rcUpdateRegion.bottom=gi->rcUpdateRegion.bottom+dy;
			if(gi->rcUpdateRegion.bottom>GetSystemMetrics(SM_CYSCREEN))
				gi->rcUpdateRegion.bottom=GetSystemMetrics(SM_CYSCREEN);
			else{
				if(gi->rcUpdateRegion.bottom<gi->rs.top)
					gi->rcUpdateRegion.bottom=gi->rs.top;
			}
			gi->rcUpdateRegion.top=gi->rcUpdateRegion.top+dy;
			if(gi->rcUpdateRegion.top>gi->rcUpdateRegion.bottom)
				gi->rcUpdateRegion.top=gi->rcUpdateRegion.bottom;
			else{
				if(gi->rcUpdateRegion.top<gi->rcVisibleDesktopTOP.top)
					gi->rcUpdateRegion.top=gi->rcVisibleDesktopTOP.top;
			}
			if(gi->rcUpdateRegion.top<gi->rcUpdateRegion.bottom){
				gi->mustRedraw=true;
				UpdateFramePriv(eraseBack);
			}
			EnterCriticalSection(&gi->criticAddBufPaint);
			bufferPaint.erase(bufferPaint.begin(),bufferPaint.begin()+1);
			bufferPaintBack.erase(bufferPaintBack.begin(),bufferPaintBack.begin()+1);
			LeaveCriticalSection(&gi->criticAddBufPaint);
		}
	}
}
void DirectDrawWarp::UpdateFrame(bool eraseBack){
	if(!isWindowInitialized){
		//initWindow();
		return;
	}
	if(messageBox!=NULL){
		EnterCriticalSection(&gi->criticPaint);
		beginPaint();
		messageBox->updateFrame(gi->primaryBuffer);
		endPaint();
		LeaveCriticalSection(&gi->criticPaint);
		return;
	}
	if (!gi->isActiv||sectionActiv<0||section.size()<=0)
		return;

	int dy=UpdateFramePriv(eraseBack);

	doRepaintBuffered(dy);
}
int DirectDrawWarp::UpdateFramePriv(bool eraseBack){
	if(messageBox!=NULL){
		EnterCriticalSection(&gi->criticPaint);
		beginPaint();
		messageBox->updateFrame(gi->primaryBuffer);
		endPaint();
		LeaveCriticalSection(&gi->criticPaint);
		return 0;
	}
	int out=0;
	EnterCriticalSection(&gi->criticPaint);
	beginPaint();
	if(eraseBack){
		if(isTopMost){
			if(numRefreash<NB_FRAME_ANIM){
				KillTimer(gi->m_hWnd,3);
				HDC hdcDest,hdcSrc;
				hdcDest=gi->backBuffer->deviceInterface;
				hdcSrc=gi->background->deviceInterface;
				BLENDFUNCTION blendFunction;
				blendFunction.BlendOp=0;
				blendFunction.AlphaFormat=0;
				blendFunction.BlendFlags=0;
				blendFunction.SourceConstantAlpha=128.0;
				int width=gi->rs.right-gi->rs.left;
				int height=gi->rs.bottom-gi->rs.top;
				if(FALSE==AlphaBlend(hdcDest,gi->rs.left,gi->rs.top,width,height,
					hdcSrc,gi->rs.left,gi->rs.top,width,height,
					blendFunction
					)){
						LocalisedString::explainFailWinAPI(L"AlphaBlend Prob!");
				}
				gi->rcUpdateRegion=gi->rs;
				this->section[sectionActiv]->paint(gi->backBuffer,gi->rs.left,gi->rs.top);
				gi->window->BltFast(gi->primaryBuffer,&gi->rcUpdateRegion,gi->backBuffer,&gi->rcUpdateRegion,  DDBLT_WAITNOTBUSY, NULL);
				SetTimer(gi->m_hWnd, 3, 200,NULL);
			}else{
				if(numRefreash==NB_FRAME_ANIM){
					numRefreash++;
					KillTimer(gi->m_hWnd,3);
					gi->rcUpdateRegion=gi->rs;
					gi->window->BltFast(gi->backBuffer,&gi->rcUpdateRegion,gi->background,&gi->rcUpdateRegion,  DDBLT_WAITNOTBUSY, NULL);
					this->section[sectionActiv]->paint(gi->backBuffer,gi->rs.left,gi->rs.top);
					gi->window->BltFast(gi->primaryBuffer,&gi->rcUpdateRegion,gi->backBuffer,&gi->rcUpdateRegion,  DDBLT_WAITNOTBUSY, NULL);
				}else
					gi->window->BltFast(gi->backBuffer,&gi->rcUpdateRegion,gi->background,&gi->rcUpdateRegion,  DDBLT_WAITNOTBUSY, NULL);
			}
		}else{
			gi->window->BltFast(gi->backBuffer,&gi->rcUpdateRegion, gi->background,&gi->rcUpdateRegion, DDBLT_WAITNOTBUSY|DDBLT_WAITVSYNC,NULL);
		}
	}
	out=renderProc();
	endPaint();
	LeaveCriticalSection(&gi->criticPaint);
	return out;
};

int DirectDrawWarp::renderProc(){

	if(!gi->isActiv||sectionActiv<0)
		return 0;

	if(gi->mustRedraw){
		gi->window->BltFast(gi->backBuffer,&gi->rcUpdateRegion,gi->background,&gi->rcUpdateRegion,  DDBLT_WAITNOTBUSY, NULL);
		this->section[sectionActiv]->paint(gi->backBuffer,gi->rs.left,gi->rs.top);
		gi->window->BltFast(gi->primaryBuffer,&gi->rcUpdateRegion,gi->backBuffer,&gi->rcUpdateRegion,  DDBLT_WAITNOTBUSY, NULL);
		return 0;
	}

	int dy=this->mouse->updateElement();

	if(dy==0&&gi->mustRender)
		return 0;
	if(dy==0){
		mouse->stopScroll();
	}

	if(isTopMost||hasBackground){
		gi->rcUpdateRegion=gi->rs;
		gi->window->BltFast(gi->backBuffer,&gi->rcUpdateRegion,gi->background,&gi->rcUpdateRegion,  DDBLT_WAITNOTBUSY, NULL);
		this->section[sectionActiv]->paint(gi->backBuffer,gi->rs.left,gi->rs.top);
		gi->window->BltFast(gi->primaryBuffer,&gi->rcUpdateRegion,gi->backBuffer,&gi->rcUpdateRegion,  DDBLT_WAITNOTBUSY, NULL);
		return dy;
	}
	HRESULT hRet;
	RECT dest=gi->rs;
	RECT src=dest;

	//move background according to direction :
	if(dy!=0){
		gi->rcUpdateRegion=gi->rs;
		if(abs(dy)<gi->rs.bottom-gi->rs.top){
			//put on top new position of backbuffer :
			if(dy>0){
				dest.top+=dy;
				src.bottom-=dy;
				gi->rcUpdateRegion.top=gi->rs.top;
				gi->rcUpdateRegion.bottom=dest.top;
			}else{
				dest.bottom+=dy;
				src.top-=dy;
				gi->rcUpdateRegion.bottom=gi->rs.bottom;
				gi->rcUpdateRegion.top=dest.bottom;
			}
			if(dest.bottom-dest.top>0&&dest.right-dest.left>0)
			hRet = gi->window->BltFast(gi->primaryBuffer, &dest, gi->primaryBuffer, &src, DDBLT_WAITNOTBUSY, NULL );
			if (hRet != DD_OK){
				stringstream ss;
				ss<<"UpdateFrame "<<gi->rcUpdateRegion.bottom<<","<<gi->rcUpdateRegion.top;
				string s=ss.str();
				wstring msg(s.length(),L' ');
				std::copy(s.begin(), s.end(), msg.begin());
				LocalisedString::explainFailDirectDraw(hRet,msg);
			}
			hRet = gi->window->BltFast(gi->backBuffer,
				&gi->rcUpdateRegion, gi->background,&gi->rcUpdateRegion, DDBLT_WAITNOTBUSY,NULL);
	//		hRet = gi->window->BltFast(gi->primaryBuffer,&gi->rcUpdateRegion, NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);
			if (hRet != DD_OK)
				LocalisedString::explainFailDirectDraw(hRet,L"Erase bckground");
		}else{
			hRet = gi->window->BltFast(gi->backBuffer,
				&gi->rs, gi->background,&gi->rs, DDBLT_WAITNOTBUSY,NULL);
			if (hRet != DD_OK)
				LocalisedString::explainFailDirectDraw(hRet,L"Erase bckground");
		}
	}



	if(gi->mustRender){
		//update active section :
		this->section[sectionActiv]->paint(gi->backBuffer,gi->rs.left,gi->rs.top);

		gi->window->BltFast(gi->primaryBuffer,
			&gi->rcUpdateRegion, gi->backBuffer,&gi->rcUpdateRegion, DDBLT_WAITNOTBUSY,NULL);
	}
	return  dy;
};


void DirectDrawWarp::addToRedraw(RECT &rc,bool backErase){
	EnterCriticalSection(&gi->criticAddBufPaint);
	if(bufferPaint.size()<=1){
		bufferPaint.push_back(rc);
		bufferPaintBack.push_back(backErase);
		if(bufferPaint.size()==1)
			PostMessage(gi->m_hWnd,MSG_USER_PAINT,NULL,NULL);
	}else{
		//try to reduce the number of rect
		bool isInto=false;
		RECT tmp;
		int i=0,nbMax=bufferPaint.size();
		while (!isInto&&i<nbMax)
		{
			tmp=bufferPaint[i];
			isInto=tmp.top<=rc.top&&tmp.bottom>=rc.bottom&&tmp.left<=rc.left&&tmp.right>=rc.right;
			if (!isInto&&rc.top<=tmp.top&&rc.bottom>=tmp.bottom&&rc.left<=tmp.left&&rc.right>=tmp.right)
			{
				//rect is smaller than rc...
				bufferPaint.erase(bufferPaint.begin()+i,bufferPaint.begin()+i+1);
				bufferPaintBack.erase(bufferPaintBack.begin()+i,bufferPaintBack.begin()+i+1);
				nbMax--;
			}else
				i++;
		}
		if(!isInto){
			bufferPaint.push_back(rc);
			bufferPaintBack.push_back(backErase);
		}else{
			int i=0;
			i++;
		}
	}
	LeaveCriticalSection(&gi->criticAddBufPaint);
}

HRESULT DirectDrawWarp::BltFast(DIRECTDRAW_GDI* out,RECT *dest,DIRECTDRAW_GDI* srcSur, RECT *src,DWORD flag,LPDDBLTFX param){
#ifdef DRAWING_GDI
	if((out==gi->primaryBuffer||srcSur==gi->primaryBuffer)&&
		gi->primaryBuffer->deviceInterface==0)
		beginPaint();

	static bool destCreated,srcCreated;
	destCreated=false;
	srcCreated=false;
	if (dest==NULL){
		destCreated=true;
		dest=new RECT;
		dest->left=0;dest->top=0;dest->right=out->width;dest->bottom=out->height;
	}
	if(srcSur!=NULL&&src==NULL){
		srcCreated=true;
		src=new RECT;
		src->left=0;src->top=0;src->right=srcSur->width;src->bottom=srcSur->height;
	}
	if(DDBLT_COLORFILL&flag){
		HBRUSH b=CreateSolidBrush(param->dwFillColor);
		//HBRUSH b=(HBRUSH)(COLOR_MENUTEXT);

		if(FillRect(out->deviceInterface,dest,b)!=0){
			if (destCreated)
				delete dest;
			if (srcCreated)
				delete src;
			return S_OK;
		}else{
			LocalisedString::explainFailWinAPI(L"FillRect");
		}
	}else{
		if(srcSur!=NULL){
			bool paintAlpha=(param==NULL&&srcSur->bitmap!=NULL&&srcSur->nbBPP>=32);
			if(paintAlpha){//speed : StretchBlt
				BLENDFUNCTION blitAlpha;
				blitAlpha.BlendOp=AC_SRC_OVER;
				blitAlpha.BlendFlags=0;
				blitAlpha.AlphaFormat=AC_SRC_ALPHA;
				blitAlpha.SourceConstantAlpha=0xFF;
				if (AlphaBlend(out->deviceInterface, 
					dest->left,dest->top,dest->right-dest->left,dest->bottom-dest->top,
					srcSur->deviceInterface,  
					src->left,src->top,src->right-src->left,src->bottom-src->top,
					blitAlpha)!=0){
						//SRCCOPY)!=0){
						if (destCreated)
							delete dest;
						if (srcCreated)
							delete src;
						return S_OK;
				}else
					paintAlpha=false;
			}
			if(!paintAlpha)
			{//speed : StretchBlt
				if (StretchBlt(out->deviceInterface, 
					dest->left,dest->top,dest->right-dest->left,dest->bottom-dest->top,
					srcSur->deviceInterface,  
					src->left,src->top,src->right-src->left,src->bottom-src->top,
					SRCCOPY)!=0){
						if (destCreated)
							delete dest;
						if (srcCreated)
							delete src;
						return S_OK;
				}else
					LocalisedString::explainFailWinAPI(L"BltFast BitBlt");
			}
		}
	}

	if (destCreated)
		delete dest;
	if (srcCreated)
		delete src;

	return DDERR_INVALIDPARAMS;
#endif
#ifdef DRAWING_DDRAW
	if (srcSur==NULL)
	{
		return out->directDrawSurf->Blt(dest,NULL,NULL,flag,param);
	} 
	else
	{
		return out->directDrawSurf->Blt(dest,srcSur->directDrawSurf,src,flag,param);
	}
#endif
}
void DirectDrawWarp::BltMix(DIRECTDRAW_GDI* out,RECT *dest,DIRECTDRAW_GDI* srcSur, RECT *src,DWORD constantAlpha){
	if((out==gi->primaryBuffer||srcSur==gi->primaryBuffer)&&
		gi->primaryBuffer->deviceInterface==0)
		beginPaint();

	static bool destCreated,srcCreated;
	destCreated=false;
	srcCreated=false;
	if (dest==NULL){
		destCreated=true;
		dest=new RECT;
		dest->left=0;dest->top=0;dest->right=out->width;dest->bottom=out->height;
	}
	if(srcSur!=NULL&&src==NULL){
		srcCreated=true;
		src=new RECT;
		src->left=0;src->top=0;src->right=srcSur->width;src->bottom=srcSur->height;
	}
	BLENDFUNCTION blendFunction;
	blendFunction.BlendOp=0;
	blendFunction.AlphaFormat=0;
	blendFunction.BlendFlags=0;
	blendFunction.SourceConstantAlpha=constantAlpha;
	if(FALSE==AlphaBlend(out->deviceInterface,
		dest->left,dest->top,dest->right-dest->left,dest->bottom-dest->top,
		srcSur->deviceInterface,
		src->left,src->top,src->right-src->left,src->bottom-src->top,
		blendFunction)){
			LocalisedString::explainFailWinAPI(L"AlphaBlend Prob!");
	}
	if (destCreated)
		delete dest;
	if (srcCreated)
		delete src;
}

HRESULT DirectDrawWarp::BltMask(DIRECTDRAW_GDI* out,RECT *dest,DIRECTDRAW_GDI* srcSur,DIRECTDRAW_GDI* maskBlt, RECT *src){
	if(srcSur==NULL||maskBlt==NULL||maskBlt->bitmap==0)
		return DDERR_INVALIDPARAMS;

	if((out==gi->primaryBuffer||srcSur==gi->primaryBuffer)&&
		gi->primaryBuffer->deviceInterface==0)
		beginPaint();

	static bool destCreated,srcCreated;
	destCreated=false;
	srcCreated=false;
	if (dest==NULL){
		destCreated=true;
		dest=new RECT;
		dest->left=0;dest->top=0;dest->right=out->width;dest->bottom=out->height;
	}
	if(src==NULL){
		srcCreated=true;
		src=new RECT;
		src->left=0;src->top=0;src->right=srcSur->width;src->bottom=srcSur->height;
	}
	if(MaskBlt(out->deviceInterface, 
		dest->left,dest->top, dest->right-dest->left, dest->bottom-dest->top, 
		srcSur->deviceInterface, 
		src->left, src->top, 
		maskBlt->bitmap, 
		src->left, src->top, 
		MAKEROP4(0x00AA0029, SRCCOPY))==0){
			LocalisedString::explainFailWinAPI(L"MaskBlt");
	};
	return S_OK;
}

GDI_OVERLAY* DirectDrawWarp::createOverlay(DDSURFACEDESC* desc)
{

	GDI_OVERLAY* surf=new GDI_OVERLAY;
	HRESULT hr=(*(gi->ldDDraw))->CreateSurface(desc,
		&surf->directDrawSurf, NULL );
	if(hr!=S_OK){
		delete surf;
		return NULL;
	}
	return surf;
}

HRESULT DirectDrawWarp::createSurf(DDSURFACEDESC* desc,DIRECTDRAW_GDI* surf){
	if(surf==NULL)
		return DDERR_INVALIDPARAMS;

#ifdef DRAWING_GDI

	bool wasPainting=true;
	if(gi->primaryBuffer->deviceInterface==0){
		beginPaint();
		wasPainting=false;
	}

	surf->directDrawSurf=NULL;
	surf->deviceInterface=CreateCompatibleDC(NULL);
	if(surf->deviceInterface==0)
		LocalisedString::explainFailWinAPI(L"createSurf CreateCompatibleDC");

	//now our DC is OK, create HBITMAP:
	surf->width=desc->dwWidth;
	surf->height=desc->dwHeight;
	uchar bpp=desc->dwBackBufferCount;
	if(bpp==0||bpp==1)
		bpp=16;
	surf->bitmap = CreateBitmap(surf->width, surf->height,1,bpp,NULL);
	//surf->bitmap = CreateCompatibleBitmap(gi->primaryBuffer->deviceInterface,surf->width, surf->height);//,1,32,NULL);
	if(surf->bitmap==0)
		LocalisedString::explainFailWinAPI(L"CreateCompatibleBitmap");

	surf->oldObj=SelectObject(surf->deviceInterface, surf->bitmap);
	if(!wasPainting)
		endPaint();

	BITMAP bm;
	GetObject(surf->bitmap, sizeof(bm), &bm);
	surf->width=bm.bmWidth;
	surf->height=bm.bmHeight;
	surf->nbBPP=bm.bmBitsPixel;

	return S_OK;
#endif
#ifdef DRAWING_DDRAW
	HRESULT hr=(*gi->ldDDraw)->CreateSurface(&desc, &surf->directDrawSurf, NULL );
	if(hr!=S_OK)
		return hr;
	surf->deviceInterface=surf->directDrawSurf->GetDC(&surf->deviceInterface);
	return S_OK;
#endif
}

void DirectDrawWarp::deleteSurf(DIRECTDRAW_GDI** surf){
	if(surf==NULL||(*surf)==NULL)
		return;

	if((*surf)->directDrawSurf!=NULL){
		(*surf)->directDrawSurf->ReleaseDC((*surf)->deviceInterface);
		(*surf)->deviceInterface=NULL;
		(*surf)->directDrawSurf->Release();
	}
	if((*surf)->deviceInterface!=NULL){
		SelectObject((*surf)->deviceInterface, (*surf)->oldObj);
		if(DeleteObject ((*surf)->bitmap)==0)
			LocalisedString::explainFailWinAPI(L"DeleteObject");
		if(DeleteDC((*surf)->deviceInterface)==0)
			LocalisedString::explainFailWinAPI(L"DeleteDC");
	}
	delete (*surf);
	(*surf)=NULL;
}

void DirectDrawWarp::beginPaint(){
	if(gi->primaryBuffer->deviceInterface!=0)
		return;
#ifdef DRAWING_GDI
	//if(gi->primaryBuffer->directDrawSurf==NULL){
	if(true){
		gi->primaryBuffer->deviceInterface=GetDC(gi->m_hWnd);
		if(gi->primaryBuffer->deviceInterface==0)
			LocalisedString::explainFailWinAPI(L"beginPaint");
	}else{
		HRESULT hr=gi->primaryBuffer->directDrawSurf->GetDC(&gi->primaryBuffer->deviceInterface);
		if(hr!=S_OK)
			LocalisedString::explainFailDirectDraw(hr,L"beginPaint GetDC");
	}
#endif
#ifdef DRAWING_DDRAW
	HRESULT hr=gi->primaryBuffer->directDrawSurf->GetDC(&gi->primaryBuffer->deviceInterface);
	if(hr!=S_OK)
		LocalisedString::explainFailDirectDraw(hr,L"beginPaint");
#endif
}
void DirectDrawWarp::endPaint(){
	if(gi->primaryBuffer->deviceInterface==NULL)
		return;
#ifdef DRAWING_GDI
	//if(gi->primaryBuffer->directDrawSurf==NULL){
	if(true){
		if(ReleaseDC(gi->m_hWnd,gi->primaryBuffer->deviceInterface)==0)
			LocalisedString::explainFailWinAPI(L"endPaint");
	}else{
		HRESULT hr=gi->primaryBuffer->directDrawSurf->ReleaseDC(gi->primaryBuffer->deviceInterface);
		if(hr!=S_OK)
			LocalisedString::explainFailDirectDraw(hr,L"endPaint ReleaseDC");
	}
	gi->primaryBuffer->deviceInterface=0;
#endif
#ifdef DRAWING_DDRAW
	HRESULT hRes=gi->primaryBuffer->directDrawSurf->ReleaseDC(gi->primaryBuffer->deviceInterface);
	if(hRes!=S_OK)
		LocalisedString::explainFailDirectDraw(hRes,L"ReleaseDC Primary2");
#endif
}


void DirectDrawWarp::setBackgroundImg( LPCWSTR imgSrc,bool forLandscape) 
{
	wstring *tmp=NULL;
	if(imgSrc!=NULL){
		if(forLandscape){
			imgBkgFileLand=imgSrc;
			tmp=&imgBkgFileLand;
		}else{
			imgBkgFile=imgSrc;
			tmp=&imgBkgFile;
		}
		if(gi->isLandscape==forLandscape){
			DIRECTDRAW_GDI* img=Element::loadImage(tmp);
			if(img!=NULL){
				//paint to background:
				HRESULT hRet = gi->window->BltFast(gi->background, NULL, img, NULL,DDBLT_WAITNOTBUSY, NULL );
				if (hRet != DD_OK)
					LocalisedString::explainFailDirectDraw(hRet,L"setBackgroundImg Blt");
				gi->rcUpdateRegion=gi->rs;
				this->deleteSurf(&img);
				hasBackground=true;
				UpdateFrame(true);
			}
		}

	}else{
		if(gi->isLandscape&&!imgBkgFileLand.empty())
			tmp=&imgBkgFileLand;
		else
			if(!gi->isLandscape&&!imgBkgFile.empty())
				tmp=&imgBkgFile;
		if(tmp!=NULL){
			DIRECTDRAW_GDI* img=Element::loadImage(tmp);
			//paint to background:
			HRESULT hRet = gi->window->BltFast(gi->background, NULL, img, NULL,DDBLT_WAITNOTBUSY, NULL );
			if (hRet != DD_OK)
				LocalisedString::explainFailDirectDraw(hRet,L"setBackgroundImg Blt");
			gi->rcUpdateRegion=gi->rs;
			this->deleteSurf(&img);
			hasBackground=true;
			UpdateFrame(true);
		}
	}
}
void DirectDrawWarp::setBackgroundColor( COLORREF newColor) 
{
	background_color=newColor;
	DDBLTFX ddbltfx;
	memset(&ddbltfx, 0, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwFillColor = background_color;
	gi->window->BltFast(gi->backBuffer,NULL, NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);
	gi->window->BltFast(gi->background,NULL, NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);
	addToRedraw(gi->rs,true);
}

void DirectDrawWarp::setMenu( HMENU hMenu ){

	int top=gi->rs.top;
	if(g_hWndMenuBar!=NULL){
		DestroyWindow(g_hWndMenuBar);
		DestroyMenu(myHMenu);
		g_hWndMenuBar=NULL;
		myHMenu=NULL;
		GetClientRect(gi->m_hWnd, &gi->rs);
		gi->hasMenuBar=false;
		SHFullScreen(gi->m_hWnd,SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);
		GetClientRect(gi->m_hWnd, &gi->rs);
		gi->rs.top=top;
		addToRedraw(gi->rs,true);
	}
	myHMenu=hMenu;
	if(hMenu==NULL)
		return;
	
	SHMENUBARINFO mbi;
	ZeroMemory(&mbi, sizeof(SHMENUBARINFO));
	mbi.cbSize = sizeof(SHMENUBARINFO);
	mbi.hwndParent = gi->m_hWnd;
	mbi.nToolBarId = (UINT_PTR)hMenu;
	mbi.hInstRes = gi->m_hInstance;
	mbi.dwFlags= SHCMBF_HMENU;
	mbi.nBmpId = 0; 
	mbi.cBmpImages = 0; 

	if (!SHCreateMenuBar(&mbi)){
		g_hWndMenuBar = NULL;
		gi->hasMenuBar=false;
	}else{
		g_hWndMenuBar = mbi.hwndMB;
		gi->hasMenuBar=true;
	}

	GetWindowRect(g_hWndMenuBar, &hMenuArea);
	int heightTmp=hMenuArea.bottom-hMenuArea.top;
	gi->rs.bottom=gi->rs.bottom-heightTmp;
};

void DirectDrawWarp::changeMenu( UINT message,int idMenu, LPARAM info ){
	SendMessage(g_hWndMenuBar, message,idMenu, info);
}