﻿
/*! \mainpage SDK Manila Sense Win32 Documentation
 *
 * \section intro_sec Introduction
 *\htmlonly
 <p>I have created a win32 SDK that mimics HTC's Sense UI Look 'n Feel... More informations on my website: <a href="http://www.charlie-soft.com/Software/SDK_Sense.php?lang=an" target="_blank">charlie-soft.com</a><br /> 
 <br /> 
 This SDK is designed for <b>speed</b>: .NET applications are usually very slow to load and not fluid. I use some tricks to improve speed, like drawing only area having changes, scrolling without backbuffer or creating textures for text (GDI text drawing was slower…).<br /> 
 What’s in the box:<ul><li>PNG resources for VGA/WVGA. They can be easily modified. SDK <b>will resize automatically the resources</b> if your device has a smaller (or higher) resolution!</li> 
 <li><b>Design your app for VGA, the SDK will adjust the layout for other resolutions!</b></li> 
 <li>Full Finger Control.</li> 
 <li>Source files (.cpp and .h) of library.</li> 
 <li>Source files of example.</li> 
 </ul><br /> 
 Class:<ul><li>MyEditControl: Edit box with different width. Easy get and set text. SIP detection: scroll Edit area.</li> 
 <li>MyItem: Button (3 types), checkboxes and switch <b>(TripleState!)</b>. Event on click, visibility and state can be changed/get easily.</li> 
 <li>MyPanel : This element is not visible but is used to bring together elements. This element can have a title and dotted separator between each element.</li> 
 <li>ChildSection : Contains a subsection which is displayed with a sliding effect.</li> 
 <li>MyLabel: Print text with different font and color.</li> 
 <li>MyPictureBox: To print image (png, jpg, bmp, gif…)</li> 
 <li>MySelector: Like the HTML select. Scroll screen if list is out of screen (see video below).</li> 
 <li>Section: A section is a panel which can be scrolled up/down. It contains the different elements.</li> 
 <li>MessageBoxSense: Four type of messagebox: info, Ok/Cancel, <b>Abort/Retry</b> and Yes/No.</li> 
 <li>MySlider: A simple slider of any size... The min and max values can be changed easily, as the cursor position.</li> 
 </ul>Change log<br /> 
 V1.5.1<ul><li>Minor bug changes:<ul>
 <li> items out of screen no longer try to redraw</li>
 <li> text of items recompute their size when changing</li>
 <li> background color is correctly changed</li>
 </ul></li>
 </ul>V1.5<ul><li>The SDK is now multi thread safe!</li> 
 <li> Add the possibility to right clicks (long press)</li> 
 <li> Add the possibility to hook windows message (WM_ACTIVATE for example)</li> 
 <li> Add the possibility to have a bottom bar.</li> 
 <li> Add the possibility to have a background image (landscape and portrait).</li> 
 <li> If the app is allready started, close the new instance and show the previous one.</li> 
 <li> MySelector can be scrolled if the list is too long.</li> 
 <li> Text is now printed with alpha transparency.</li>
 <li> Compatible with any character (hebrew, vietnamese...).</li>
 <li> MyPictureBox can now be stretched.</li>
 <li> Memory usage reduced.</li> 
 </ul>V1.4<ul><li> Minor bugs fixed</li> 
 <li> Add the possibility to show MessageBox without a main application.</li> 
 </ul>V1.3<ul><li> <b>Background can be transparent !</b> (see <a href="http://forum.xda-developers.com/showthread.php?t=742008" target="_blank">this app</a> for demo)</li> 
 <li> <b>Native drawing</b> (DirectDraw was too slow in landscape)</li> 
 <li> Slider can have a force feedback (see <a href="http://forum.xda-developers.com/showthread.php?t=742008" target="_blank">this app</a> for demo)</li> 
 </ul>V1.2<ul><li> <b>MySlider </b>added</li> 
 <li> drawing process rewrited: less redraw-&gt;less computation-&gt;less CPU utilization <b>-&gt; battery consumption reduced</b></li> 
 <li>Loading optimisation</li> 
 <li>The layout is now <b>independent</b> of screen resolution!</li> 
 <li>top taskbar is occassionally cleared <b>[fixed]</b></li> 
 <li>White screen, touching the panel brings it back <b>[fixed]</b></li> 
 <li>landscape items position incorrect <b>[fixed]</b></li> 
 </ul>V1.1<ul><li> <b>landscape compatible</b></li> 
 <li> <b>Abort/Retry</b> added to MessageBoxSense</li> 
 <li> <b>TripleState Checkboxes and OnOffItems</b> added</li> 
 </ul><object width="425" height="350"><param name="movie" value="http://www.youtube.com/v/6O3AyiZ9tIM"></param><embed src="http://www.youtube.com/v/6O3AyiZ9tIM" type="application/x-shockwave-flash" width="425" height="350"></embed></object><br /> 
 FAQ<ul><li>is QVGA resolution supported?<br /> 
 Yes, SDK will find the correct resolution and select the appropriate resource resolution. The SDK will delete the other resources...</li> 
 <li>have you planned to extend MessageBox types to Abort/Retry?<br /> 
 Yes, to create one:<br /> 
 MessageBoxSense::show(L&quot;Hello&quot;,L&quot;Try again ?&quot;, MESSAGE_ABORTRETRY);</li> 
 <li>is this landscape compatible?<br /> 
 Yes but having refresh rate issue. Seems to be a DirectDraw problem (S2U2 was subject to the same issue...)<br /> 
 If someone know how to solve this problem, send me a message !</li> 
 <li>Back button too slow.<br /> 
 You can change the speed anim using this function: changeSpeed(double nbMilisecond)</li> 
 <li>why aren't you including some TripleState Checkboxes and OnOffItems ?<br /> 
 Both are now included:<br /> 
 new MyItem(1,5,15,ITEM_IS_CHECKBOX,<b>ITEM_THIRD_STATE</b>,L&quot;My third checkbox (Third state)&quot;);</li> 
 </ul><br /> 
 <br /> 
 Other apps<br /> 
 <a href="http://forum.xda-developers.com/showthread.php?p=7298752" target="_blank">Wake on Wan</a> is a new app which use this SDK. <a href="http://forum.xda-developers.com/attachment.php?attachmentid=364913&amp;d=1279816130" target="_blank">Sources are available</a>!<br /> 
 <a href="http://forum.xda-developers.com/showthread.php?t=742008" target="_blank">Quick shutdown</a> is a software which use this SDK too.  It can turn off, restart or set the phone in sleep mode. <a href="http://forum.xda-developers.com/attachment.php?attachmentid=371209&amp;d=1280703422&quot;" target="_blank">Sources are also available</a>!</p>
 \endhtmlonly
 \section install_sec How create a new App ?
 \subsection step1 Set up environment
 * <br /> 
 * It is of course necessary to have the Windows Mobile SDK installed. You can download it using this link: <a href="http://www.microsoft.com/downloads/details.aspx?FamilyID=06111a3a-a651-4745-88ef-3d48091a390b" target="_blank">SDK WM6.0</a>. Then you can install the <a href="http://www.microsoft.com/downloads/details.aspx?familyid=20686A1D-97A8-4F80-BC6A-AE010E085A6E" target="_blank">WM6.5 TDK</a> (this is not a requirement) or the <a href="http://www.microsoft.com/downloads/details.aspx?familyid=C0213F68-2E01-4E5C-A8B2-35E081DCF1CA" target="_blank">WM6.5.3 TDK</a>.<br /> 
 * Finally, you have to add the library to the project: put the .lib and .h in a directory (usually the project directory) and configures Visual Studio to use the .lib (project/properties/linker/input/Additional Dependencies).<br /> 
 * <br /> 
 * \subsection step2 Project creation
 * <br /> 
 * Create a new empty smartdevice project. In order to use the library, you have to put images into a directory named <b>&quot;resources&quot;</b> in the application directory and deploy it to the device. If it's not done, you will have this type of error at the start of your application: <b>&quot;Resource not available!&quot;</b><br /> 
 * Then create a new source file (.cpp) and create the WinMain function.<br /> 
 * Add include to <b>&quot;SDK_Manila_Sense.h&quot;</b>.<br /> 
 * <br /> 
 * \subsection step3 Application development
 * <br /> 
 * First, you have to create a class that inherits from <b>&quot;EventHandler&quot;</b>. You have to implement the two followings methods: <br /> 
 * void messageTreatment(Element* src,UINT msg);<br /> 
 * void initApplication();<br /> 
 * <br /> 
 * Your constructor should have a HINSTANCE parameter.<br /> 
 * <br /> 
 * So, you will have something like that:
 * \code class MyApp:
 * public EventHandler
 * {
 * protected:
 * //function to init application (add item to our window, init var, etc.)
 * void initApplication();
 * public:
 * MyApp(HINSTANCE hInstance);
 * ~MyApp(void);
 * //function which is called when events appends
 * void messageTreatment(Element* src,UINT msg);
 * };
 * \endcode
 * void initApplication();<br /> 
 * This method should be used to init application (add item to our window -GlobalInformations::window-, init var, etc.)<br /> 
 * <br /> 
 * void messageTreatment(Element* src,UINT msg)<br /> 
 * This method is called when event appends (clicks or value change). The parameter src is a pointer on the active Element and msg is equal to either EVENT_CLICK or EVENT_VALUE_CHANGED...<br /> 
 * <br /> 
 * \subsection step4 Back to WinMain
 * <br /> 
 * Once your class implemented, you just have to start your application:
 * \code int WINAPI WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPWSTR lpCmdLine,int nCmdShow)
 * {
 * MyApp example(hInstance);//if MyApp is your class name...
 * example.runApp();
 * return 0;
 * }
 * \endcode
 * \subsection step5 Application deployment
 * You have to put the resources in the same directory as your application and follow this tree:<br /> 
 * yourApp<br /> 
 * -resources<br /> 
 * --VGA<br /> 
 * ---all PNG images needed by the SDK (if you don't use slider for example, the btn_common_slider.png is not needed)
 *
 */

