#include "../../Library/SDK_Manila_Sense.h"


EventHandler::EventHandler(HINSTANCE hInstance,wstring windowName,bool topmost,HMENU menu)
{
	//new GlobalInformations(windowName);//only global variables (for compatibility to old version)
	if(!GlobalInformations::alreadyInitialized())
		GlobalInformations::setName(windowName);

	HWND myAppHwnd = FindWindow(windowName.c_str(), NULL);
	if(myAppHwnd!=NULL){
		//show window:
		SetForegroundWindow((HWND)(((ULONG) myAppHwnd) | 0x01));//To ensure that our window is reactivated
		ShowWindow(myAppHwnd, SW_SHOW);
		UpdateWindow(myAppHwnd);
		SetFocus(myAppHwnd);

		//close this instance:
		exit(0);
	}

	this->gInstance=hInstance;
	new DirectDrawWarp(this->gInstance,windowName.c_str(),topmost,menu);//@ is stored in gi->window
	Element::setGestEvent(this);//we are the elements management

	//start message thread:
	//hThread=CreateThread(NULL,NULL, EventHandler::launchApp,NULL,NULL,&idThread);
}
DWORD WINAPI EventHandler::launchApp( LPVOID lpParameter ){
	return 0;
};


EventHandler::~EventHandler(void)
{
	//TerminateThread(hThread,0);//close the thread
	GlobalInformations* gi=GlobalInformations::getInstance();
	delete gi->window;
}

void EventHandler::messageProc(void* src,WPARAM type){
	PostThreadMessage(NULL,WM_USER,type,(LPARAM)src);//post the message to the thread
}



void EventHandler::msgExecute(MSG msg){
	GlobalInformations* gi=GlobalInformations::getInstance();
	switch(msg.message)
	{
	case WM_QUIT:
		return;
	case WM_USER:
		{
			switch (msg.wParam)
			{
			case 0:
				{
					gi->isActiv=false;
					Element::getGestEvent()->initApplication();
					gi->rcUpdateRegion=gi->rs;
					gi->rcUpdateRegion.top=gi->rcVisibleDesktopTOP.top;
					gi->rcUpdateRegion.bottom=GetSystemMetrics(SM_CYSCREEN);
					gi->mustRedraw=true;
					gi->window->initWindow();
					gi->isActiv=true;
				}
				break;
			case EVENT_CLICK:
			case EVENT_VALUE_CHANGED:
			case EVENT_RIGHT_CLICK:
				Element::getGestEvent()->messageTreatment((Element*)msg.lParam,msg.wParam);
				break;
			case MESSAGE_REP:
				SetEvent(gi->waitForMSG);//restart MsgBox function...
				break;
			default:
				Element::getGestEvent()->messageTreatment(NULL,msg.wParam,(void*)msg.lParam);
			}
		}
		break;
	default:
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
}
void EventHandler::runApp(){

	GlobalInformations* gi=GlobalInformations::getInstance();
	MSG msg;

	bool retour;
	while( 1 )
	{
		if(GetMessage( &msg, NULL, 0, 0)==-1){
			LocalisedString::explainFail( L"Main function fail...",L"GetMessage");
			break;
		}
		if (msg.message == WM_QUIT||msg.message==WM_CLOSE)
		{
			if(gi->cantBeClosed)
				PostMessage(gi->m_hWnd,WM_ACTIVATE,(WPARAM)WA_INACTIVE,(LPARAM)NULL);
			else
				break;
		}else{
			if(msg.hwnd==NULL)//thread msg...
			{
				msgExecute(msg);
			}else{
				if(MyEditControl::input==msg.hwnd)//thread msg...
				{//it's input text ! Activate the copy/past...
					if(msg.message==WM_EXITMENULOOP){
						if (MyEditControl::pEditCtrl!=NULL)
							MyEditControl::pEditCtrl->showSIP();
					}
				}
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
	}
	DestroyWindow(gi->m_hWnd);

	int i=0;
	i++;
}

void EventHandler::showWindow(bool isVisible){
	GlobalInformations* gi=GlobalInformations::getInstance();
	if(isVisible){
		SetForegroundWindow((HWND)(((ULONG) gi->m_hWnd) | 0x01));//To ensure that our window is reactivated
		ShowWindow(gi->m_hWnd, SW_SHOW);
		UpdateWindow(gi->m_hWnd);
		SetFocus(gi->m_hWnd);
	}else{
		ShowWindow(gi->m_hWnd, SW_HIDE);
	}
}