#include "../../Library/SDK_Manila_Sense.h"

GlobalInformations* GlobalInformations::resources=NULL;

GlobalInformations* GlobalInformations::getInstance(){
	if (GlobalInformations::resources==NULL)
		MessageBox(NULL,L"Where is Directory?",L"appName is empty!\r\nPlease set the name of your application before doing anything !",MB_ICONERROR|MB_OK);
	return GlobalInformations::resources;
}

void GlobalInformations::setName(wstring newName)
{
	if (GlobalInformations::resources==NULL){
		new GlobalInformations(newName);
	}
	if(GlobalInformations::resources->appName.compare(newName)!=0){
		GlobalInformations::resources->appName=newName;
		//reload the resources :
		loadResources(GlobalInformations::resources,findUserDirectory(GlobalInformations::resources));
	}
}

wstring GlobalInformations::findUserDirectory(GlobalInformations* gi){
/*
	//was used to find the current directory (to use our files...)
	WCHAR* wszTemp = NULL;
	WCHAR  wszDirectory[MAX_PATH] = L"\0";

	GetModuleFileNameW(NULL,wszDirectory,MAX_PATH);
	wszTemp = wcsrchr(wszDirectory,L'\\'); // Finds last occurrence and replace it with \.
	//add images :
	WCHAR directoryImg[13]=L"resources\\\0";
	wcscpy(wszTemp+1,directoryImg);
	//*(wszTemp+1) = L'\0';

	wstring myDirectory=userDirectory;
	wstring myDirectoryVGA=L"VGA\\";
	myDirectory=myDirectory+myDirectoryVGA;
	*/
	wstring regKey=L"SOFTWARE\\Manila_";
	regKey=regKey+gi->appName;

	HKEY myKey;
	DWORD disposition;
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, regKey.c_str(), 0, 0, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, 0, &myKey, &disposition);

	wstring myDirectory;

	WCHAR myDir[MAX_PATH];
	DWORD sizeValue=MAX_PATH*sizeof(WCHAR);
	if(RegQueryValueEx(myKey,L"SourcesDirectory", 0, 0, (LPBYTE)myDir, &sizeValue)==ERROR_SUCCESS){
		myDirectory=myDir;
	}else{
		WCHAR  wszDirectory[MAX_PATH] = L"\0";//set the directory of app...

		GetModuleFileNameW(NULL,wszDirectory,MAX_PATH);
		WCHAR* lastChar = wcsrchr(wszDirectory,L'\\'); // Finds last occurrence.
		//add images :
		wcscpy(lastChar+1,L"\0");
		wstring dir=wszDirectory;
		WCHAR directoryImg[17]=L"resources\\VGA\\\0";
		wcscpy(lastChar+1,directoryImg);
		if((long)GetFileAttributes(wszDirectory)<0){//prob with installation !
			return L"\\Windows\\";
		}else{
			RegSetValueEx(myKey, L"SourcesDirectory", 0, REG_SZ, (const BYTE*)wszDirectory, wcslen(wszDirectory)*sizeof(WCHAR));
			myDirectory=wszDirectory;
		}
	}

	int deb=myDirectory.find(L"resources");
	if(deb!=wstring::npos)
		gi->userDirectory=myDirectory.substr(0,deb);//get a wstring for easier use...
	else
		gi->userDirectory=myDirectory;//get a wstring for easier use...

	RegCloseKey(myKey);

	return myDirectory;
}

GlobalInformations::GlobalInformations(wstring name)
{
	GlobalInformations::resources=this;
	//////////////////////////////////////////////////////////////////////////
	appName=name;
	hasMenuBar=false;
	window=NULL;
	m_hInstance=NULL;
	m_hWnd=NULL;
	ldDDraw=NULL;
	primaryBuffer=NULL;
	backBuffer=NULL;
	background=NULL;
	mustRender=true;
	mustRedraw=true;
	isActiv=false;
	hFontTitle=NULL;
	percentOfVGA=0;
	cantBeClosed=false;
	waitForMSG=CreateEvent(NULL,true,true,NULL);

	bg_common_dotline = NULL;
	bg_common_titlebar = NULL;
	bg_common_divider_section = NULL;
	btn_common_msgbox_large = NULL;
	btn_common_msgbox_small = NULL;
	btn_common_normal = NULL;
	btn_common_switch = NULL;
	btn_common_checkbox = NULL;
	btn_switch_thirdState = NULL;
	btn_checkbox_thirdState = NULL;
	btn_common_input = NULL;
	btn_common_listitem = NULL;
	pivot_leftarrow = NULL;
	pivot_rightarrow = NULL;
	btn_common_combo_down = NULL;
	btn_common_listitem_bottom = NULL;
	btn_common_listitem_middle = NULL;
	bg_msg_box = NULL;
	bg_dark = NULL;
	btn_common_slider = NULL;
	btn_slider = NULL;

	lastTick1=0;
	lastTick2=0;
	lenght1=0;
	lenght2=0;

	//////////////////////////////////////////////////////////////////////////
	SHInitExtraControls();//for SIP (copy/past/cut standard...)
	InitializeCriticalSection(&criticPaint);
	InitializeCriticalSection(&criticAddBufPaint);

	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);
	DWORD realWidth=dwWidth;
	if(dwWidth>dwHeight){
		realWidth=dwHeight;
	}
	if(dwWidth<480){
		percentOfVGA=realWidth/480.0;
	}else{
		percentOfVGA=1.0;
	}

	isLandscape=(dwWidth > dwHeight);
	cantBeClosed=false;

	wstring myDirectory=findUserDirectory(this);

	wstring regKey=L"SOFTWARE\\Manila_";
	regKey=regKey+appName;

	HKEY myKey;
	DWORD disposition;
	RegCreateKeyEx(HKEY_LOCAL_MACHINE, regKey.c_str(), 0, 0, REG_OPTION_NON_VOLATILE,
		KEY_ALL_ACCESS, 0, &myKey, &disposition);

	DWORD sizeValue=sizeof(DWORD);
	double manilaVersion=MANILA_SDK_VERSION;
	bool okVersion=RegQueryValueEx(myKey,L"manilaVersion", 0, 0, (LPBYTE)&manilaVersion, &sizeValue)==ERROR_SUCCESS;
	okVersion=okVersion&&manilaVersion==MANILA_SDK_VERSION;
	if(!okVersion){
		/*
		if((long)GetFileAttributes(myDirectory.c_str())<0){//prob with installation !
			wstring msg=L"Could not find resources for your application...\r\nCheck this directory:\r\n";
			MessageBox(NULL,(msg+myDirectory).c_str(),(LPCWSTR)L"Resource not available!",MB_OK|MB_ICONERROR);
			exit(0);//force to quit !
		}
		//MessageBox(NULL,L"Welcome!\nOptimisation in progress...\r\nA reboot is recommended to take advantage of new fonts!",L"First use...",MB_OK|MB_ICONINFORMATION);
		//Delete dir :
		SHFILEOPSTRUCT dirToRemove;
		memset(&dirToRemove, 0, sizeof(dirToRemove));
		dirToRemove.wFunc=FO_DELETE;
		dirToRemove.pFrom=wszDirectory;
		dirToRemove.fFlags=FOF_NOCONFIRMATION|FOF_SILENT;
		
		SHFileOperation(&dirToRemove);*/

		wstring tmp=L"HelveticaNeue LT 35 Thin.ttf";
		CopyFile((myDirectory+tmp).c_str(),L"\\windows\\HelveticaNeue LT 35 Thin.ttf",true);
		tmp=L"Tahoma.ttf";
		CopyFile((myDirectory+tmp).c_str(),L"\\windows\\Tahoma.ttf",false);

		manilaVersion=MANILA_SDK_VERSION;
		RegSetValueEx(myKey, L"manilaVersion", 0, REG_DWORD, (LPBYTE)&manilaVersion, sizeValue);//set the new info
	}
	RegCloseKey(myKey);
	bool rescall=false;
	if(percentOfVGA!=1){
		wstring fileName=L"AlreadyScalled.txt";
		wstring fileTest=myDirectory+fileName;
		if((long)GetFileAttributes(fileTest.c_str())<0){
			//first start
			HANDLE hFichier = NULL; //HANDLE vers le fichier

			hFichier = CreateFile(fileTest.c_str(),GENERIC_WRITE,0,NULL,CREATE_ALWAYS,0,NULL);
			if(hFichier != INVALID_HANDLE_VALUE)
			{
				string valid="Your resources are already scalled!";
				DWORD NbrElemEcrits=0;
				//Ecriture d'un texte
				WriteFile(hFichier,(LPCVOID)valid.c_str(),valid.length(),&NbrElemEcrits,NULL);
				//Fermeture du fichier
				CloseHandle(hFichier);
				rescall=true;
			}
		}
	}

	loadResources(this,myDirectory);

	if(rescall){//resize the resources :
		Element::resizeIImage(bg_common_titlebar);
		Element::resizeIImage(bg_common_divider_section);
		Element::resizeIImage(btn_common_msgbox_large);
		Element::resizeIImage(btn_common_msgbox_small);
		Element::resizeIImage(btn_common_normal);
		Element::resizeIImage(btn_slider);
		Element::resizeIImage(btn_common_slider);
		Element::resizeIImage(btn_checkbox_thirdState);
		Element::resizeIImage(btn_switch_thirdState);
		Element::resizeIImage(bg_dark);
		Element::resizeIImage(bg_msg_box);
		Element::resizeIImage(bg_common_dotline);
		Element::resizeIImage(btn_common_listitem_middle);
		Element::resizeIImage(btn_common_listitem_bottom);
		Element::resizeIImage(btn_common_combo_down);
		Element::resizeIImage(pivot_rightarrow);
		Element::resizeIImage(pivot_leftarrow);
		Element::resizeIImage(btn_common_listitem);
		Element::resizeIImage(btn_common_switch);
		Element::resizeIImage(btn_common_checkbox);
		Element::resizeIImage(btn_common_input);
	}
	//wstring myDirectory=L"\\windows\\";//set to windows directory

};
void GlobalInformations::releaseLoadedVar(){
	delete bg_common_titlebar;
	delete bg_common_divider_section;
	delete btn_common_msgbox_large;
	delete btn_common_msgbox_small;
	delete btn_common_normal;
	delete btn_common_switch;
	delete btn_common_checkbox;
	delete btn_common_input;
	delete btn_common_listitem;
	delete pivot_leftarrow;
	delete pivot_rightarrow;
	delete btn_common_combo_down;
	delete btn_common_listitem_bottom;
	delete btn_common_listitem_middle;
	delete bg_common_dotline;
	delete bg_msg_box;
	delete bg_dark;
	delete btn_switch_thirdState;
	delete btn_checkbox_thirdState;
	delete btn_common_slider;
	delete btn_slider;

	CloseHandle(GlobalInformations::waitForMSG);
	GlobalInformations::window=NULL;
	GlobalInformations::m_hInstance=NULL;
	GlobalInformations::m_hWnd=NULL;
	//GlobalInformations::ldDDraw=NULL;
	GlobalInformations::mustRender=false;
	GlobalInformations::mustRedraw=false;
	GlobalInformations::isActiv=false;
	CloseHandle(GlobalInformations::hFontTitle);
	GlobalInformations::hFontTitle=NULL;
	GlobalInformations::percentOfVGA=0;
	GlobalInformations::isLandscape=false;
	DeleteCriticalSection(&criticPaint);
	DeleteCriticalSection(&criticAddBufPaint);
};

void GlobalInformations::loadResources(GlobalInformations* gi,wstring myDirectory){
	wstring tmp;

	tmp=L"bg_common_titlebar.png";
	gi->bg_common_titlebar=new wstring(myDirectory+tmp);

	tmp=L"bg_common_divider_section.png";
	gi->bg_common_divider_section=new wstring(myDirectory+tmp);

	tmp=L"btn_common_msgbox_large.png";
	gi->btn_common_msgbox_large=new wstring(myDirectory+tmp);

	tmp=L"btn_common_msgbox_small.png";
	gi->btn_common_msgbox_small=new wstring(myDirectory+tmp);

	tmp=L"btn_common_normal.png";
	gi->btn_common_normal=new wstring(myDirectory+tmp);

	tmp=L"btn_common_switch.png";
	gi->btn_common_switch=new wstring(myDirectory+tmp);

	tmp=L"btn_common_checkbox.png";
	gi->btn_common_checkbox=new wstring(myDirectory+tmp);

	tmp=L"btn_common_input.png";
	gi->btn_common_input=new wstring(myDirectory+tmp);

	tmp=L"btn_common_listitem.png";
	gi->btn_common_listitem=new wstring(myDirectory+tmp);

	tmp=L"pivot_leftarrow.png";
	gi->pivot_leftarrow=new wstring(myDirectory+tmp);

	tmp=L"pivot_rightarrow.png";
	gi->pivot_rightarrow=new wstring(myDirectory+tmp);

	tmp=L"btn_common_combo_down.png";
	gi->btn_common_combo_down=new wstring(myDirectory+tmp);

	tmp=L"btn_common_listitem_bottom.png";
	gi->btn_common_listitem_bottom=new wstring(myDirectory+tmp);

	tmp=L"btn_common_listitem_middle.png";
	gi->btn_common_listitem_middle=new wstring(myDirectory+tmp);

	tmp=L"bg_common_dotline.png";
	gi->bg_common_dotline=new wstring(myDirectory+tmp);

	tmp=L"bg_common_msgbox.png";
	gi->bg_msg_box=new wstring(myDirectory+tmp);

	tmp=L"background.png";
	gi->bg_dark=new wstring(myDirectory+tmp);

	tmp=L"btn_switch_thirdState.png";
	gi->btn_switch_thirdState=new wstring(myDirectory+tmp);

	tmp=L"btn_checkbox_thirdState.png";
	gi->btn_checkbox_thirdState=new wstring(myDirectory+tmp);

	tmp=L"btn_common_slider.png";
	gi->btn_common_slider=new wstring(myDirectory+tmp);

	tmp=L"sliderBtn.png";
	gi->btn_slider=new wstring(myDirectory+tmp);
}

GlobalInformations::~GlobalInformations(void)
{
	releaseLoadedVar();
}
