#include "../../Library/SDK_Manila_Sense.h"


TCHAR* LocalisedString::windowCreationError=L"Can't create Windows";
TCHAR* LocalisedString::SizeImageError=L"Image size error!\r\nPlease contact : thibault.lelore@gmail.com";
TCHAR* LocalisedString::LoadImageError=L"Image not found!\r\nPlease contact : thibault.lelore@gmail.com";
TCHAR* LocalisedString::AddElemError=L"You try to add an element to another element witch can not contain other component !";
TCHAR* LocalisedString::ResourceError=L"Can't find the resource !\r\nPlease contact : thibault.lelore@gmail.com";

TCHAR *LocalisedString::szDDrawError = TEXT("DirectDraw Error");
TCHAR *LocalisedString::szDDrawFailedMsg = TEXT("DirectDrawCreate failed.");
TCHAR *LocalisedString::szSetCooperativeFailMsg = TEXT("SetCooperativeLevel failed.");
TCHAR *LocalisedString::szNoOverlaysMsg = TEXT("Overlays are not supported in hardware!");
TCHAR *LocalisedString::szCreateOverlayFailMsg = TEXT("Unable to create overlay surface!");
TCHAR *LocalisedString::szLoadOverlayFailMsg = TEXT("Unable to load images to overlay surface!");
TCHAR *LocalisedString::szShowOverlayFailMsg = TEXT("Unable to show overlay surface!");
TCHAR *LocalisedString::szNoFlipSurfacesMsg =TEXT("Display driver doesn't support flipping surfaces.");
TCHAR *LocalisedString::szEnumAttachedSurfacesFailMsg = TEXT("EnumAttachedSurfaces failed.");
TCHAR *LocalisedString::szCreateSurfaceFailMsg = TEXT("CreateSurface failed.");
TCHAR *LocalisedString::szSetTimerFailMsg = TEXT("SetTimer failed.");
TCHAR *LocalisedString::szGetCapsFailMsg = TEXT("GetCaps FAILED");
TCHAR *LocalisedString::szNoBackBufferMsg = TEXT("Display driver doesn't support a back buffer.");
TCHAR *LocalisedString::szSurfaceLost = TEXT("Display surface lost.\n\r Need to be restored (available in future release)");
TCHAR *LocalisedString::szGetDC = TEXT("Display can't obtain a Device Context.");
TCHAR *LocalisedString::szCreateInputText = TEXT("Can't create an input text.");
TCHAR *LocalisedString::szShowKbrd = TEXT("Can't show the Software-based Input Panel.");
TCHAR *LocalisedString::szCreateMyItem=TEXT("Can't create this Item.");

void LocalisedString::explainFail(LPCTSTR error,LPCTSTR title,int quit)
{
	GlobalInformations* gi=GlobalInformations::getInstance();
	static int nbError=0;
	gi->isActiv=false;
	nbError++;
	if(nbError>3){
		PostMessage(gi->m_hWnd,WM_QUIT,(WPARAM)1,(LPARAM)NULL);
		exit(1);
		return;
	}
	gi->window->endPaint();
 	MessageBox(gi->m_hWnd, error, title, MB_OK | MB_ICONEXCLAMATION);
	if(quit!=0){
		PostMessage(gi->m_hWnd,WM_QUIT,(WPARAM)1,(LPARAM)NULL);
		exit(1);
		return;
	}
	gi->isActiv=true;
}

//print debug information when CreateSurface fail :
void LocalisedString::explainFailDirectDraw(int hRet,wstring info){
#ifndef _DEBUG
	return;
#endif

	switch(hRet){
		case DDERR_GENERIC:
			return;//can't do anithing, so try to continue ;-)
			break;
		case DDERR_INCOMPATIBLEPRIMARY:
			LocalisedString::explainFail( info.c_str(),L"DDERR_INCOMPATIBLEPRIMARY");
			break;
		case DDERR_INVALIDCAPS:
			LocalisedString::explainFail( info.c_str(),L"DDERR_INVALIDCAPS");
			break;
		case DDERR_INVALIDOBJECT:
			LocalisedString::explainFail( info.c_str(),L"DDERR_INVALIDOBJECT");
			break;
		case DDERR_INVALIDPARAMS:
			LocalisedString::explainFail( info.c_str(),L"DDERR_INVALIDPARAMS");
			break;
		case DDERR_INVALIDRECT:
			LocalisedString::explainFail( info.c_str(),L"DDERR_INVALIDRECT");
			break;
		case DDERR_INVALIDPIXELFORMAT:
			LocalisedString::explainFail( info.c_str(),L"DDERR_INVALIDPIXELFORMAT");
			break;
		case DDERR_NOALPHAHW:
			LocalisedString::explainFail( info.c_str(),L"DDERR_NOALPHAHW");
			break;
		case DDERR_NOBLTHW:
			LocalisedString::explainFail( info.c_str(),L"DDERR_NOBLTHW");
			break;
		case DDERR_NOCLIPLIST:
			LocalisedString::explainFail( info.c_str(),L"DDERR_NOCLIPLIST");
			break;
		case DDERR_NOCOOPERATIVELEVELSET:
			LocalisedString::explainFail( info.c_str(),L"DDERR_NOCOOPERATIVELEVELSET");
			break;
		case DDERR_NOFLIPHW:
			LocalisedString::explainFail( info.c_str(),L"DDERR_NOFLIPHW");
			break;
		case DDERR_NOOVERLAYHW:
			LocalisedString::explainFail( info.c_str(),L"DDERR_NOOVERLAYHW");
			break;
		case DDERR_NOSTRETCHHW:
			LocalisedString::explainFail( info.c_str(),L"DDERR_NOSTRETCHHW");
			break;
		case DDERR_NOTAOVERLAYSURFACE:
			LocalisedString::explainFail( info.c_str(),L"DDERR_NOTAOVERLAYSURFACE");
			break;
		case DDERR_OUTOFMEMORY:
			LocalisedString::explainFail( info.c_str(),L"DDERR_OUTOFMEMORY");
			break;
		case DDERR_OUTOFVIDEOMEMORY:
			LocalisedString::explainFail( info.c_str(),L"DDERR_OUTOFVIDEOMEMORY");
			break;
		case DDERR_PRIMARYSURFACEALREADYEXISTS:
			LocalisedString::explainFail( info.c_str(),L"DDERR_PRIMARYSURFACEALREADYEXISTS");
			break;
		case DDERR_SURFACEBUSY:
			LocalisedString::explainFail( info.c_str(),L"DDERR_SURFACEBUSY");
			break;
		case DDERR_SURFACELOST:{
			GlobalInformations* gi=GlobalInformations::getInstance();
			(*(gi->ldDDraw))->RestoreAllSurfaces();
			Element::reloadAllSurface();
			//LocalisedString::explainFail( info.c_str(),L"DDERR_SURFACELOST");
							   }
			return;//not an error
		case DDERR_UNSUPPORTED:
			LocalisedString::explainFail( info.c_str(),L"DDERR_UNSUPPORTED");
			break;
		case DDERR_DCALREADYCREATED:
			LocalisedString::explainFail( info.c_str(),L"DDERR_DCALREADYCREATED");
			break;
		case DDERR_WASSTILLDRAWING:
			LocalisedString::explainFail( info.c_str(),L"DDERR_WASSTILLDRAWING");
			return;//not an error...
		default:
			//LocalisedString::explainFail( info.c_str(),L"DirectDraw error unhandled");
			return;//not an error ???
	}
	exit(0);
};

//print debug information when CreateSurface fail :
void LocalisedString::explainFailIImage(HRESULT hRet,wstring info){
	switch(hRet){
		case E_INVALIDARG:
			LocalisedString::explainFail( info.c_str(),L"E_INVALIDARG");
			break;
		case E_OUTOFMEMORY:
			LocalisedString::explainFail( info.c_str(),L"E_OUTOFMEMORY");
			break;
		case E_NOTIMPL:
			LocalisedString::explainFail( info.c_str(),L"E_NOTIMPL");
			break;
		case E_ACCESSDENIED:
			LocalisedString::explainFail( info.c_str(),L"E_ACCESSDENIED");
			break;
		case E_PENDING:
			LocalisedString::explainFail( info.c_str(),L"E_PENDING");
			break;
		case IMGERR_OBJECTBUSY:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_OBJECTBUSY");
			break;
		case IMGERR_NOPALETTE:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_NOPALETTE");
			break;
		case IMGERR_BADLOCK:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_BADLOCK");
			break;
		case IMGERR_BADUNLOCK:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_BADUNLOCK");
			break;
		case IMGERR_NOCONVERSION:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_NOCONVERSION");
			break;
		case IMGERR_CODECNOTFOUND:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_CODECNOTFOUND");
			break;
		case IMGERR_NOFRAME:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_NOFRAME");
			break;
		case IMGERR_ABORT:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_ABORT");
			break;
		case IMGERR_FAILLOADCODEC:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_FAILLOADCODEC");
			break;
		case IMGERR_PROPERTYNOTFOUND:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_PROPERTYNOTFOUND");
			break;
		case IMGERR_PROPERTYNOTSUPPORTED:
			LocalisedString::explainFail( info.c_str(),L"IMGERR_PROPERTYNOTSUPPORTED");
			break;
		default:
			//LocalisedString::explainFail( info.c_str(),L"DirectDraw error unhandled");
			return;//not an error ???
	}
	exit(0);
};


//print debug information when Win API fail :
void LocalisedString::explainFailWinAPI(wstring info){
	LPVOID lpMsgBuf;
	FormatMessage( 
		FORMAT_MESSAGE_ALLOCATE_BUFFER | 
		FORMAT_MESSAGE_FROM_SYSTEM | 
		FORMAT_MESSAGE_IGNORE_INSERTS,
		NULL,
		GetLastError(),
		0, // Default language
		(LPTSTR) &lpMsgBuf,
		0,
		NULL 
		);
	WCHAR *tmp=(WCHAR *)lpMsgBuf;
	// Process any inserts in lpMsgBuf.
	// ...
	// Display the string.
	explainFail((LPCTSTR)lpMsgBuf, info.c_str(),  true );
	// Free the buffer.
	LocalFree( lpMsgBuf );
}