//#define INITGUID
#include "../../Library/SDK_Manila_Sense.h"
GlobalInformations* MessageBoxSense::gi=NULL;


DIRECTDRAW_GDI *MessageBoxSense::msgBox=NULL;
RECT MessageBoxSense::rectBox;
int MessageBoxSense::answer;
HANDLE MessageBoxSense::threadMSG;
bool MessageBoxSense::standAlone=false;

void MessageBoxSense::loadSurf(){
	if(msgBox==NULL){
		msgBox=Element::loadImage(gi->bg_msg_box);

		rectBox.top=0;rectBox.left=0;
		rectBox.right=msgBox->width;
		rectBox.bottom=msgBox->height;
	}
	isInit=false;
	posAbsolute.top=gi->rcVisibleDesktopTOP.top+((gi->rs.bottom-gi->rs.top)-(2*rectBox.bottom/3+heightMsg+button[0]->getHeight()+10))/2;
	posAbsolute.left=((gi->rs.right-gi->rs.left)-rectBox.right)/2;
	posAbsolute.bottom=posAbsolute.top+(2*rectBox.bottom/3+heightMsg+button[0]->getHeight()+10);
	posAbsolute.right=posAbsolute.left+rectBox.right;
}

MessageBoxSense::MessageBoxSense(wstring ti,wstring text,int t){
	//take control of drawing!
	gi->window->changeControl(this);
	repaintButton=false;
	title=ti;
	message=text;
	type=t;
	selectedButton=NULL;
	isActive=true;
	isAlreadyComputed=false;
	button=NULL;

	//window creation :

	WNDCLASS                    wc;
	DWORD                       dwUpdateFlags = 0;

	// Set up and register window class.

	wc.style = CS_HREDRAW | CS_VREDRAW;
	wc.lpfnWndProc = MessageBoxSense::messageDispatch;
	wc.cbClsExtra = 0;
	wc.cbWndExtra = 0;
	wc.hInstance = gi->m_hInstance;
	wc.hIcon = LoadIcon(gi->m_hInstance, NULL);
	wc.hCursor = LoadCursor(NULL, IDC_ARROW);
	wc.hbrBackground = (HBRUSH )GetStockObject(WHITE_BRUSH);
	wc.lpszMenuName = NULL;
	wc.lpszClassName = L"MessageBoxSense";
	RegisterClass(&wc);

	// Create a window.

	this->hWnd = CreateWindow(
		L"MessageBoxSense",
		title.c_str(),
		WS_SYSMENU,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		CW_USEDEFAULT,
		gi->m_hWnd,
		NULL,
		NULL,
		this);
	if (!this->hWnd)
		return;
	if(standAlone){
		gi->m_hWnd=this->hWnd;
		GetClientRect(gi->m_hWnd, &gi->rs);
		gi->primaryBuffer=new DIRECTDRAW_GDI;
		gi->primaryBuffer->bitmap=0;
		gi->primaryBuffer->directDrawSurf=NULL;
		gi->primaryBuffer->deviceInterface=0;
		gi->primaryBuffer->height=GetSystemMetrics(SM_CYSCREEN)-gi->rcVisibleDesktopTOP.top;
		gi->primaryBuffer->width=GetSystemMetrics(SM_CXSCREEN);
		gi->primaryBuffer->nbBPP=16;

		DDSURFACEDESC DDSurfDesc;
		memset(&DDSurfDesc, 0, sizeof(DDSurfDesc));
		DDSurfDesc.dwSize = sizeof(DDSurfDesc);
		DDSurfDesc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT;
		DDSurfDesc.dwWidth = gi->rs.right;
		DDSurfDesc.dwHeight = gi->rs.bottom;
		gi->backBuffer=new DIRECTDRAW_GDI;
		//hret=(*gi->ldDDraw)->CreateSurface(&DDSurfDesc, &gi->backBuffer->directDrawSurface, NULL );
		HRESULT hret=DirectDrawWarp::createSurf(&DDSurfDesc, gi->backBuffer);
		if (hret != DD_OK)
			LocalisedString::explainFailDirectDraw(hret,L"Can't create surface");
	}

	///////////////////////////////////////////////////////////////////////////
	// the main DirectDraw object is already created : (not used now)
	///////////////////////////////////////////////////////////////////////////
	//gi->ldDDraw
	//gi->primaryBuffer
	//gi->backBuffer

	SetForegroundWindow((HWND)(((ULONG) this->hWnd) | 0x01));//To ensure that our window is reactivated
	ShowWindow(this->hWnd, true);
	UpdateWindow(this->hWnd);
	SetFocus(this->hWnd);
	SHFullScreen(this->hWnd,SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);



	switch (type)
	{
	case MESSAGE_ALERT:
		button=new MyItem*[1];//only one button
		button[0]=new MyItem(1,0,0,ITEM_IS_BUTTON_SHORT,ITEM_STATE_EBL_EMPTY,L"OK");
		break;
	case MESSAGE_YESNO:
		button=new MyItem*[2];//two buttons
		button[0]=new MyItem(1,0,0,ITEM_IS_BUTTON_SHORT,ITEM_STATE_EBL_EMPTY,L"Yes");
		button[1]=new MyItem(2,0,0,ITEM_IS_BUTTON_SHORT,ITEM_STATE_EBL_EMPTY,L"No");
		break;
	case MESSAGE_OKCANCEL:
		button=new MyItem*[2];//two buttons
		button[0]=new MyItem(1,0,0,ITEM_IS_BUTTON_SHORT,ITEM_STATE_EBL_EMPTY,L"OK");
		button[1]=new MyItem(2,0,0,ITEM_IS_BUTTON_SHORT,ITEM_STATE_EBL_EMPTY,L"Cancel");
		break;
	case MESSAGE_ABORTRETRY:
		button=new MyItem*[2];//two buttons
		button[0]=new MyItem(1,0,0,ITEM_IS_BUTTON_SHORT,ITEM_STATE_EBL_EMPTY,L"Retry");
		button[1]=new MyItem(2,0,0,ITEM_IS_BUTTON_SHORT,ITEM_STATE_EBL_EMPTY,L"Abort");
		break;
	default:
		button=NULL;//two buttons
	}
	if(msgBox==NULL){
		loadSurf();
	}

	//find the real size of text :
	HDC hdc;
	RECT sizeTxt={0,0,rectBox.right,0};

	hdc=gi->backBuffer->deviceInterface;

	SelectObject(hdc, MyLabel::fontNormal);
	DrawText(hdc,message.c_str(),message.length(),&sizeTxt,DT_CALCRECT|DT_WORDBREAK);
	heightMsg=sizeTxt.bottom;
	sizeTxt.bottom=0;

	SelectObject(hdc, MyLabel::fontTitle);
	DrawText(hdc,title.c_str(),title.length(),&sizeTxt,DT_CALCRECT);
	widthTitle=sizeTxt.right;

	isInit=false;
	posAbsolute.top=gi->rcVisibleDesktopTOP.top+((gi->rs.bottom-gi->rs.top)-(2*rectBox.bottom/3+heightMsg+button[0]->getHeight()+10))/2;
	posAbsolute.left=((gi->rs.right-gi->rs.left)-rectBox.right)/2;
	posAbsolute.bottom=posAbsolute.top+(2*rectBox.bottom/3+heightMsg+button[0]->getHeight()+10);
	posAbsolute.right=posAbsolute.left+rectBox.right;
}

MessageBoxSense::~MessageBoxSense(){

	DestroyWindow(this->hWnd);
	//ShowWindow(hWnd,SW_HIDE);

	switch (type)
	{
	case MESSAGE_ALERT:
		delete *button;//only one button
		break;
	case MESSAGE_YESNO:
	case MESSAGE_OKCANCEL:
	case MESSAGE_ABORTRETRY:
		delete button[0];
		delete button[1];
		break;
	default:
		button=NULL;//two buttons
	}
}



long FAR PASCAL MessageBoxSense::messageDispatch(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam){
	MessageBoxSense* pParent;

	// Get pointer to window
	if(message == WM_CREATE)
	{
		pParent = (MessageBoxSense*)((LPCREATESTRUCT)lParam)->lpCreateParams;
		SetWindowLong(hWnd,GWL_USERDATA,(LONG_PTR)pParent);
		return 1;
	}
	else
	{
		pParent = (MessageBoxSense*)GetWindowLong(hWnd,GWL_USERDATA);
		if(!pParent)
			return DefWindowProc(hWnd,message,wParam,lParam);
	}

	return pParent->messageAnalysis(message,wParam,lParam);
}
long MessageBoxSense::messageAnalysis(UINT message, WPARAM wParam, LPARAM lParam){
	switch (message)
	{
#ifdef UNDER_CE
		case WM_ACTIVATE:
#else
		case WM_ACTIVATEAPP:
#endif
			
			return 0;

		case WM_SETFOCUS:
			if(isActive){
				isInit=false;
				gi->window->UpdateFrame();
			}
			return 0L;
			/*
		case WM_CLOSE:
			DestroyWindow(this->hWnd);
			break;

		case WM_DESTROY:
			break;*/
			
			
		case WM_CTLCOLOREDIT://EDIT control want to repaint...
			break;
			

		case WM_ERASEBKGND:
			return 1;

		case MSG_USER_PAINT:
			gi->window->doRepaintBuffered(0);
			return 1;
		case WM_PAINT:{
			PAINTSTRUCT ps;
			BeginPaint( this->hWnd, &ps );
			EndPaint( this->hWnd, &ps );
			gi->window->UpdateFrame();
					  }
			break;

		case WM_LBUTTONDOWN:{
			MouseCtrl::getInstance()->leftBtnDown(LOWORD(lParam),HIWORD(lParam));
			gi->window->UpdateFrame();
			break;
							}
		case WM_LBUTTONUP:{
			MouseCtrl::getInstance()->leftBtnUp(LOWORD(lParam),HIWORD(lParam));
			gi->window->UpdateFrame();
			break;
						  }
		case WM_MOUSEMOVE:{
			MouseCtrl::getInstance()->leftBtnMove(LOWORD(lParam),HIWORD(lParam));
			gi->window->UpdateFrame();
			break;
						  }

	}
	return DefWindowProc(gi->m_hWnd, message, wParam, lParam);
}
int MessageBoxSense::show(wstring ti,wstring message,int type){

	if(!GlobalInformations::alreadyInitialized()){//stand alone app...
		standAlone=true;
		gi=GlobalInformations::getInstance();//hope for appName correctly set !

		gi->window=new DirectDrawWarp();
	}else{
		standAlone=false;
		gi=GlobalInformations::getInstance();
	}
	//EnableWindow(gi->m_hWnd, FALSE);
	ResetEvent(gi->waitForMSG);
	MessageBoxSense* box=new MessageBoxSense(ti,message,type);

	gi->window->UpdateFrame();

	

	//ShowWindow(gi->m_hWnd, SW_MINIMIZED);


	//two options : we are in the same thread of Main Msg Loop or in an other thread.
	DWORD processWindow=NULL;
	GetWindowThreadProcessId(gi->m_hWnd,&processWindow);
	if(GetCurrentProcessId()==processWindow){//create a new processing loop :
		bool waitMSG=true;
		MSG msg;
		while( waitMSG )
		{

			if(GetMessage( &msg, NULL, 0, 0)==-1){
				LocalisedString::explainFail( L"Main MsgBox function failed...",L"GetMessage");
				waitMSG=false;
			}
			if(msg.hwnd==box->hWnd){
				switch(msg.message)
					{
					case WM_QUIT:
						waitMSG=false;
						break;
					case WM_USER:
						if(msg.wParam==MESSAGE_REP){
							waitMSG=false;
							break;
						}
					default:
						TranslateMessage(&msg);
						DispatchMessage(&msg);
						//gi->window->UpdateFrame();
				}
			}else{
				if(msg.hwnd==NULL){
					EventHandler::msgExecute(msg);
				}else{
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}
		}
	}else{
		WaitForSingleObject(gi->waitForMSG,INFINITE);//if a msg box is shown we wait...
	}
	/*
	
		//EnableWindow(gi->m_hWnd, TRUE);
	
		//PostMessage(gi->m_hWnd,WM_ACTIVATE,WA_ACTIVE,NULL);//redundant, but should be there!!!
		ShowWindow(gi->m_hWnd, true);
		UpdateWindow(gi->m_hWnd);
		SetFocus(gi->m_hWnd);
		SHFullScreen(gi->m_hWnd,SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);*/
	

	box->isActive=false;
	delete box;//don't need this window...

	//give control of drawing!
	if(!standAlone)
		gi->window->changeControl(NULL);
	else{
		delete gi->window;
		gi->window=NULL;
		gi=NULL;
	}
/*
	// Use the blter to do a color fill to clear the buffer
	DDBLTFX ddbltfx;
	memset(&ddbltfx, 0, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwFillColor = BACKGROUND_COLOR_MANILA;
	gi->window->BltFast(gi->primaryBuffer,&gi->rs,NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);
	//gi->window->UpdateFrame();
	*/
	//gi->window->BltFast(gi->primaryBuffer,&gi->rs, gi->background,&gi->rs, DDBLT_WAITNOTBUSY,NULL);

	InvalidateRect(gi->m_hWnd,NULL,false);

	return MessageBoxSense::answer;
}


void MessageBoxSense::updateFrame(DIRECTDRAW_GDI* screen){
	if(!isActive||button==NULL)//not initialized
		return;

	if(!isInit){
		isInit=true;
		isAlreadyComputed=true;
		DIRECTDRAW_GDI* backBuf=gi->backBuffer;

		gi->rcUpdateRegion=gi->rs;
		gi->rcUpdateRegion.top=gi->rcVisibleDesktopTOP.top;
		//set a background darker!
		DDBLTFX fillColor;
		fillColor.dwFillColor=0;//Do a black bliting...
		gi->window->BltFast(backBuf,NULL,
			NULL, NULL,DDBLT_COLORFILL,&fillColor);
		gi->window->BltMix(backBuf,&gi->rcUpdateRegion,
			screen,&gi->rcUpdateRegion,128.0);


		//background of msgBox:
		RECT srcBox={rectBox.left,rectBox.top,rectBox.right,rectBox.bottom};
		RECT posBox=posAbsolute;
		//top:
		posBox.bottom=posAbsolute.top+rectBox.bottom/2;
		srcBox.bottom-=(int)((rectBox.bottom/2.0));
		gi->window->BltFast(backBuf,&posBox,msgBox, &srcBox,NULL,NULL);
		//h=msgBox->Draw(hdc, &posBox, &srcBox);

		//middle:
		posBox.top=posAbsolute.top+rectBox.bottom/2;
		posBox.bottom=posAbsolute.bottom-rectBox.bottom/10;
		srcBox.top=(int)((rectBox.bottom/2.0));
		srcBox.bottom=(LONG)((rectBox.bottom/2.0))+(LONG)2;
		//h=msgBox->Draw(hdc, &posBox, &srcBox);
		gi->window->BltFast(backBuf,&posBox,msgBox, &srcBox,NULL,NULL);

		//bottom:
		posBox=posAbsolute;
		posBox.top=posAbsolute.bottom-rectBox.bottom/4;
		srcBox.top=(LONG)((3.0*rectBox.bottom/4.0));
		srcBox.bottom=(LONG)(rectBox.bottom);
		//h=msgBox->Draw(hdc, &posBox, &srcBox);
		gi->window->BltFast(backBuf,&posBox,msgBox, &srcBox,NULL,NULL);



		//now print title & text:
		COLORREF color=RGB(0xFF,0xFF,0xFF);

		//screen->GetDC(&hdc);
		posBox=posAbsolute;
		posBox.bottom=posBox.top+(posBox.bottom-posBox.top)/5;
		SelectObject(backBuf->deviceInterface, MyLabel::fontTitle);
		SetTextColor(backBuf->deviceInterface,color);
		SetBkMode(backBuf->deviceInterface,TRANSPARENT);
		DrawText(backBuf->deviceInterface,title.c_str(),title.length(),&posBox,DT_CENTER|DT_SINGLELINE|DT_VCENTER);

		color=RGB(0,0,0);
		posBox=posAbsolute;
		posBox.left+=(posBox.right-posBox.left)/50;
		posBox.right-=(posBox.right-posBox.left)/50;
		posBox.top+=rectBox.bottom/2;
		posBox.bottom-=(posBox.bottom-posBox.top)/4;
		SelectObject(backBuf->deviceInterface, MyLabel::fontNormal);
		SetTextColor(backBuf->deviceInterface,color);
		SetBkMode(backBuf->deviceInterface,TRANSPARENT);
		DrawText(backBuf->deviceInterface,message.c_str(),message.length(),&posBox,DT_WORDBREAK);
		repaintButton=false;
		//now buttons:
		switch (type)
		{
		case MESSAGE_ALERT://only one button
			button[0]->paint(backBuf,posAbsolute.left+((posAbsolute.right-posAbsolute.left)-(button[0]->getWidth()))/2,
				posAbsolute.top+rectBox.bottom/2+heightMsg+10);
			break;
		case MESSAGE_YESNO:
		case MESSAGE_OKCANCEL:
		case MESSAGE_ABORTRETRY://two buttons
			button[0]->paint(backBuf,posAbsolute.left+10,
				posAbsolute.top+rectBox.bottom/2+heightMsg+10);
			button[1]->paint(backBuf,posAbsolute.right-10-button[1]->getWidth(),
				posAbsolute.top+rectBox.bottom/2+heightMsg+10);
			break;
		}
		gi->window->BltFast(screen,&gi->rcUpdateRegion,
			gi->backBuffer,&gi->rcUpdateRegion,NULL,NULL);
	}
	KillTimer(gi->m_hWnd,1);

	if(repaintButton){
		repaintButton=false;
		gi->window->BltFast(screen,&gi->rcUpdateRegion,
			gi->backBuffer,&gi->rcUpdateRegion,NULL,NULL);
		//now buttons:
		switch (type)
		{
		case MESSAGE_ALERT://only one button
			button[0]->paint(screen,posAbsolute.left+((posAbsolute.right-posAbsolute.left)-(button[0]->getWidth()))/2,
				posAbsolute.top+rectBox.bottom/2+heightMsg+10);
			break;
		case MESSAGE_YESNO:
		case MESSAGE_OKCANCEL:
		case MESSAGE_ABORTRETRY://two buttons
			button[0]->paint(screen,posAbsolute.left+10,
				posAbsolute.top+rectBox.bottom/2+heightMsg+10);
			button[1]->paint(screen,posAbsolute.right-10-button[1]->getWidth(),
				posAbsolute.top+rectBox.bottom/2+heightMsg+10);
			break;
		}
	}

	MouseCtrl* mCtrl=MouseCtrl::getInstance();
	mCtrl->stopScroll();

	if(mCtrl->isClicked())
		if(this->selectedButton!=NULL){
			MessageBoxSense::answer=MSG_REP_YES;
			if(selectedButton->getId()!=1)
				MessageBoxSense::answer=MSG_REP_NO;
			//PostThreadMessage(NULL,WM_USER,MESSAGE_REP,NULL);
			PostMessage(this->hWnd,WM_USER,MESSAGE_REP,NULL);
			this->selectedButton=NULL;
			repaintButton=true;
			return;
		}
	if(mCtrl->isSelected()){
		if(this->selectedButton==NULL){
			int posX,posY;
			mCtrl->getMousePosition(posX,posY);
			selectedButton=button[0]->isClicked(posX,posY);
			if(selectedButton==NULL&&(type!=MESSAGE_ALERT))
				selectedButton=button[1]->isClicked(posX,posY);
			repaintButton=true;
		}
	}else{
		if(this->selectedButton!=NULL){
			this->selectedButton->unClick();
			this->selectedButton=NULL;
			repaintButton=true;
		}
	}
};
