#include "../../Library/SDK_Manila_Sense.h"

DIRECTDRAW_GDI *MyEditControl::inputDDraw=NULL;

unsigned char MyEditControl::widthCorner=10;//HTC default
unsigned short int MyEditControl::widthItem=0;
HWND MyEditControl::input=0;
MyEditControl* MyEditControl::pEditCtrl=NULL;

int MyEditControl::EDIT_MENU_HEIGHT=0;

void MyEditControl::loadSurf(){
	if(MyEditControl::input==0){
		MyEditControl::input=CreateWindow(
			L"EDIT",
			NULL,
			ES_AUTOHSCROLL,	//|ES_MULTILINE|ES_AUTOVSCROLL|ES_AUTOHSCROLL
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			CW_USEDEFAULT,
			gi->m_hWnd,//NULL
			(HMENU) ID_EDITCHILD,   // edit control ID 
			GetModuleHandle(NULL),
			NULL);
		if (!MyEditControl::input){
			LocalisedString::explainFailWinAPI(LocalisedString::szCreateInputText);
			return;
		}
		// Create a SIPPREF control to handle the SIP. (copy/paste...)
		CreateWindow(WC_SIPPREF, L"", WS_CHILD,
			0,  0, 0, 0, gi->m_hWnd, NULL, NULL, NULL);
	}
	if(inputDDraw==NULL){
		inputDDraw=loadImage(gi->btn_common_input);
		EDIT_MENU_HEIGHT=inputDDraw->height;
		widthItem=inputDDraw->width/3.0;
	}

	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);

	if(dwWidth > dwHeight){//center the item:
		if(paddingSup==0){
			double diff=dwWidth- dwHeight;
			paddingSup=diff/2;
			if(this->getRight()+paddingSup<dwWidth){
				this->setRight(this->getRight()+paddingSup);
				this->setLeft(this->getLeft()+paddingSup);
			}else{
				paddingSup=0;
			}
		}
	}else{
		if(paddingSup!=0){
			this->setRight(this->getRight()-paddingSup);
			this->setLeft(this->getLeft()-paddingSup);
			paddingSup=0;
		}else{
			if(this->getRight()>dwWidth){
				this->setRight(this->getRight()-(dwWidth- dwHeight));
			}
		}
	}

	
}

MyEditControl::MyEditControl(int idElement, int x,int y,int width):Element(idElement, x,y,TYPE_EDIT_CTRL)
{
	text=NULL;
	this->setWidth(width);
	if(inputDDraw==NULL||gi->backBuffer==NULL){
		loadSurf();
	}

	state=0;
	this->setHeight(EDIT_MENU_HEIGHT);
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;
	text=new MyLabel(-1,4,10,width,EDIT_MENU_HEIGHT,L"",NULL,false);
	text->isClickable=true;
	text->owner=this;

	slideToTop=false;
	container=NULL;
}

void MyEditControl::sizeChanged(Element* src,int width,int height){
	if(src!=text)
		return;
	if(width>getWidth()){
		text->setWidth(getWidth());
	}
	if(height>getHeight()){
		text->setHeight(getHeight());
	}
}

MyEditControl::~MyEditControl(void)
{
}

bool MyEditControl::run(bool isRightClicked){
	Element::run(isRightClicked);
	if(state!=VIS_HOVER)
		return false;//EventHandler::messageTreatment has maybe changed the state of element !

	container=(Section*)this->mouseEvent->changeMouseAnalyse(this);

	slideToTop=true;//animation to catch the control of the screen...

	// Create a timer to show scrolling
	SetTimer(gi->m_hWnd, 1, MS_PER_FRAME, NULL);

	startAnim=GetTickCount();//300ms max
	startPos=positionAbsolute.bottom;
	return true;

}
void MyEditControl::showSIP(){
	//Show Software-based Input Panel :
	SetFocus(gi->m_hWnd);
	SHFullScreen(gi->m_hWnd,SHFS_SHOWSIPBUTTON);
	SIPINFO si = {0};
	si.cbSize = sizeof(SIPINFO);
	SHSipInfo(SPI_GETSIPINFO, 0, &si, 0);
	si.fdwFlags = SIPF_ON;
	SHSipInfo(SPI_SETSIPINFO, 0, &si, 0); 
	ShowWindow(input, SW_SHOW);
	UpdateWindow(input);
	SetFocus(input);
	//InvalidateRect(gi->m_hWnd,NULL,false);
}
void MyEditControl::show(){
	pEditCtrl=this;
	KillTimer(gi->m_hWnd, 1);
	//Stop DirectDraw
	gi->mustRender=false;
	ShowWindow(gi->m_hWnd, SW_SHOW);
	UpdateWindow(gi->m_hWnd);
	SetFocus(gi->m_hWnd);

	SIPINFO pSipInfo;
	memset(&pSipInfo, 0, sizeof(pSipInfo));
	pSipInfo.cbSize=sizeof(pSipInfo);
	if(!SipGetInfo(&pSipInfo))
		LocalisedString::explainFail(L"Internal Failure...",L"SipGetInfo(&pSipInfo)");

	// Use the blter to do a color fill to clear the buffer
	DDBLTFX ddbltfx;
	memset(&ddbltfx, 0, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwFillColor = RGB565to32(0,0,0);
	RECT tmp=gi->rs;
	tmp.top=pSipInfo.rcSipRect.bottom;
	gi->rcVisibleDesktopBOTTOM=pSipInfo.rcSipRect;

	//show a black banner at the bottom of the screen :
	gi->window->BltFast(gi->primaryBuffer,&tmp,NULL,NULL,DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);

/*
	//save the screen :
	HRESULT hres= gi->window->BltFast(gi->backBuffer,NULL, gi->primaryBuffer,NULL, DDBLT_WAITNOTBUSY,NULL);
	if (hres != DD_OK)
		LocalisedString::explainFailDirectDraw(hres,L"MyEditControl Blt(backBuffer);");
*/

	positionAbsolute.bottom=positionAbsolute.top+EDIT_MENU_HEIGHT;

	//gi->rcVisibleDesktopTOP=gi->rs;
	//gi->rcVisibleDesktopTOP.top=GetSystemMetrics(SM_CYSCREEN)-gi->rs.bottom;
	//gi->rcVisibleDesktopTOP.bottom=positionAbsolute.top+10;//previous : bottom-EDIT_MENU_HEIGHT
	gi->rcVisibleDesktopTOP.bottom=gi->rs.bottom;
/*
	gi->rcVisibleDesktopBOTTOM=gi->rcVisibleDesktopTOP;
	gi->rcVisibleDesktopBOTTOM.top=gi->rcVisibleDesktopTOP.bottom+(positionAbsolute.bottom-positionAbsolute.top)-10;
	gi->rcVisibleDesktopBOTTOM.bottom=pSipInfo.rcSipRect.top;
	*/

	MoveWindow(MyEditControl::input,
		positionAbsolute.left+4*gi->percentOfVGA,
		positionAbsolute.top+8*gi->percentOfVGA-gi->rcVisibleDesktopTOP.top,
		positionAbsolute.right-positionAbsolute.left-12*gi->percentOfVGA,
		positionAbsolute.bottom-positionAbsolute.top-12*gi->percentOfVGA,
		true);


	SendMessage(input, WM_SETTEXT, 0, (LPARAM) text->getText().c_str());

	showSIP();
};

void MyEditControl::unClick(){
	pEditCtrl=NULL;
	if(state!=VIS_DISABLED)
		this->state=VIS_NORMAL;

	gi->isActiv=true;
	slideToTop=false;

	//give the mouse control :
	if(container!=NULL)
		this->mouseEvent->changeMouseAnalyse(container);
	else
		return;//call by container, so we have nothing to do...

	//Hide Software-based Input Panel :
	if(!SipShowIM(SIPF_OFF)){
		LocalisedString::explainFail(LocalisedString::szCreateInputText,L"SipShowIM(SIPF_OFF)");
	}
	SHFullScreen(gi->m_hWnd,SHFS_HIDETASKBAR|SHFS_HIDESIPBUTTON);
	SIPINFO si = {0};
	si.cbSize = sizeof(SIPINFO);
	SHSipInfo(SPI_GETSIPINFO, 0, &si, 0);
	si.fdwFlags = SIPF_OFF;
	SHSipInfo(SPI_SETSIPINFO, 0, &si, 0); 

	WCHAR textTmp[255];
	GetWindowText( input, textTmp, 255	);
	wstring textPrev=text->getText();
	if(textPrev.compare(textTmp)!=0){
		text->setText(textTmp);
		getGestEvent()->messageProc(this,EVENT_VALUE_CHANGED);
	}

	ShowWindow(input, SW_HIDE);

	//manually, because non standard redraw (entire screen) :
	InvalidateRect(gi->m_hWnd,NULL,false);

};

Element* MyEditControl::isClicked(int x,int y){
	if(positionAbsolute.right==positionAbsolute.bottom&&
		positionAbsolute.bottom==0)
		return NULL;//OUT of screen, can't be clicked !

	if(x>positionAbsolute.left&&x<positionAbsolute.right&&
		y>positionAbsolute.top-gi->rcVisibleDesktopTOP.top&&y<positionAbsolute.top-gi->rcVisibleDesktopTOP.top+this->getHeight()){
		this->isActivated=true;
		if(state!=VIS_DISABLED){
			this->state=VIS_HOVER;
		}
		return this;
	}
	return NULL;
};

void MyEditControl::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){

	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.bottom=positionAbsolute.top+this->getHeight();
	positionAbsolute.left=this->getLeft()+x;
	positionAbsolute.right=positionAbsolute.left+getWidth();

	//are we in the window ?
	//if out of screen, do nothing...
	if(positionAbsolute.top>=gi->rcUpdateRegion.bottom||positionAbsolute.bottom<=gi->rcUpdateRegion.top||
		positionAbsolute.left>=gi->rcUpdateRegion.right||positionAbsolute.right<=gi->rcUpdateRegion.left)
		return;

	if(positionAbsolute.top<gi->rcUpdateRegion.top){
		clipping.top=gi->rcUpdateRegion.top-positionAbsolute.top;
		positionAbsolute.top=gi->rcUpdateRegion.top;
	}else{
		clipping.top=0;
	}
	if(positionAbsolute.bottom>gi->rcUpdateRegion.bottom){
		clipping.bottom=this->getHeight()-(positionAbsolute.bottom-gi->rcUpdateRegion.bottom);
		positionAbsolute.bottom=gi->rcUpdateRegion.bottom;
	}else{
		clipping.bottom=this->getHeight();
	}
	if(positionAbsolute.left<gi->rcUpdateRegion.left){
		clipping.left=gi->rcUpdateRegion.left-positionAbsolute.left;
		positionAbsolute.left=gi->rcUpdateRegion.left;
	}else{
		clipping.left=0;
	}
	if(positionAbsolute.right>gi->rcUpdateRegion.right){
		clipping.right=this->getWidth()-(positionAbsolute.right-gi->rcUpdateRegion.right);
		positionAbsolute.right=gi->rcUpdateRegion.right;
	}else{
		clipping.right=this->getWidth();
	}
	//clipping.left+=(state)*widthItem;
	//clipping.right+=(state)*widthItem;

	//now print background input :
	//left:
	RECT tmp=positionAbsolute;
	RECT tmpSrc=clipping;
	HRESULT hres;


	//print middle :
	tmp.right=positionAbsolute.right;
	tmp.left=positionAbsolute.left;
	tmpSrc.left=(state)*widthItem+15;
	tmpSrc.right=tmpSrc.left+1;
	if(clipping.left<10)
		tmp.left+=10;
	if(clipping.right>this->getWidth()-10)
		tmp.right-=10;
	if(tmp.left<tmp.right&&tmpSrc.right<widthItem*3.0){
		hres= gi->window->BltFast(lpDDraw,&tmp, inputDDraw,&tmpSrc, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
		if (hres != DD_OK)
			LocalisedString::explainFailDirectDraw(hres,L"MyPictureBox Blt(input mdl);");
	}

	int tmpRight=clipping.right;
	if(tmpRight>=10)
		tmpRight=10;
	if(clipping.left<10){
		//print [
		tmp.left=positionAbsolute.left;
		tmp.right=tmp.left+tmpRight;
		tmpSrc.left=(state)*widthItem+clipping.left;
		tmpSrc.right=(state)*widthItem+clipping.left+tmpRight;
		hres= gi->window->BltFast(lpDDraw,&tmp, inputDDraw,&tmpSrc, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
		if (hres != DD_OK)
			LocalisedString::explainFailDirectDraw(hres,L"MyPictureBox Blt(input ]);");
		//for middle :
		tmp.left=tmp.right;
	}

	int tmpLeft=clipping.left;
	if(tmpLeft<=this->getWidth()-10)
		tmpLeft=this->getWidth()-10;
	if(clipping.right>this->getWidth()-10){
		//print ]
		tmp.right=positionAbsolute.right;
		tmp.left=tmp.right-tmpLeft;
		tmpSrc.left=(state+1)*widthItem-tmpLeft;
		tmpSrc.right=(state+1)*widthItem;
		hres= gi->window->BltFast(lpDDraw,&tmp, inputDDraw,&tmpSrc, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
		if (hres != DD_OK)
			LocalisedString::explainFailDirectDraw(hres,L"MyPictureBox Blt(input ]);");
	}

	//set the real positions...
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.left=this->getLeft()+x;

	text->paintColor(lpDDraw,positionAbsolute.left,positionAbsolute.top,RGB(0,0,0),RGB565to32(31,63,31));

};


int MyEditControl::mouseGesture(){
	if(slideToTop){
		//is the control under the SIP ?
		SIPINFO pSipInfo;
		memset(&pSipInfo, 0, sizeof(pSipInfo));
		pSipInfo.cbSize=sizeof(pSipInfo);
		if(!SipGetInfo(&pSipInfo)){
			LocalisedString::explainFail(L"Internal Failure...",L"SipGetInfo(&pSipInfo)");
		}

		double paddingtop=GetSystemMetrics(SM_CYSCREEN)-gi->rs.bottom;
		if(positionAbsolute.bottom>pSipInfo.rcSipRect.top-paddingtop){
			DWORD timeL=(GetTickCount()-startAnim);
			int out;
			if(timeL>200){
				out=-(positionAbsolute.bottom-(pSipInfo.rcSipRect.top-paddingtop));
			}else{
				out=-((positionAbsolute.bottom-(pSipInfo.rcSipRect.top-paddingtop))/4+1);
			}
			//slide up :

			container->slideOverlay(out);
			if(out>0){
				gi->rcUpdateRegion.top=gi->rs.top;
				gi->rcUpdateRegion.bottom=gi->rs.top+out;
			}
			if(out<0){
				gi->rcUpdateRegion.bottom=GetSystemMetrics(SM_CYSCREEN);
				gi->rcUpdateRegion.top=gi->rcUpdateRegion.bottom+out;
			}
			gi->mustRedraw=false;
			return out;
		}else{
			if(positionAbsolute.top<50){
				//slide down :
				int out=1+(50-positionAbsolute.top)/2;
				container->slideOverlay(out);
				if(out>0){
					gi->rcUpdateRegion.top=gi->rs.top;
					gi->rcUpdateRegion.bottom=gi->rs.top+out;
				}
				if(out<0){
					gi->rcUpdateRegion.bottom=GetSystemMetrics(SM_CYSCREEN);
					gi->rcUpdateRegion.top=gi->rcUpdateRegion.bottom+out;
				}
				gi->mustRedraw=false;
				return out;
			}else{//we can print the component
				mouseEvent->stopScroll();
				slideToTop=false;
				this->show();
			}
		}
		return 0;
	}
	if(!mouseEvent->pickChange())
		return 0;//repaint all...

	if(mouseEvent->isSelected()||mouseEvent->isClicked()||mouseEvent->isDblClicked()){
		int posX,posY;
		mouseEvent->getMousePosition(posX,posY);
		posY+=gi->rcVisibleDesktopTOP.top;//beacause the windows is not at (0,0)
		if((posY<gi->rcVisibleDesktopTOP.bottom)||
			(posY>gi->rcVisibleDesktopBOTTOM.top&&posY<gi->rcVisibleDesktopBOTTOM.bottom)){
				this->unClick();/*
				
								Element *clicked=container->isClicked(posX-gi->rcVisibleDesktopTOP.left,posY-gi->rcVisibleDesktopTOP.top);
								container->selectedElement=clicked;*/
				
				container=NULL;/*
				if(clicked!=NULL)
					clicked->run();*/
		}
	}
	return 0;

};

void MyEditControl::setText( LPCWSTR param1 )
{
	text->setText(param1);
}