#include "../../Library/SDK_Manila_Sense.h"

DIRECTDRAW_GDI *MyItem::checkBoxes=NULL;
DIRECTDRAW_GDI *MyItem::switches=NULL;
DIRECTDRAW_GDI *MyItem::button_normal=NULL;
DIRECTDRAW_GDI *MyItem::button_big=NULL;
DIRECTDRAW_GDI *MyItem::button_short=NULL;
DIRECTDRAW_GDI *MyItem::checkBoxThrd=NULL;
DIRECTDRAW_GDI *MyItem::switchThrd=NULL;

int MyItem::checkBoxesWidth;
int MyItem::checkBoxesHeight;
int MyItem::switchesWidth;
int MyItem::switchesHeight;
int MyItem::button_normalWidth;
int MyItem::button_normalHeight;
int MyItem::button_bigWidth;
int MyItem::button_bigHeight;
int MyItem::button_shortWidth;
int MyItem::button_shortHeight;
int MyItem::button_ckThrdWidth;
int MyItem::button_swThrdWidth;
int MyItem::button_ckThrdHeight;
int MyItem::button_swThrdHeight;

void MyItem::loadSurf(){
	if(switchThrd==NULL&&type==ITEM_IS_SWITCH){
		switchThrd=loadImage(gi->btn_switch_thirdState);
		button_swThrdWidth=switchThrd->width/2;
		button_swThrdHeight=switchThrd->height;
	}
	if(checkBoxThrd==NULL&&type==ITEM_IS_CHECKBOX){
		checkBoxThrd=loadImage(gi->btn_checkbox_thirdState);
		button_ckThrdWidth=checkBoxThrd->width/2;
		button_ckThrdHeight=checkBoxThrd->height;
	}
	if(button_big==NULL&&type==ITEM_IS_BUTTON_BIG){
		button_big=loadImage(gi->btn_common_msgbox_large);
		button_bigWidth=button_big->width/4;
		button_bigHeight=button_big->height;
	}
	if(button_short==NULL&&type==ITEM_IS_BUTTON_SHORT){
		button_short=loadImage(gi->btn_common_msgbox_small);
		button_shortWidth=button_short->width/4;
		button_shortHeight=button_short->height;
	}
	if(button_normal==NULL&&type==ITEM_IS_BUTTON_NORMAL){
		button_normal=loadImage(gi->btn_common_normal);
		button_normalWidth=button_normal->width/4;
		button_normalHeight=button_normal->height;
	}
	if(switches==NULL&&type==ITEM_IS_SWITCH){
		switches=loadImage(gi->btn_common_switch);
		switchesWidth=switches->width/7;
		switchesHeight=switches->height;
	}
	if(checkBoxes==NULL&&type==ITEM_IS_CHECKBOX){
		checkBoxes=loadImage(gi->btn_common_checkbox);
		checkBoxesWidth=checkBoxes->width/6;
		checkBoxesHeight=checkBoxes->height;
	}
/*
	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);

	if(dwWidth > dwHeight){//center the item:
		if(paddingSup==0){
			double diff=dwWidth- dwHeight;
			paddingSup=diff/2;
			if(this->getRight()+paddingSup<dwWidth){
				this->setRight(this->getRight()+paddingSup);
				this->setLeft(this->getLeft()+paddingSup);
			}else{
				paddingSup=0;
			}
		}
	}else{
		if(paddingSup!=0){
			this->setRight(this->getRight()-paddingSup);
			this->setLeft(this->getLeft()-paddingSup);
			paddingSup=0;
		}
	}
*/
	if(isCentered){
		centerH();
	}
	
}
void MyItem::centerH(){
	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	int myWidth=this->getWidth();
	this->setLeft((dwWidth-myWidth)/2);
	this->setWidth(myWidth);
	isCentered=true;
}

MyItem::MyItem(int idElement, int x,int y,unsigned char t,unsigned char s,wstring tex):Element(idElement, x,y,TYPE_ITEM)
{
	isCentered=false;
	this->text=NULL;
	this->type=t;
	this->state=s;

	wstring primaryText;
	wstring secondaryText;

	loadSurf();

	switch(type){
	case ITEM_IS_CHECKBOX:
		elementHeight=checkBoxesHeight;
		elementWidth=checkBoxesWidth;
		mySurface=checkBoxes;
		break;
	case ITEM_IS_SWITCH:
		elementHeight=switchesHeight;
		elementWidth=switchesWidth;
		mySurface=switches;
		break;
	case ITEM_IS_BUTTON_NORMAL:
		elementHeight=button_normalHeight;
		elementWidth=button_normalWidth;
		mySurface=button_normal;
		break;
	case ITEM_IS_BUTTON_BIG:
		elementHeight=button_bigHeight;
		elementWidth=button_bigWidth;
		mySurface=button_big;
		break;
	case ITEM_IS_BUTTON_SHORT:
		elementHeight=button_shortHeight;
		elementWidth=button_shortWidth;
		mySurface=button_short;
		break;
	default:
		LocalisedString::explainFail( LocalisedString::szCreateMyItem,L"Wrong parameter");
	}


	this->setHeight(elementHeight);
	this->setWidth(elementWidth);


	if(tex!=L""){
		changeText(tex);
	}else
		text=NULL;
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;

	colorHover=RGB(196,196,196);
	colorDsbl=RGB(128,128,128);
	colorNrmal=RGB(5,5,5);
	colorBackHover=RGB565to32(6,12,6);
	colorBackDsbl=RGB565to32(28,56,28);
	colorBackNrmal=RGB565to32(28,56,28);
}

MyItem::~MyItem(void)
{
	//mySurface should not be released!
	delete text;
}


void MyItem::sizeChanged(Element* src,int width,int height){
	if(src!=text)
		return;
	switch(type){
		case ITEM_IS_BUTTON_NORMAL:
		case ITEM_IS_BUTTON_BIG:
		case ITEM_IS_BUTTON_SHORT:
		if(width>getWidth()){
			text->setWidth(getWidth());
		}
		if(height>getHeight()){
			text->setHeight(getHeight());
		}
	}
}

bool MyItem::run(bool isRightClicked){
	if(!(this->state==ITEM_STATE_DSBL_EMPTY||this->state==ITEM_STATE_DSBL_SELECTED||this->state==ITEM_THIRD_STATE_DSBL))
		Element::run(isRightClicked);//only fire event if element is activ

	//EventHandler::messageTreatment has maybe changed the state of element !
	if(this->state==ITEM_STATE_HOVER_EMPTY){
		this->state=ITEM_STATE_EBL_SELECTED;
		setMustRedraw();
		return false;
	}
	if(this->state==ITEM_STATE_HOVER_SELECTED){
		this->state=ITEM_STATE_EBL_EMPTY;
		setMustRedraw();
		return false;
	}
	if(this->state==ITEM_THIRD_STATE){
		this->state=ITEM_STATE_EBL_SELECTED;
		setMustRedraw();
		return false;
	}
	return false;
}


void MyItem::unClick(){
	if(this->state==ITEM_STATE_HOVER_EMPTY){
		this->state=ITEM_STATE_EBL_EMPTY;
		setMustRedraw();
		return;
	}

	if(this->state==ITEM_STATE_HOVER_SELECTED){
		this->state=ITEM_STATE_EBL_SELECTED;
		setMustRedraw();
		return;
	}
};

Element* MyItem::isClicked(int x,int y){
	if(positionAbsolute.right==positionAbsolute.bottom&&
		positionAbsolute.bottom==0)
		return NULL;//OUT of screen, can't be clicked !

	int width=this->getWidth();
	if(text!=NULL&&width<text->getRight())
		width=text->getRight();
	if(x>positionAbsolute.left-5&&x<positionAbsolute.left+width+5&&y>positionAbsolute.top-10-gi->rcVisibleDesktopTOP.top&&//increase the size
		y<positionAbsolute.top+this->getHeight()-gi->rcVisibleDesktopTOP.top){
		this->isActivated=true;
		if(this->state==ITEM_STATE_EBL_EMPTY){
			this->state=ITEM_STATE_HOVER_EMPTY;
			setMustRedraw();
		}else
			if(this->state==ITEM_STATE_EBL_SELECTED){
				this->state=ITEM_STATE_HOVER_SELECTED;
				setMustRedraw();
			}
		return this;
	}
	return NULL;
};

void MyItem::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){
	int posReal;
	switch(type){
	case ITEM_IS_CHECKBOX:
		elementHeight=checkBoxesHeight;
		elementWidth=checkBoxesWidth;
		mySurface=checkBoxes;
		if(state==ITEM_THIRD_STATE||state==ITEM_THIRD_STATE_DSBL){
			mySurface=checkBoxThrd;
			elementHeight=button_ckThrdHeight;
			elementWidth=button_ckThrdWidth;
			posReal=state-ITEM_THIRD_STATE;
		}else
			posReal=state;
		break;
	case ITEM_IS_SWITCH:
		elementHeight=switchesHeight;
		elementWidth=switchesWidth;
		mySurface=switches;
		mySurface=switches;
		if(state==ITEM_STATE_HOVER_EMPTY||state==ITEM_STATE_HOVER_SELECTED)
			posReal=6;
		else{
			if(state==ITEM_THIRD_STATE||state==ITEM_THIRD_STATE_DSBL){
				elementHeight=button_swThrdHeight;
				elementWidth=button_swThrdWidth;
				mySurface=switchThrd;
				posReal=state-ITEM_THIRD_STATE;
			}else
				posReal=state;
		}

		break;
	case ITEM_IS_BUTTON_NORMAL:
	case ITEM_IS_BUTTON_BIG:
	case ITEM_IS_BUTTON_SHORT:
		switch(state){
	case ITEM_STATE_EBL_EMPTY:
	case ITEM_STATE_EBL_SELECTED:
		posReal=0;
		break;
	case ITEM_STATE_DSBL_EMPTY:
	case ITEM_STATE_DSBL_SELECTED:
		posReal=2;
		break;
	case ITEM_STATE_HOVER_EMPTY:
	case ITEM_STATE_HOVER_SELECTED:
		posReal=1;
		break;
		}
		break;
	}

	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.bottom=positionAbsolute.top+elementHeight;
	positionAbsolute.left=this->getLeft()+x;
	positionAbsolute.right=positionAbsolute.left+elementWidth;

	//are we in the window ?
	//if out of screen, do nothing...
	if(!(positionAbsolute.top>=gi->rcUpdateRegion.bottom||positionAbsolute.bottom<=gi->rcUpdateRegion.top||
		positionAbsolute.left>=gi->rcUpdateRegion.right||positionAbsolute.right<=gi->rcUpdateRegion.left)){

			if(positionAbsolute.top<gi->rcUpdateRegion.top){
				clipping.top=gi->rcUpdateRegion.top-positionAbsolute.top;
				positionAbsolute.top=gi->rcUpdateRegion.top;
			}else{
				clipping.top=0;
			}
			if(positionAbsolute.bottom>gi->rcUpdateRegion.bottom){
				clipping.bottom=this->getHeight()-(positionAbsolute.bottom-gi->rcUpdateRegion.bottom);
				positionAbsolute.bottom=gi->rcUpdateRegion.bottom;
			}else{
				clipping.bottom=this->getHeight();
			}
			if(positionAbsolute.left<gi->rcUpdateRegion.left){
				clipping.left=posReal*elementWidth+gi->rcUpdateRegion.left-positionAbsolute.left;
				positionAbsolute.left=gi->rcUpdateRegion.left;
			}else{
				clipping.left=posReal*elementWidth;
			}
			if(positionAbsolute.right>gi->rcUpdateRegion.right){
				clipping.right=(posReal+1)*elementWidth-(positionAbsolute.right-gi->rcUpdateRegion.right);
				positionAbsolute.right=gi->rcUpdateRegion.right;
			}else{
				clipping.right=(posReal+1)*elementWidth;
			}

			HRESULT hres;

			if(positionAbsolute.bottom>positionAbsolute.top&&positionAbsolute.right>positionAbsolute.left){
				//now print image :
				hres= gi->window->BltFast(lpDDraw,&positionAbsolute, mySurface,&clipping, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
				//hres=lpDDraw->AlphaBlt(&positionAbsolute, mySurface,&clipping, DDBLT_WAITNOTBUSY,NULL);
				if (hres != DD_OK)
					LocalisedString::explainFailDirectDraw(hres,L"MyItem Blt(mySurface);");
			}
	}
	//set the real positions...
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.left=this->getLeft()+x;

	//render text, if available :
	if(this->text!=NULL){
		if((state==ITEM_STATE_HOVER_EMPTY||state==ITEM_STATE_HOVER_SELECTED)&&(type==ITEM_IS_BUTTON_NORMAL||type==ITEM_IS_BUTTON_BIG||type==ITEM_IS_BUTTON_SHORT))
			this->text->paintColor(lpDDraw,positionAbsolute.left,positionAbsolute.top,colorHover,colorBackHover);
		else
			if(state==ITEM_STATE_DSBL_EMPTY||state==ITEM_STATE_DSBL_SELECTED||state==ITEM_THIRD_STATE_DSBL)
				this->text->paintColor(lpDDraw,positionAbsolute.left,positionAbsolute.top,colorDsbl,colorBackDsbl);
			else
				this->text->paintColor(lpDDraw,positionAbsolute.left,positionAbsolute.top,colorNrmal,colorBackNrmal);
	}

};




void MyItem::setMustRedraw(){
	if(positionAbsolute.right==positionAbsolute.bottom&&
		positionAbsolute.bottom==0)
		return;//OUT of screen, no needs for redraw !

	if(text!=NULL&&(type==ITEM_IS_CHECKBOX||type==ITEM_IS_SWITCH))
		positionAbsolute.right=positionAbsolute.left+this->getWidth()+text->getRight();
	else
		positionAbsolute.right=positionAbsolute.left+this->getWidth();

	if(positionAbsolute.right>GetSystemMetrics(SM_CXSCREEN))
		positionAbsolute.right=GetSystemMetrics(SM_CXSCREEN);
	if(positionAbsolute.left<0)
		positionAbsolute.left=0;
	positionAbsolute.bottom=positionAbsolute.top+this->getHeight();
	if(positionAbsolute.bottom>GetSystemMetrics(SM_CYSCREEN))
		positionAbsolute.bottom=GetSystemMetrics(SM_CYSCREEN);
	if(positionAbsolute.top<gi->rs.top)
		positionAbsolute.top=gi->rs.top;

	if(positionAbsolute.bottom-positionAbsolute.top>0&&
		positionAbsolute.right-positionAbsolute.left>0){
			gi->window->addToRedraw(positionAbsolute,type==ITEM_IS_CHECKBOX||type==ITEM_IS_SWITCH||forceErase);
	}
}


void MyItem::changeText(wstring t){
	if(text!=NULL){
		switch(type){
		case ITEM_IS_BUTTON_NORMAL:
		case ITEM_IS_BUTTON_BIG:
		case ITEM_IS_BUTTON_SHORT:
			text->setText(t);
			text->centerH(0,this->getWidth());
			break;
		default:
			text->setRight(gi->rs.right);
			text->setText(t);
		}
	}else{
		switch(type){
		case ITEM_IS_CHECKBOX:
		case ITEM_IS_SWITCH:
			text=new MyLabel(-1,elementWidth+6*gi->percentOfVGA,0,t,0,(DWORD)0,true);
			break;
		case ITEM_IS_BUTTON_BIG:
			text=new MyLabel(-1,0,0,t,TEXT_BIG,(DWORD)0,true);
			text->centerH(0,this->getWidth());
			break;
		case ITEM_IS_BUTTON_NORMAL:
		case ITEM_IS_BUTTON_SHORT:
			text=new MyLabel(-1,0,0,t,0,(DWORD)0,true);
			text->centerH(0,this->getWidth());
			break;
		}
	}
	text->centerV(0,this->getHeight());
	text->isClickable=true;
	text->owner=this;
	this->setMustRedraw();
}

void MyItem::changeColorTxt(DWORD color,DWORD backColor,int type){
	switch(type){
		case ITEM_COLOR_HOVER:
			colorHover=color;
			colorBackHover=backColor;
			break;
		case ITEM_COLOR_DISABLED:
			colorDsbl=color;
			colorBackDsbl=backColor;
			break;
		case ITEM_COLOR_NORMAL:
			colorNrmal=color;
			colorBackNrmal=backColor;
			break;
	}
}