#include "../../Library/SDK_Manila_Sense.h"

HFONT MyLabel::fontTitle=NULL;
HFONT MyLabel::fontNormal=NULL;
HFONT MyLabel::fontItalic=NULL;
HFONT MyLabel::fontSmall=NULL;

void MyLabel::loadSurf(){
	if(render==NULL)
		setText(myText,false);

	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);
	if(this->getRight()==dwHeight){
		this->setRight(dwWidth);
	}
}

void  MyLabel::changeColor(DWORD color,int type){
	if(type<LABEL_STATE_NORMAL||type>LABEL_STATE_SELECTED)
		return;
	if(myColor[type]!=color){
		myColor[type]=color;
		setMustRedraw();
	}
};

void MyLabel::initComponnents(int type,DWORD color){
	isVisible=true;

	//load background for title :
	if(fontTitle==NULL){
		//------------------------Create new font :--------------------------------
/*
				HDC hdc;
				DIRECTDRAW_GDI* gdiSurface;
				HRESULT hres=(*gi->ldDDraw)->GetGDISurface(&gdiSurface);
				if (hres != DD_OK){
					LocalisedString::explainFailDirectDraw(hres,L"GetGDISurface(gdiSurface)");
					return;
				}
				gdiSurface->GetDC(&hdc);
				if (hres != DD_OK){
					LocalisedString::explainFailDirectDraw(hres,L"gdiSurface->GetDC(&hdc)");
					return;
					}*/
		HDC hdc=gi->backBuffer->deviceInterface;

		// Gets current font
		fontTitle = (HFONT) GetCurrentObject(hdc, OBJ_FONT);

		// Gets LOGFONT structure corresponding to current font
		LOGFONT LogFont;
		if (GetObject(fontTitle, sizeof(LOGFONT), &LogFont) == 0)
			return;

		// set the font to 10 :
		LogFont.lfHeight = -((10 * GetDeviceCaps(hdc, LOGPIXELSY))/ 72);
		//LogFont.lfWeight =300;
		LogFont.lfOutPrecision=OUT_RASTER_PRECIS;
		LogFont.lfQuality=CLEARTYPE_QUALITY|ANTIALIASED_QUALITY;
		LogFont.lfPitchAndFamily=FF_ROMAN|VARIABLE_PITCH;
		LogFont.lfCharSet=DEFAULT_CHARSET;
		//wcsncpy(LogFont.lfFaceName,L"HelveticaNeue LT 35 Thin.ttf\0",32);
		wcsncpy(LogFont.lfFaceName,L"Tahoma\0",32);

		// Creates and sets font to device context
		fontTitle = CreateFontIndirect(&LogFont);
		LogFont.lfHeight = -((9 * GetDeviceCaps(hdc, LOGPIXELSY))/ 72);
		fontNormal = CreateFontIndirect(&LogFont);
		LogFont.lfHeight = -((7 * GetDeviceCaps(hdc, LOGPIXELSY))/ 72);
		fontSmall = CreateFontIndirect(&LogFont);
		LogFont.lfHeight = -((9 * GetDeviceCaps(hdc, LOGPIXELSY))/ 72);
		LogFont.lfItalic=true;
		fontItalic = CreateFontIndirect(&LogFont);
	}
	isClickable=false;
	backGrnd=NULL;
	state=0;
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;

	previousColor=~color;
	myColor[LABEL_STATE_NORMAL]=color;
	myColor[LABEL_STATE_HOVER]=RGB(196,196,196);
	myColor[LABEL_STATE_DSBL]=RGB(128,128,128);
	myColor[LABEL_STATE_SELECTED]=RGB(196,196,196);
	render=NULL;
	switch(type){
		case 1:
			myFont=fontTitle;
			break;
		case 2:
			myFont=fontItalic;
			break;
		case 3:
			myFont=fontSmall;
			break;
		default:
			myFont=fontNormal;
	}


	loadSurf();

	paddingTop=0;
	paddingLeft=0;
	mustErase=true;
	lastWidth=0;
};

MyLabel::MyLabel(int idElement, int x,int y,wstring text,MyPictureBox* image,int padL,int fontType,DWORD color):Element(idElement, x,y,TYPE_LABEL)
{
	myText=text;
	backColor=DirectDrawWarp::background_color;
	this->setRight(gi->rs.right);
	initComponnents(fontType,color);

	state=LABEL_STATE_NORMAL;
	isClickable=true;

	backGrnd=image;
	if(backGrnd!=NULL){
		if(sizeSurface.bottom<backGrnd->getBottom())
			this->setHeight(backGrnd->getHeight());
		if(sizeSurface.right<backGrnd->getRight())
			this->setWidth(backGrnd->getWidth());
	}else{
		this->setWidth(sizeSurface.right);
		this->setHeight(sizeSurface.bottom);
	}
	paddingLeft=padL*gi->percentOfVGA;
}

MyLabel::MyLabel(int idElement, int x,int y,wstring text,DIRECTDRAW_GDI *bH,int fontType,DWORD color):Element(idElement, x,y,TYPE_LABEL)
{
	myText=text;
	backColor=DirectDrawWarp::background_color;
	this->setRight(gi->rs.right);
	initComponnents(fontType,color);

	state=LABEL_STATE_NORMAL;
	isClickable=true;

	if(bH!=NULL){
		backGrnd=new MyPictureBox(-1,x,y,bH,4);
		if(sizeSurface.bottom<backGrnd->getBottom())
			this->setHeight(backGrnd->getHeight());
		if(sizeSurface.right<backGrnd->getRight())
			this->setWidth(backGrnd->getWidth());
	}else{
		this->setWidth(sizeSurface.right);
		this->setHeight(sizeSurface.bottom);
	}
}

MyLabel::MyLabel(int idElement, int x,int y,wstring text,int fontType,DWORD color,bool rP,DWORD backC):Element(idElement, x,y,TYPE_LABEL,rP)
{
	if(backC==1)
		backColor=DirectDrawWarp::background_color;
	else
		backColor=backC;
	myText=text;
	this->setRight(gi->rs.right);
	initComponnents(fontType,color);
	this->setWidth(sizeSurface.right);
	this->setHeight(sizeSurface.bottom);
}

MyLabel::MyLabel(int idElement, int x,int y,int width,int height,wstring text,int fontType,bool centered,DWORD color):Element(idElement, x,y,TYPE_LABEL)
{
	isCenterH=centered;
	isCenterV=centered;
	width=width*gi->percentOfVGA;
	height=height*gi->percentOfVGA;
	myText=text;
	backColor=DirectDrawWarp::background_color;

	this->setWidth(width);
	this->setHeight(height);

	initComponnents(fontType,color);
	

	this->setWidth(width);//may be changed by initComponnents
	//this->setHeight(height);

	this->myText=text;
	if(centered)
		this->center();
}




void MyLabel::centerV(int top,int bottom){
	isCenterV=true;
	if(top==-1&&bottom==-1){
		top=getTop();
		bottom=getBottom();
	}
	int height=sizeSurface.bottom-sizeSurface.top;
	int wantedHeight=bottom-top;
	paddingTop=(wantedHeight-height)/2;
};
void MyLabel::centerH(int left,int right){
	isCenterH=true;
	int width=sizeSurface.right-sizeSurface.left;
	int wantedWidth=right-left;
	paddingLeft=(wantedWidth-width)/2;
};

void MyLabel::center(){
	centerH(getLeft(),getRight());
	centerV(getTop(),getBottom());
};

void MyLabel::setText(wstring nT,bool redraw){
	myText=nT;
	DirectDrawWarp::deleteSurf(&render);

	render=new DIRECTDRAW_GDI;
	previousColor=myColor[state];

	sizeSurface.top=0;
	sizeSurface.left=0;
	sizeSurface.bottom=1;
	sizeSurface.right=this->getWidth();//this->getWidth() |DT_WORDBREAK
	//find the real size of text :
	HDC hdc=gi->backBuffer->deviceInterface;
	HFONT hOldFont = (HFONT) SelectObject(hdc, myFont);

	DrawText(hdc,myText.c_str(),myText.length(),&sizeSurface,DT_CALCRECT|DT_WORDBREAK);
	SelectObject(hdc, hOldFont);
	sizeSurface.right+=5;	//italics end are cut...

	DDSURFACEDESC ddsd;
	memset(&ddsd, 0, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT;
	ddsd.dwWidth = sizeSurface.right;
	if(ddsd.dwWidth<16) ddsd.dwWidth=16;
	ddsd.dwHeight = sizeSurface.bottom;
	if(ddsd.dwHeight<16) ddsd.dwHeight=16;
	//HRESULT hRet = (*gi->ldDDraw)->CreateSurface(&ddsd, &render->directDrawSurface, NULL );
	HRESULT hRet = DirectDrawWarp::createSurf(&ddsd, render);
	if (hRet != DD_OK)
		LocalisedString::explainFailDirectDraw(hRet,L"MyLabel:setText CreateSurface");

	// Use the blter to do a color fill to clear the buffer
	DDBLTFX ddbltfx;
	memset(&ddbltfx, 0, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwFillColor = RGB(0,0,0);
	gi->window->BltFast(render,NULL, NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);

	hdc=render->deviceInterface;
	//font change :
	hOldFont = (HFONT) SelectObject(hdc, myFont);
	//SetTextColor(hdc,color);
	SetTextColor(hdc,0x00FFFFFF);
	SetBkColor(hdc,0);
	//SetBkMode(hdc,TRANSPARENT);

	RECT pos={0,0,this->getWidth(),this->getHeight()};
	UINT flags=DT_WORDBREAK;
	if(isCenterH)
		flags=flags|DT_CENTER;
	DrawText(hdc,myText.c_str(),myText.length(),&sizeSurface,flags);
	//now pass the image into a function to pass the alpha layer just computed to the correct position:
	computeRealAlpha(previousColor);
	SelectObject(hdc,hOldFont);

	if(owner!=NULL)
		owner->sizeChanged(this,sizeSurface.right,sizeSurface.bottom);
	if(sizeSurface.right>getWidth())
		this->setWidth(sizeSurface.right);
	if(sizeSurface.bottom>getHeight())
		this->setHeight(sizeSurface.bottom);
	if(redraw)
		this->setMustRedraw();
	mustErase=true;
	if(lastWidth<sizeSurface.right)
		lastWidth=sizeSurface.right;
};


MyLabel::~MyLabel(void)
{
	DirectDrawWarp::deleteSurf(&render);
}

Element* MyLabel::isClicked(int x,int y){
	if(isClickable){
		if(positionAbsolute.right==positionAbsolute.bottom&&
			positionAbsolute.bottom==0)
			return NULL;//OUT of screen, can't be clicked !

		positionAbsolute.right=positionAbsolute.left+this->getWidth();
		if(x>positionAbsolute.left-5&&x<positionAbsolute.right+5&&y>positionAbsolute.top-10-gi->rcVisibleDesktopTOP.top&&//increase the size
			y<positionAbsolute.top+this->getHeight()-gi->rcVisibleDesktopTOP.top){
				this->isActivated=true;
				if(this->state==LABEL_STATE_NORMAL||this->state==LABEL_STATE_SELECTED){
					this->state=LABEL_STATE_HOVER;
					setMustRedraw();
				}
				return this;
		}
	}
	return NULL;
};
bool MyLabel::run(bool isRightClicked){
	Element::run(isRightClicked);

	bool redraw=this->state==LABEL_STATE_HOVER;
	this->state=LABEL_STATE_SELECTED;

	if(redraw)
		setMustRedraw();
	return false;
};

void MyLabel::unClick(){
	if(this->state==LABEL_STATE_SELECTED||this->state==LABEL_STATE_HOVER)
		setMustRedraw();
	this->state=LABEL_STATE_NORMAL;
};

void MyLabel::paintColor(DIRECTDRAW_GDI* lpDDraw,int x,int y,COLORREF color,COLORREF background){
	//-----------------------------print the label :------------------------

	//recompute positionAbsolute :
	positionAbsolute.top=this->getTop()+paddingTop+y;
	positionAbsolute.bottom=positionAbsolute.top+sizeSurface.bottom;
	positionAbsolute.left=this->getLeft()+paddingLeft+x;
	positionAbsolute.right=positionAbsolute.left+sizeSurface.right;

	int posTop=positionAbsolute.top;
	int posBottom=positionAbsolute.bottom;
	if(backGrnd!=NULL){
		posTop=this->getTop()+y;
		posBottom=posTop+backGrnd->getHeight();
	}

	//are we in the window ?
	//if out of screen, do nothing...
	if(positionAbsolute.top>=gi->rcUpdateRegion.bottom||positionAbsolute.bottom<=gi->rcUpdateRegion.top||
		positionAbsolute.left>=gi->rcUpdateRegion.right||positionAbsolute.right<=gi->rcUpdateRegion.left)
		return;

	// compute the correct position :

	if(positionAbsolute.top<gi->rcUpdateRegion.top){
		clipping.top=gi->rcUpdateRegion.top-positionAbsolute.top;
		positionAbsolute.top=gi->rcUpdateRegion.top;
	}else{
		clipping.top=0;
	}
	if(positionAbsolute.bottom>gi->rcUpdateRegion.bottom){
		clipping.bottom=sizeSurface.bottom-(positionAbsolute.bottom-gi->rcUpdateRegion.bottom);
		positionAbsolute.bottom=gi->rcUpdateRegion.bottom;
	}else{
		clipping.bottom=sizeSurface.bottom;
	}
	if(positionAbsolute.left<gi->rcUpdateRegion.left){
		clipping.left=gi->rcUpdateRegion.left-positionAbsolute.left;
		positionAbsolute.left=gi->rcUpdateRegion.left;
	}else{
		clipping.left=0;
	}
	if(positionAbsolute.right>gi->rcUpdateRegion.right){
		clipping.right=sizeSurface.right-(positionAbsolute.right-gi->rcUpdateRegion.right);
		positionAbsolute.right=gi->rcUpdateRegion.right;
	}else{
		clipping.right=sizeSurface.right;
	}

	HRESULT hres;
	if(isClickable){
		if(backGrnd!=NULL){
			backGrnd->setNumImage(state);
			//now print image :
			backGrnd->paint(lpDDraw,x,y);
		}
	}

	if(clipping.right-clipping.left>0&&clipping.bottom-clipping.top>0){
		bool shouldRepaint=false;
		if(color!=previousColor){
			myColor[state]=color;
			this->setText(myText,false);
		}
		//now print text :
		//hres= gi->window->BltFast(lpDDraw,&positionAbsolute, render,&clipping, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
		hres= gi->window->BltFast(lpDDraw,&positionAbsolute, render,&clipping,NULL,NULL);
		if (hres != DD_OK)
			LocalisedString::explainFailDirectDraw(hres,L"MyLabel Blt(previousColor);");
	}
};
void MyLabel::computeRealAlpha( COLORREF color )
{
	//release Bitmap
	SelectObject(render->deviceInterface, render->oldObj);

	BITMAP bmData;
	GetObject(render->bitmap, sizeof(bmData), &bmData);

	if(bmData.bmBits==NULL){
		//Convert bitmap to access to buffer:
		Element::ConvertToDIB(render->bitmap);
		GetObject(render->bitmap, sizeof(bmData), &bmData);
	}

	DWORD alphaValue=0;
	if(bmData.bmBitsPixel>16){
		//nothing to do
		return;
	}

	PixelFormat pixelFormat;
	BitmapData bmDataRGBA = {0};
	int nStride = bmData.bmWidth * 4;// nbBit -> 32/8

	bmDataRGBA.Width = bmData.bmWidth;
	bmDataRGBA.Height = bmData.bmHeight;
	bmDataRGBA.Stride = nStride;
	int widthS=bmDataRGBA.Stride/4;
	bmDataRGBA.PixelFormat=PixelFormat32bppARGB;

	const WCHAR* tmp=myText.c_str();

	DWORD* bitsRGBA=new DWORD[widthS*bmDataRGBA.Height];

	uchar* bits=((uchar*)bmData.bmBits);
	DWORD alphaMix=0;
	WORD red,green,blue,alphaPreMult;
	red=((color&0x00FF0000)>>16);
	green=((color&0x0000FF00)>>8);
	blue=((color&0x000000FF));
	for (int i=0;i<bmData.bmHeight;i++)
	{
		for(int j=0;j<widthS;j++){
			alphaValue=*((WORD*)(&bits[i*bmData.bmWidthBytes+j*sizeof(WORD)]));
			if(alphaValue!=0){
				alphaPreMult=((((DWORD)(0x7C00&alphaValue)) >> 10)+(((DWORD)(0x03E0&alphaValue)) >>5)+(((DWORD)(0x001F&alphaValue))))/3.0;
				alphaPreMult=alphaPreMult<<3;//5bits->8bits
				alphaMix=alphaPreMult<<24;
				bitsRGBA[i*bmData.bmWidth+j]=alphaMix|RGB(red*alphaPreMult/0xFF,green*alphaPreMult/0xFF,blue*alphaPreMult/0xFF);
			}else
				bitsRGBA[i*bmData.bmWidth+j]=(DWORD)0;
		}
	}
	bmDataRGBA.Scan0 = bitsRGBA;

	DirectDrawWarp::deleteSurf(&render);
	render=new DIRECTDRAW_GDI;
	render->directDrawSurf=NULL;

	render->bitmap = CreateBitmap( bmDataRGBA.Width, bmDataRGBA.Height, 1, GetPixelFormatSize( bmDataRGBA.PixelFormat ), bmDataRGBA.Scan0 );
	render->nbBPP=32;

	render->deviceInterface = CreateCompatibleDC(NULL);
	if (!render->deviceInterface) {
		LocalisedString::explainFail(LocalisedString::szGetDC,L"computeRealAlpha: CreateCompatibleDC(NULL);");
		return;
	}
	render->oldObj=SelectObject(render->deviceInterface, render->bitmap);
	delete []bitsRGBA;
}

void MyLabel::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){
	if(!isVisible)
		return;
	this->paintColor(lpDDraw,x,y,myColor[state],NULL);

	//set the real positions...
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.left=this->getLeft()+x;
};


void MyLabel::setBkg(DIRECTDRAW_GDI *surf){
	if(backGrnd!=NULL)
		backGrnd->changeImg(surf);
	else{
		backGrnd=NULL;
	}
};

void MyLabel::changeVisibility(bool vis,bool eraseBckground){
	if(isVisible!=vis){
		isVisible=vis;
		if(vis)
			vis=false;
		positionAbsolute.right=positionAbsolute.left+this->getWidth()+paddingLeft;
		if(positionAbsolute.right>GetSystemMetrics(SM_CXSCREEN))
			positionAbsolute.right=GetSystemMetrics(SM_CXSCREEN);
		if(positionAbsolute.left<0)
			positionAbsolute.left=0;
		positionAbsolute.bottom=positionAbsolute.top+this->getHeight()+paddingTop;
		if(positionAbsolute.bottom>GetSystemMetrics(SM_CYSCREEN))
			positionAbsolute.bottom=GetSystemMetrics(SM_CYSCREEN);
		if(positionAbsolute.top<gi->rs.top)
			positionAbsolute.top=gi->rs.top;
		if(positionAbsolute.bottom-positionAbsolute.top>0&&
			positionAbsolute.right-positionAbsolute.left>0){
				gi->window->addToRedraw(positionAbsolute,eraseBckground);
		}
	}
};