#include "../../Library/SDK_Manila_Sense.h"

DIRECTDRAW_GDI *MyPanel::bkgSurfaceSrc=NULL;
DIRECTDRAW_GDI *MyPanel::separator=NULL;
int MyPanel::TITLE_PANEL_HEIGHT=0;
int MyPanel::bkgSurfaceSrcWidth=0;
int MyPanel::separatorWidth=0;
LPCRITICAL_SECTION MyPanel::criticAdd=NULL;

void MyPanel::loadSurf(){
	if(criticAdd==NULL){
		criticAdd=new CRITICAL_SECTION;
		InitializeCriticalSection(criticAdd);
	}
	if(bkgSurfaceSrc==NULL&&hasTitle){
		bkgSurfaceSrc=loadImage(gi->bg_common_divider_section);

		TITLE_PANEL_HEIGHT=bkgSurfaceSrc->height;
		bkgSurfaceSrcWidth=bkgSurfaceSrc->width;
	}
	if(separator==NULL&&hasSeparator){
		separator=loadImage(gi->bg_common_dotline);
		separatorWidth=separator->width;
	}

	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);

	if(this->getRight()==dwHeight){
		this->setRight(dwWidth);
		rcTitle.right=dwWidth;
	}
	if(bkgSurface==NULL)
		computeSurface();
	
}

MyPanel::MyPanel(int idElement, int x,int y,int width,wstring title,bool hT,bool hS):Element(idElement, x,y,TYPE_PANEL)
{
	if(width>0)
		this->setWidth(width);
	else
		this->setWidth(gi->rs.right);

	bkgSurface=NULL;
	this->title=title;
	this->components.clear();
	heightComp.clear();
	isAlone.clear();
	hasTitle=hT;
	hasSeparator=hS;

	loadSurf();

	//for now, Section contain only title (if wanted) :
	if(hasTitle)
		this->setHeight(TITLE_PANEL_HEIGHT);
	else
		this->setHeight(0);

	rcTitle.left=getLeft();
	rcTitle.right=getRight();
	rcTitle.top=getTop();
	rcTitle.bottom=rcTitle.top+TITLE_PANEL_HEIGHT;
}

MyPanel::~MyPanel(void)
{
	int taille=this->components.size();
	for(int i=0;i<taille;i++){
		if(this->components[i]!=NULL){
			delete this->components[i];
			this->components[i]=NULL;
		}
	}
}

void MyPanel::changeTitle(wstring t){
	if(title==L""){
		hasTitle=false;
		return;
	}
	hasTitle=true;
	title=t;
	computeSurface();
}
void MyPanel::computeSurface(){
	if(!hasTitle)
		return;
	DirectDrawWarp::deleteSurf(&bkgSurface);

	bkgSurface=new DIRECTDRAW_GDI;
	DDSURFACEDESC ddsd;
	HRESULT hres;
	//copy the surface :

	// Get size of the bitmap
	memset(&ddsd, 0, sizeof(ddsd));
	ddsd.dwSize = sizeof(ddsd);
	ddsd.dwFlags = DDSD_HEIGHT | DDSD_WIDTH;
	ddsd.dwWidth=bkgSurfaceSrcWidth;
	ddsd.dwHeight=bkgSurfaceSrc->height;

	// Create a copy for this bitmap
	hres =DirectDrawWarp::createSurf(&ddsd, bkgSurface);
	if(hres != DD_OK)
		LocalisedString::explainFailDirectDraw(hres, L"computeSurface(bkgSurface);");

#ifdef DRAWING_DDRAW
	DDCOLORKEY ddck;
	memset(&ddck, 0, sizeof(ddck));
	ddck.dwColorSpaceHighValue = BACKGROUND_COLOR_MANILA;
	ddck.dwColorSpaceLowValue = ddck.dwColorSpaceHighValue;
	hres = bkgSurface->directDrawSurface->SetColorKey(DDCKEY_SRCBLT,&ddck);
	if (hres != DD_OK)
		LocalisedString::explainFailDirectDraw(hres,L"bkgSurface SetColorKey");
	// copy content :
#endif

	RECT posPatch={0,0,bkgSurfaceSrcWidth,TITLE_PANEL_HEIGHT};
	if ((hres = gi->window->BltFast(bkgSurface,NULL, bkgSurfaceSrc,&posPatch,DDBLT_WAITNOTBUSY, NULL)) != DD_OK)
		LocalisedString::explainFailDirectDraw(hres, L"computeSurface(Blt);");
	
	//print title on :

	HDC hdc=bkgSurface->deviceInterface;

	RECT posText={5,0,getWidth(),TITLE_PANEL_HEIGHT};
	posText.top-=5;
	posText.left+=5;

	SetTextColor(hdc,RGB(255,255,255));
	SetBkMode(hdc,TRANSPARENT);
	DrawText(hdc,title.c_str(),title.length(),&posText,DT_SINGLELINE|DT_VCENTER);

}

Element* MyPanel::isClicked(int x,int y){
	//can't be clicked directly... but the other components :------------------------
	Element* out=NULL;

	int taille=this->components.size();
	for(int i=0;i<taille;i++){
		if(this->components[i]!=NULL){
			out=this->components[i]->isClicked(x,y);
			if(out!=NULL)
				return out;
		}
	}
	return out;
};

void MyPanel::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){
	//-----------------------------start by our title :------------------------
	HRESULT hres;

	if(hasTitle){
		//is the background for Title loaded ?
		if(bkgSurface==NULL){
			computeSurface();
		}

		positionAbsolute.top=rcTitle.top+y;
		positionAbsolute.bottom=rcTitle.bottom+y;
		positionAbsolute.left=rcTitle.left+x;
		positionAbsolute.right=rcTitle.right+x;

		//are we in the window ?
		//if out of screen, do nothing...
		if(!(positionAbsolute.top>=gi->rcUpdateRegion.bottom||positionAbsolute.bottom<=gi->rcUpdateRegion.top||
			positionAbsolute.left>=gi->rcUpdateRegion.right||positionAbsolute.right<=gi->rcUpdateRegion.left||
			gi->rcUpdateRegion.bottom-gi->rcUpdateRegion.top==0)){

				if(positionAbsolute.top<gi->rcUpdateRegion.top){
					clipping.top=gi->rcUpdateRegion.top-positionAbsolute.top;
					positionAbsolute.top=gi->rcUpdateRegion.top;
				}else{
					clipping.top=0;
				}
				if(positionAbsolute.bottom>gi->rcUpdateRegion.bottom){
					clipping.bottom=(rcTitle.bottom-rcTitle.top)-(positionAbsolute.bottom-gi->rcUpdateRegion.bottom);
					positionAbsolute.bottom=gi->rcUpdateRegion.bottom;
				}else{
					clipping.bottom=(rcTitle.bottom-rcTitle.top);
				}
				if(positionAbsolute.left<gi->rcUpdateRegion.left){
					clipping.left=gi->rcUpdateRegion.left-positionAbsolute.left;
					positionAbsolute.left=gi->rcUpdateRegion.left;
				}else{
					clipping.left=0;
				}
				if(positionAbsolute.right>gi->rcUpdateRegion.right){
					positionAbsolute.right=gi->rcUpdateRegion.right;
					clipping.right=clipping.left+(positionAbsolute.right-positionAbsolute.left);
				}else{
					clipping.right=bkgSurfaceSrcWidth;
				}


				if(positionAbsolute.bottom-positionAbsolute.top>0&&
					clipping.right-clipping.left>0&&clipping.left>=0){
					if(bkgSurfaceSrcWidth<positionAbsolute.right){
						RECT clTmp={bkgSurfaceSrcWidth-(positionAbsolute.right-bkgSurfaceSrcWidth),clipping.top,
							bkgSurfaceSrcWidth,clipping.bottom};
						RECT posTmp={bkgSurfaceSrcWidth,positionAbsolute.top,
							positionAbsolute.right,positionAbsolute.bottom};

						hres= gi->window->BltFast(lpDDraw,&posTmp, bkgSurfaceSrc,&clTmp, DDBLT_WAITNOTBUSY,NULL);
						if (hres != DD_OK){
							LocalisedString::explainFailDirectDraw(hres,L"MyPanel Blt(bkgSurface);");
							return;
						}
						positionAbsolute.right=posTmp.left;
						clipping.right=clTmp.right;
					}
					//now print background :
					hres= gi->window->BltFast(lpDDraw,&positionAbsolute, bkgSurface,&clipping, DDBLT_WAITNOTBUSY,NULL);
					if (hres != DD_OK){
						LocalisedString::explainFailDirectDraw(hres,L"MyPanel:paint Blt");
					}
				}

				//set the real positions...
				positionAbsolute.top=this->getTop()+y;
				positionAbsolute.left=this->getLeft();

		}

		y+=TITLE_PANEL_HEIGHT;
	}
	y+=this->getTop();
	x+=this->getLeft();

	//-----------------------------now the other components :------------------------

	positionAbsolute.left=x;
	positionAbsolute.right=this->getWidth()+x;
	if(positionAbsolute.right>gi->rs.right)
		positionAbsolute.right=gi->rs.right;
	
	RECT srcSeparator={0,0,this->getWidth(),1};
	if(srcSeparator.right>separatorWidth)
		srcSeparator.right=separatorWidth;
	RECT destSeparator=positionAbsolute;

	int maxSize=0;

	if(y+this->getHeight()<0||y>=gi->rs.bottom){
		return;//exit : we are totally out of screen...
	}
	if(this->components.size()>0&&this->components[0]!=NULL){
		this->components[0]->paint(lpDDraw,x,y);

		int taille=this->components.size();
		for(int i=1;i<taille;i++){
			if(this->heightComp[i-1]>maxSize)
				maxSize=this->heightComp[i-1];
			//where are we now ?
			if(this->isAlone[i]){
				y+=maxSize+PADDING_PANEL_H;
				maxSize=0;
			}

			if(hasSeparator&&this->isAlone[i]){
				y+=PADDING_PANEL_H;
				if(y-PADDING_PANEL_H+1<=gi->rcUpdateRegion.bottom&&y-PADDING_PANEL_H>=gi->rcUpdateRegion.top){//we are in screen :
					positionAbsolute.top=y-PADDING_PANEL_H;//only 1 height...
					positionAbsolute.bottom=y-PADDING_PANEL_H+1;
					destSeparator=positionAbsolute;
					while(separatorWidth<destSeparator.right-destSeparator.left){
						int leftTmp=(destSeparator.right-destSeparator.left)-separatorWidth;
						if (leftTmp>separatorWidth)
						{
							leftTmp=separatorWidth;
						}
						RECT clTmp={0,0,leftTmp,1};
						RECT posTmp={destSeparator.right-leftTmp,destSeparator.top,
							destSeparator.right,destSeparator.bottom};

						//first erase:
						hres= gi->window->BltFast(lpDDraw,&posTmp, gi->background,&clTmp, DDBLT_WAITNOTBUSY,NULL);
						hres= gi->window->BltFast(lpDDraw,&posTmp, separator,&clTmp, DDBLT_WAITNOTBUSY,NULL);
						if (hres != DD_OK){
							LocalisedString::explainFailDirectDraw(hres,L"MyPanel Blt(bkgSurface);");
							return;
						}
						destSeparator.right=posTmp.left;
						srcSeparator.right=separatorWidth;
					}
					//now print separator :
					hres= gi->window->BltFast(lpDDraw,&destSeparator, gi->background,&srcSeparator, DDBLT_WAITNOTBUSY,NULL);
					hres= gi->window->BltFast(lpDDraw,&destSeparator, separator,&srcSeparator, DDBLT_WAITNOTBUSY,NULL);
					if (hres != DD_OK)
						LocalisedString::explainFailDirectDraw(hres,L"MyPanel::paint Blt");
				}
				
				y++;
			}

			if(this->components[i]!=NULL){
				this->components[i]->paint(lpDDraw,x,y);
			}
		}
	}
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.left=this->getLeft()+x;
};

void MyPanel::add(Element* e,int minHeight,int pos,bool mixWithOther){

	EnterCriticalSection(criticAdd);
	int prevBottom=this->getBottom();
	minHeight=minHeight*gi->percentOfVGA;
	e->owner=this;
	int cSize=components.size();
	int heightElem=e->getBottom();
	if(heightElem<minHeight){
		heightElem=minHeight;
	}
	if(pos<0||pos>=cSize){
		this->components.push_back(e);
		heightComp.push_back(heightElem);
		isAlone.push_back(true);
		if(hasSeparator)
			this->setBottom(this->getBottom()+heightElem+2*PADDING_PANEL_H+1);
		else
			this->setBottom(this->getBottom()+heightElem+PADDING_PANEL_H);
	}else{
		if(pos>=0){
			int maxHeight=0;
			components.push_back(NULL);
			heightComp.push_back(0);
			isAlone.push_back(false);
			//move items :
			int i;
			for(i=cSize;i>pos;i--){
				components[i]=components[i-1];
				isAlone[i]=isAlone[i-1];
				heightComp[i]=heightComp[i-1];
				if(maxHeight<heightComp[i])
					maxHeight=heightComp[i];
				if(isAlone[i]&&i!=pos+1)
					maxHeight=0;
			}
			isAlone[pos+1]=false;
			components[pos+1]=e;
			heightComp[pos+1]=heightElem;
			while(i>=0&&!isAlone[i]){
				if(maxHeight<heightComp[i])
					maxHeight=heightComp[i];
				i--;
			}
			if(i>=0){//the first item...
				if(maxHeight<heightComp[i])
					maxHeight=heightComp[i];
			}
			if(maxHeight<heightElem)
				this->setBottom(this->getBottom()+heightElem-maxHeight);
		}
	}
	if(owner!=NULL){
		owner->setBottom(owner->getBottom()+this->getBottom()-prevBottom);//update owner...
	}
	LeaveCriticalSection(criticAdd);
};
Element* MyPanel::remove(int pos,int nb){
	int taille=this->components.size();
	if(pos>=taille)
		return NULL;
	EnterCriticalSection(criticAdd);
	if(pos+nb>taille||nb<0)
		nb=taille-pos;
	Element*out=this->components[pos];
	int i=0;
	for(i=pos;i<taille-nb;i++){
		this->components[i]=this->components[i+nb];
		this->isAlone[i]=this->isAlone[i+nb];
		this->heightComp[i]=this->heightComp[i+nb];
	}
	for(i=0;i<nb;i++){
		this->components.pop_back();
		heightComp.pop_back();
	}
	//What is the new size?
	taille=this->heightComp.size();
	int height=0;
	int maxHeight=0;
	for(int i=0;i<taille;i++){
		if(maxHeight<heightComp[i])
			maxHeight=heightComp[i];
		if(isAlone[i]){
			height+=maxHeight;
			maxHeight=0;
		}
	}
	int prevBottom=this->getBottom();
	this->setBottom(height);
	if(owner!=NULL&&this->getBottom()-prevBottom!=0){
		owner->setBottom(owner->getBottom()+this->getBottom()-prevBottom);//update owner...
	}
	LeaveCriticalSection(criticAdd);
	return out;
};
void MyPanel::sizeChanged(Element* src,int w,int h){
	int i=0,sizeTab=components.size();
	while(i<sizeTab&&src!=components[i])
		i++;
	if(i>=sizeTab)
		return;
	int prevHeight=heightComp[i];
	if(prevHeight<h){
		heightComp[i]=h;
		setHeight(getHeight()+(h-prevHeight));
	}
}