#include "../../Library/SDK_Manila_Sense.h"

void MyPictureBox::loadSurf(){

	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);
	if(this->getRight()==dwHeight){
		this->setRight(dwWidth);
	}
}

MyPictureBox::MyPictureBox(int idElement, int x,int y,DIRECTDRAW_GDI *i,int nbImg):Element(idElement, x,y,TYPE_PICTURE){
	pImage=i;
	nbMaxImage=nbImg;
	widthImg=0;
	if(i!=NULL){
		widthImg=pImage->width/nbMaxImage;
		this->setWidth(widthImg);
		this->setHeight(pImage->height);
	}
	loadSurf();
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;

	numImage=0;
	this->canScal=false;
};

MyPictureBox::MyPictureBox(int idElement, int x,int y,wstring img,int nbImg,bool rescall):Element(idElement,x,y,TYPE_PICTURE)
{
	this->pImage=Element::loadImage(&img,rescall);
	nbMaxImage=nbImg;
	widthImg=pImage->width/nbMaxImage;

	this->setWidth(widthImg);
	this->setHeight(pImage->height);
	loadSurf();
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;
	numImage=0;
	this->canScal=false;
}

MyPictureBox::~MyPictureBox(void)
{
	DirectDrawWarp::deleteSurf(&pImage);
}


void MyPictureBox::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){

	if(pImage==NULL)//prob with IMG!!!
		return;

	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.bottom=positionAbsolute.top+this->getHeight();
	positionAbsolute.left=this->getLeft()+x;
	positionAbsolute.right=positionAbsolute.left+getWidth();

	double scallingX=(double)widthImg/(double)getWidth();
	double scallingY=(double)pImage->height/(double)getHeight();
	if(!canScal){
		scallingX=1;
		scallingY=1;
	}

	//are we in the window ?
	//if out of screen, do nothing...
	if(positionAbsolute.top>=gi->rcUpdateRegion.bottom||positionAbsolute.bottom<=gi->rcUpdateRegion.top||
		positionAbsolute.left>=gi->rcUpdateRegion.right||positionAbsolute.right<=gi->rcUpdateRegion.left)
		return;

	if(positionAbsolute.top<gi->rcUpdateRegion.top){
		clipping.top=(gi->rcUpdateRegion.top-positionAbsolute.top)*scallingY;
		positionAbsolute.top=gi->rcUpdateRegion.top;
	}else{
		clipping.top=0;
	}
	if(positionAbsolute.bottom>gi->rcUpdateRegion.bottom){
		clipping.bottom=pImage->height-(positionAbsolute.bottom-gi->rcUpdateRegion.bottom)*scallingY;
		positionAbsolute.bottom=gi->rcUpdateRegion.bottom;
	}else{
		clipping.bottom=pImage->height;
	}
	if(positionAbsolute.left<gi->rcUpdateRegion.left){
		clipping.left=(numImage)*widthImg+(gi->rcUpdateRegion.left-positionAbsolute.left)*scallingX;
		positionAbsolute.left=gi->rcUpdateRegion.left;
	}else{
		clipping.left=(numImage)*widthImg;
	}
	if(positionAbsolute.right>gi->rcUpdateRegion.right){
		clipping.right=(numImage+1)*widthImg-(positionAbsolute.right-gi->rcUpdateRegion.right)*scallingX;
		positionAbsolute.right=gi->rcUpdateRegion.right;
	}else{
		clipping.right=(numImage+1)*widthImg;
	}
	HRESULT hres;
	if(!canScal&&widthImg<positionAbsolute.right-positionAbsolute.left){
		RECT clTmp={clipping.left+5,clipping.top,
			clipping.left+6,clipping.bottom};
		RECT posTmp={positionAbsolute.left,positionAbsolute.top,
			positionAbsolute.left+((positionAbsolute.right-positionAbsolute.left)-widthImg),positionAbsolute.bottom};

		hres= gi->window->BltFast(lpDDraw,&posTmp, pImage,&clTmp, DDBLT_WAITNOTBUSY,NULL);
		if (hres != DD_OK){
			LocalisedString::explainFailDirectDraw(hres,L"MyPictureBox Blt(max)");
			return;
		}
		positionAbsolute.left=posTmp.right;
	}
	hres= gi->window->BltFast(lpDDraw,&positionAbsolute, pImage,&clipping, DDBLT_WAITNOTBUSY,NULL);
	if (hres != DD_OK){
		LocalisedString::explainFailDirectDraw(hres,L"MyPictureBox Blt(rest)");
		return;
	}

	//set the real positions...
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.left=this->getLeft()+x;
};

Element* MyPictureBox::isClicked(int x,int y){

	if(x>positionAbsolute.left&&x<positionAbsolute.right&&y>positionAbsolute.top&&y<positionAbsolute.bottom){
		this->isActivated=true;
		return this;
	}
	return NULL;
};