#include "../../Library/SDK_Manila_Sense.h"

DIRECTDRAW_GDI *MySelector::header=NULL;
DIRECTDRAW_GDI *MySelector::listBottom=NULL;
DIRECTDRAW_GDI *MySelector::listMiddle=NULL;
int MySelector::elementListWidth=0;
int MySelector::elementWidth=0;
int MySelector::elementHeight=0;

void MySelector::loadSurf(){

	if(header==NULL){
		header=loadImage(gi->btn_common_combo_down);
		elementWidth=header->width/4;
		elementHeight=header->height;
		//header->directDrawSurface->SetColorKey(DDCKEY_SRCBLT,&ddck);
	}
	if(listBottom==NULL){
		listBottom=loadImage(gi->btn_common_listitem_bottom);
		//listBottom->directDrawSurface->SetColorKey(DDCKEY_SRCBLT,&ddck);
	}
	if(listMiddle==NULL){
		listMiddle=loadImage(gi->btn_common_listitem_middle);
		elementListWidth=listMiddle->width/4;
		//listMiddle->directDrawSurface->SetColorKey(DDCKEY_SRCBLT,&ddck);
	}

	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);

	if(dwWidth > dwHeight){//center the item:
		if(paddingSup==0){
			double diff=dwWidth- dwHeight;
			paddingSup=diff/2;
			if(this->getRight()+paddingSup<dwWidth){
				this->setRight(this->getRight()+paddingSup);
				this->setLeft(this->getLeft()+paddingSup);
			}else{
				paddingSup=0;
			}
		}
	}else{
		if(paddingSup!=0){
			this->setRight(this->getRight()-paddingSup);
			this->setLeft(this->getLeft()-paddingSup);
			paddingSup=0;
		}
	}
	
}
MySelector::MySelector(int idElement, int x,int y,wstring nameOfChoice):Element(idElement, x,y,TYPE_SELECTOR)
{
	backgroundIsCaptured=true;
	backgroundBuff=NULL;
	loadSurf();
	itemChoose=-1;

	this->setHeight(header->height);
	this->setWidth(elementWidth);
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;

	values=new MyPanel(-1,5,0,elementListWidth-10,L"",false,true);
	//need to be set with real coordinate :
	title=new MyLabel(-1,5,0,(elementListWidth-30)/gi->percentOfVGA,elementHeight/gi->percentOfVGA,nameOfChoice);
	title->isClickable=true;
	title->center();

	container=NULL;//the owner of the edit control...
	animation=false;
	isOpen=false;
	hasPaintingHook=false;
	animToVisibility=false;
	state=SELECT_STATE_NORMAL;
	selected=NULL;
	animIndex=0;
}

MySelector::~MySelector(void)
{
}

bool MySelector::run(bool isRightClicked){
	Element::run(isRightClicked);

	if(state!=SELECT_STATE_HOVER){
		return false;
	}
	if(values->getSize()==0)
		return false;

	container=(Section*)this->mouseEvent->changeMouseAnalyse(this);
	this->state=SELECT_STATE_SELECTED;
	this->setMustRedraw();

	animToVisibility=true;//slide up to open the entire list...
	animation=false;//animation to open the list...
	isOpen=false;
	animIndex=0;
	if(backgroundBuff!=NULL)
		DirectDrawWarp::deleteSurf(&backgroundBuff);

	//backbuffer...
	DDSURFACEDESC DDSurfDesc;
	memset(&DDSurfDesc, 0, sizeof(DDSurfDesc));
	DDSurfDesc.dwSize = sizeof(DDSurfDesc);
	DDSurfDesc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT;
	DDSurfDesc.dwWidth = gi->rs.right;
	DDSurfDesc.dwHeight = gi->rs.bottom;

	backgroundBuff=new DIRECTDRAW_GDI;
	//HRESULT hret=(*gi->ldDDraw)->CreateSurface(&DDSurfDesc, &gi->background->directDrawSurface, NULL );
	HRESULT hret=DirectDrawWarp::createSurf(&DDSurfDesc, backgroundBuff);
	if (hret != DD_OK)
		LocalisedString::explainFailDirectDraw(hret,L"MySelector CreateSurface");
	backgroundIsCaptured=true;//for now, background don't need update

	// Create a timer to show scrolling up
	SetTimer(gi->m_hWnd, 1, MS_PER_FRAME, NULL);
	startSlide=GetTickCount();

	return true;
}
void MySelector::unClick(){
	if(this->state==SELECT_STATE_HOVER){
		this->state=SELECT_STATE_NORMAL;
		setMustRedraw();
	}
	//give the mouse control :
	if(container!=NULL){
		state=SELECT_STATE_NORMAL;
		if(backgroundBuff!=NULL)
			DirectDrawWarp::deleteSurf(&backgroundBuff);
		isOpen=false;
		gi->rcUpdateRegion=gi->rs;
		container->setDrawingHook(NULL);
		container->verifScrollingRange(0,false);
		hasPaintingHook=false;
		this->mouseEvent->changeMouseAnalyse(container);
		mouseEvent->setClickSelected(false);

		animation=false;
		isOpen=false;
		gi->window->addToRedraw(gi->rs,true);
	}

};

Element* MySelector::isClicked(int x,int y){
	if(state==SELECT_STATE_DSBL){
		return NULL;
	}
	if(positionAbsolute.right==positionAbsolute.bottom&&
		positionAbsolute.bottom==0)
		return NULL;//OUT of screen, can't be clicked !

	if(x>positionAbsolute.left&&x<positionAbsolute.left+getWidth()&&
		y>positionAbsolute.top-gi->rcVisibleDesktopTOP.top&&y<positionAbsolute.top-gi->rcVisibleDesktopTOP.top+this->getHeight()){
			this->isActivated=true;
			if(this->state==SELECT_STATE_NORMAL){
				this->state=SELECT_STATE_HOVER;
				setMustRedraw();
			}
		return this;
	}
	return NULL;
};

void MySelector::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){

	if(hasPaintingHook){
		y=lastY;//restore correct value
		if(!backgroundIsCaptured){
			backgroundIsCaptured=true;
			gi->window->BltFast(backgroundBuff,&gi->rs,gi->primaryBuffer,&gi->rs,NULL,NULL);
		}
	}else
		lastY=y;
	HRESULT hres;

	//print the header :
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.bottom=positionAbsolute.top+this->getHeight();
	positionAbsolute.left=this->getLeft()+x;
	positionAbsolute.right=positionAbsolute.left+getWidth();

	if(animation){

		DWORD timeL=(GetTickCount()-startSlide);
		//startSlide=GetTickCount();
		double accel=((double)values->getHeight())/(300.0*50.0);

		int dist=(accel*(timeL*timeL))/2.0;
		if(dist<values->getHeight()){
			animIndex=dist;
		}else{
			animIndex=values->getHeight();
			animation=false;
			isOpen=true;
			//stop timer:
			KillTimer(gi->m_hWnd, 1);
		}
		if(animIndex>0){//optimisation:if not open, don't print)
			gi->rcUpdateRegion=positionAbsolute;
			gi->rcUpdateRegion.top=this->getTop()+y+this->getHeight();
			gi->rcUpdateRegion.bottom=gi->rcUpdateRegion.top+animIndex;
			if(gi->rcUpdateRegion.bottom>gi->rs.bottom)
				gi->rcUpdateRegion.bottom=gi->rs.bottom;

			if(backgroundBuff!=NULL)
				gi->window->BltFast(lpDDraw,&gi->rcUpdateRegion,backgroundBuff,&gi->rcUpdateRegion,NULL,NULL);
			//container->paint(lpDDraw,0,0);
			//show the items :
			this->values->paint(lpDDraw,
				positionAbsolute.left,this->getTop()+y+this->getHeight()-4+animIndex-values->getHeight());
		}
	}else{
		if(isOpen){
			//show the items :

			if(backgroundBuff!=NULL)
				gi->window->BltFast(lpDDraw,&gi->rcUpdateRegion,backgroundBuff,&gi->rcUpdateRegion,NULL,NULL);
			//container->paint(lpDDraw,0,0);
			this->values->paint(lpDDraw,positionAbsolute.left,this->getTop()+y+this->getHeight()-4+listDY);
			gi->mustRedraw=false;
		};
	}


	//are we in the window ?
	//if out of screen, do nothing...
	if(!(positionAbsolute.top>=gi->rcUpdateRegion.bottom||positionAbsolute.bottom<=gi->rcUpdateRegion.top||
		positionAbsolute.left>=gi->rcUpdateRegion.right||positionAbsolute.right<=gi->rcUpdateRegion.left)){

			int top=gi->rcUpdateRegion.top;
			if(top<gi->rs.top)//because we erase the background later !
				top=gi->rs.top;
			if(positionAbsolute.top<top){
				clipping.top=top-positionAbsolute.top;
				positionAbsolute.top=top;
			}else{
				clipping.top=0;
			}
			if(positionAbsolute.bottom>gi->rcUpdateRegion.bottom){
				clipping.bottom=this->getHeight()-(positionAbsolute.bottom-gi->rcUpdateRegion.bottom);
				positionAbsolute.bottom=gi->rcUpdateRegion.bottom;
			}else{
				clipping.bottom=this->getHeight();
			}
			if(positionAbsolute.left<gi->rcUpdateRegion.left){
				clipping.left=state*elementWidth+gi->rcUpdateRegion.left-positionAbsolute.left;
				positionAbsolute.left=gi->rcUpdateRegion.left;
			}else{
				clipping.left=state*elementWidth;
			}
			if(positionAbsolute.right>gi->rcUpdateRegion.right){
				clipping.right=(state+1)*elementWidth-(positionAbsolute.right-gi->rcUpdateRegion.right);
				positionAbsolute.right=gi->rcUpdateRegion.right;
			}else{
				clipping.right=(state+1)*elementWidth;
			}

			if (positionAbsolute.bottom-positionAbsolute.top>0)
			{
				hres= gi->window->BltFast(lpDDraw,&positionAbsolute, header,&clipping, NULL,NULL);
				if (hres != DD_OK)
					LocalisedString::explainFailDirectDraw(hres,L"MySelector Blt(header);");
			}

			//render title, if available :
			if(title!=NULL){
				if(state==SELECT_STATE_NORMAL||state==SELECT_STATE_SELECTED)
					this->title->paintColor(lpDDraw,this->getLeft()+x,this->getTop()+y,RGB(5,5,5),RGB565to32(28,56,28));
				else
					if(state==SELECT_STATE_HOVER)
						this->title->paintColor(lpDDraw,this->getLeft()+x,this->getTop()+y,RGB(160,160,160),RGB565to32(6,12,6));
					else
						title->paintColor(lpDDraw,this->getLeft()+x,this->getTop()+y,RGB(160,160,160),RGB565to32(28,56,28));
			}
	}

	if(!hasPaintingHook){
		//set the real positions...
		positionAbsolute.top=this->getTop()+y;
		positionAbsolute.left=this->getLeft()+x;
	}
};


int MySelector::mouseGesture(){
	if(animToVisibility){
		listDY=0;
		bool slideUp=(values->getHeight()+getHeight()>gi->rs.bottom);
		double lengthSlide=0;
		if(slideUp){//here, it's because elements are too big...
			lengthSlide=positionAbsolute.top-gi->rs.top;
			if(lengthSlide<1)
				lengthSlide=0;
		}else{
			//slide up if element don't fit in screen:
			slideUp=(positionAbsolute.bottom+values->getHeight()>gi->rs.bottom);
			lengthSlide=positionAbsolute.bottom+values->getHeight()-gi->rs.bottom;
		}
		if(slideUp&&lengthSlide!=0){
			DWORD timeL=GetTickCount()-startSlide;
			double accel=lengthSlide/(300.0*50.0);

			int dist=-(accel*(timeL*timeL))/2.0;
			if(lengthSlide+dist<0||dist>0)
				dist=-lengthSlide;
			container->slideOverlay(dist);
			gi->mustRedraw=false;
			lengthSlide=dist;
		}
		if(lengthSlide==0){//we can print the component
			mouseEvent->stopScroll();
			startSlide=GetTickCount();
			animToVisibility=false;
			animation=true;
			container->setDrawingHook(this);
			hasPaintingHook=true;
			gi->mustRedraw=true;
			backgroundIsCaptured=false;
		}
		return lengthSlide;
	}

	if(!mouseEvent->pickChange())
		return 0;//do nothing

	if(mouseEvent->isClicked()||mouseEvent->isDblClicked()){
		if(selected!=NULL){
			//first unselect all other items :
			int nbElem=values->getSize();
			for(int i=0;i<nbElem;i++){
				//int stTmp=((MyLabel*)values->getElement(i))->getState();
				if(values->getElement(i)==selected)
					itemChoose=i;
				else
					values->getElement(i)->unClick();
			}
			selected->run();
			setSelection(itemChoose);
		}
		selected=NULL;
		this->unClick();
		return 0;
	}

	if(mouseEvent->isSelected()){
		if(this->selected!=NULL){
			this->selected->unClick();
			this->selected=NULL;
		}
		int posX,posY;
		this->mouseEvent->getMousePosition(posX,posY);
		this->selected=(MyLabel*)values->isClicked(posX,posY);
		if(selected==NULL)
			this->unClick();
	}

	if(!mouseEvent->isSelected()&&this->selected!=NULL){
		this->selected->unClick();
		this->selected=NULL;
	}

	//--------------------------scrolling behavior:

	//get the evolution :
	int dY=this->mouseEvent->getMouseDY();
	int yBottom=dY;
	if(yBottom<listDY)
		yBottom=listDY;
	yBottom=positionAbsolute.bottom+yBottom+values->getHeight();
	if (yBottom<gi->rs.bottom)
	{
		yBottom=gi->rs.bottom;
	}
	RECT updateR={positionAbsolute.left,positionAbsolute.bottom,
		positionAbsolute.right,yBottom};
	gi->window->addToRedraw(updateR,false);
	listDY+=dY;
	int minHeight=gi->rs.bottom/4;
	if(minHeight>values->getHeight())
		listDY=0;
	else
		if(listDY < -values->getHeight()+minHeight)
			listDY = -values->getHeight()+minHeight;
	if(listDY>0)
		listDY=0;
	
	return 0;
};


void MySelector::addItem(wstring word){
	//first find the number of elements :
	int nbElem=values->getSize();

	MyLabel* lab;
	if(nbElem==0){
		lab=new MyLabel(-1,0,0,word,listBottom);
	}else{
		lab=new MyLabel(-1,0,0,word,listBottom);
		((MyLabel*)values->getElement(nbElem-1))->setBkg(listMiddle);//not the last...
	}
	lab->center();
	values->add(lab);
};
int MySelector::getSelection(){
	if(itemChoose>=0)
		return itemChoose;
	int nbElem=values->getSize();
	for(int i=0;i<nbElem;i++){
		if(values->getElement(i)==selected){
			itemChoose=i;
			return i;
		}
	}
	return -1;
};
MyLabel* MySelector::operator[] (unsigned int i){
	int nbElem=values->getSize();
	if(i<nbElem&&i>0)
		return (MyLabel*)values->getElement(i);
	return NULL;
}
void MySelector::updateTitle(wstring wantedTitle){
	if(selected==NULL&&(itemChoose<0||itemChoose>=values->getSize())){
		title->setText(wantedTitle);
	}else{
		if(selected==NULL)
			selected=(MyLabel*)values->getElement(itemChoose);
		title->setText(selected->getText());
	}
	title->center();
	setMustRedraw();
}
void MySelector::setSelection(int idSelect){
	if(idSelect<0||idSelect>=values->getSize())
		return;
	itemChoose=idSelect;
	selected=(MyLabel*)values->getElement(itemChoose);
	if(selected!=NULL){
		selected->run();
		updateTitle();
	}
	getGestEvent()->messageProc(this,EVENT_VALUE_CHANGED);
};