#include "../../Library/SDK_Manila_Sense.h"

DIRECTDRAW_GDI *MySlider::slideSurf=NULL;
DIRECTDRAW_GDI *MySlider::btnSurf=NULL;
MySlider *MySlider::slideRunning=NULL;
int MySlider::widthSlide=0;
int MySlider::heightSlide=0;
int MySlider::widthBtn=0;
int MySlider::heightBtn=0;


void MySlider::loadSurf(){
	if(slideSurf==NULL){
		slideSurf=loadImage(gi->btn_common_slider);
		widthSlide=slideSurf->width/4;
		heightSlide=slideSurf->height;
	}
	if(btnSurf==NULL){
		btnSurf=loadImage(gi->btn_slider);
		widthBtn=btnSurf->width/2;
		heightBtn=btnSurf->height;
	}

	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);

	double diff=dwWidth- dwHeight;
	if(dwWidth > dwHeight){//increase size:
		if(this->getWidth()+diff+getLeft()<dwWidth){
			this->setWidth(this->getWidth()+diff);
		}
	}else{
		if(this->getWidth()+getLeft()>dwWidth){
			this->setWidth(this->getWidth()+diff);//diff<0
		}
	}
	isSliding=false;
	
}

MySlider::MySlider(int idElement, int x,int y,int width,bool visible,
				   int minVal,int maxVal):Element(idElement, x,y,TYPE_SLIDER)
{
	sliderAnim=false;
	width=width*gi->percentOfVGA;
	if (x+width>gi->rs.right)
	{
		width=gi->rs.right-x;
	}
	this->setWidth(width);

	loadSurf();

	this->minVal=minVal;
	this->maxVal=maxVal;

	this->setHeight(heightSlide);
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;

	if(visible)
		state=VIS_SLIDE_NORMAL;
	else
		state=VIS_SLIDE_DISABLED;
	position=minVal;
};

MySlider::MySlider(int idElement, int x,int y,int width,bool visible,
				   double lengthAnim):Element(idElement, x,y,TYPE_SLIDER)
{
	sliderAnim=true;
	width=width*gi->percentOfVGA;
	if (x+width>gi->rs.right)
	{
		width=gi->rs.right-x;
	}
	this->setWidth(width);

	loadSurf();

	this->minVal=0;
	this->maxVal=100;


	this->setHeight(heightSlide);
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;

	if(visible)
		state=VIS_SLIDE_NORMAL;
	else
		state=VIS_SLIDE_DISABLED;
	position=minVal;
}

MySlider::~MySlider(void)
{
}

bool MySlider::run(bool isRightClicked){
	Element::run(isRightClicked);
	return isActivated;
}

void MySlider::unClick(){
	this->isActivated=false;
	//give the mouse control :
	if(container!=NULL){
		this->mouseEvent->changeMouseAnalyse(container);
		mouseEvent->setClickSelected(false);
	}else
		return;//call by container, so we have nothing to do...

	container->unselect();
	container=NULL;
	if(sliderAnim){
		gi->rcUpdateRegion.left=this->positionAbsolute.left;
		gi->rcUpdateRegion.right=this->positionAbsolute.left+this->getWidth();
		gi->rcUpdateRegion.top=this->positionAbsolute.top;
		gi->rcUpdateRegion.bottom=this->positionAbsolute.bottom+this->getHeight();
		isSliding=true;
		gi->mustRedraw=true;
		slideRunning=this;
		// Create a timer to show slider scrolling back
		SetTimer(gi->m_hWnd, 2, MS_PER_FRAME,NULL);
	}
};

Element* MySlider::isClicked(int x,int y){
	if(state!=0)
		return NULL;
	if(positionAbsolute.right==positionAbsolute.bottom&&
		positionAbsolute.bottom==0)
		return NULL;//OUT of screen, can't be clicked !

	if(x>positionAbsolute.left&&x<positionAbsolute.right&&
		y>positionAbsolute.top-gi->rcVisibleDesktopTOP.top&&y<positionAbsolute.top-gi->rcVisibleDesktopTOP.top+this->getHeight()){
			if(sliderAnim){
				double posAbs=widthBtn/2+(this->getWidth()-widthBtn)*(position-minVal)/(double)maxVal;
				if(x<positionAbsolute.left+posAbs-widthBtn/2||x>positionAbsolute.left+posAbs+widthBtn/2)
					return NULL;
			}
			this->isActivated=true;
			// stop timer
			KillTimer(gi->m_hWnd, 2);

			container=(Section*)this->mouseEvent->changeMouseAnalyse(this);
			return this;
	}
	return NULL;
};

void MySlider::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.bottom=positionAbsolute.top+this->getHeight();
	positionAbsolute.left=this->getLeft()+x;
	positionAbsolute.right=positionAbsolute.left+getWidth();

	RECT posClipping=positionAbsolute;

	//are we in the window ?
	//if out of screen, do nothing...
	if(positionAbsolute.top>=gi->rcUpdateRegion.bottom||positionAbsolute.bottom<=gi->rcUpdateRegion.top||
		positionAbsolute.left>=gi->rcUpdateRegion.right||positionAbsolute.right<=gi->rcUpdateRegion.left)
			return;

	if(positionAbsolute.top<gi->rcUpdateRegion.top){
		clipping.top=gi->rcUpdateRegion.top-positionAbsolute.top;
		positionAbsolute.top=gi->rcUpdateRegion.top;
	}else{
		clipping.top=0;
	}
	if(positionAbsolute.bottom>gi->rcUpdateRegion.bottom){
		clipping.bottom=this->getHeight()-(positionAbsolute.bottom-gi->rcUpdateRegion.bottom);
		positionAbsolute.bottom=gi->rcUpdateRegion.bottom;
	}else{
		clipping.bottom=this->getHeight();
	}
	if(positionAbsolute.left<gi->rcUpdateRegion.left){
		clipping.left=gi->rcUpdateRegion.left-positionAbsolute.left;
		positionAbsolute.left=gi->rcUpdateRegion.left;
		posClipping.left=gi->rcUpdateRegion.left;
	}else{
		clipping.left=0;
	}
	if(positionAbsolute.right>gi->rcUpdateRegion.right){
		clipping.right=this->getWidth()-(positionAbsolute.right-gi->rcUpdateRegion.right);
		positionAbsolute.right=gi->rcUpdateRegion.right;
		posClipping.right=gi->rcUpdateRegion.right;
	}else{
		clipping.right=this->getWidth();
	}/*
	clipping.left+=(state)*widthSlide;
	clipping.right+=(state)*widthSlide;*/

	posClipping.bottom=positionAbsolute.bottom;
	posClipping.top=positionAbsolute.top;

	double posAbs=widthBtn/2+(this->getWidth()-widthBtn)*(position-minVal)/(double)maxVal;

	RECT tmp=positionAbsolute;
	RECT tmpSrc=clipping;
	HRESULT hres;
	/*
	// Use the blter to do a color fill to clear the buffer
	DDBLTFX ddbltfx;
	memset(&ddbltfx, 0, sizeof(ddbltfx));
	ddbltfx.dwSize = sizeof(ddbltfx);
	ddbltfx.dwFillColor = RGB(255,0,128);
	tmp.right+=heightSlide/2.0;
	gi->window->BltFast(gi->backBuffer,&posClipping, NULL,NULL, DDBLT_COLORFILL | DDBLT_WAITNOTBUSY, &ddbltfx);
	*/
	gi->window->BltFast(lpDDraw,&posClipping, gi->background,&posClipping, DDBLT_WAITNOTBUSY,NULL);
	
	int decal=getWidth()-10;
	if(decal>widthSlide-10)
		decal=widthSlide-10;
	decal=decal-clipping.left;
	if(decal>0){
		//print [
		tmp.right=tmp.left+decal;
		tmpSrc.left=(state)*widthSlide+clipping.left;
		tmpSrc.right=tmpSrc.left+decal;

		if(tmp.right>positionAbsolute.right){
			tmpSrc.right-=tmp.right-positionAbsolute.right;
			tmp.right=positionAbsolute.right;
		}
		if(tmpSrc.right>=(state+1)*widthSlide){
			tmp.right-=tmpSrc.right-(state+1)*widthSlide-1;
			tmpSrc.right=(state+1)*widthSlide-1;
		}
		hres= gi->window->BltFast(lpDDraw,&tmp, slideSurf,&tmpSrc, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
		if (hres != DD_OK)
			LocalisedString::explainFailDirectDraw(hres,L"MySlider Blt(input [);");
		//for middle :
		tmp.left=tmp.right;
		tmp.right=positionAbsolute.right;
	}
	int savLeft=tmp.left;
	if(clipping.right>this->getWidth()-10&&widthSlide>10){//widthSlide>5 to be sure!
		//print ]
		tmp.left=this->getLeft()+x+getWidth()-10;
		tmp.right=positionAbsolute.right;
		tmpSrc.left=(state+1)*widthSlide-10;
		tmpSrc.right=(state+1)*widthSlide-(getWidth()-clipping.right);
		hres= gi->window->BltFast(lpDDraw,&tmp, slideSurf,&tmpSrc, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
		if (hres != DD_OK)
			LocalisedString::explainFailDirectDraw(hres,L"MySlider Blt(input ]);");
		//for middle :
		tmp.right=tmp.left;
	}

	tmp.left=savLeft;
	if(tmp.left<tmp.right&&widthSlide>10){
		//print middle :
		tmpSrc.left=(state+1)*widthSlide-10;
		tmpSrc.right=tmpSrc.left+1;
		hres= gi->window->BltFast(lpDDraw,&tmp, slideSurf,&tmpSrc, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
		if (hres != DD_OK)
			LocalisedString::explainFailDirectDraw(hres,L"MySlider Blt(input mdl);");
	}


	tmp=positionAbsolute;
	tmpSrc=clipping;
	decal=posAbs;
	if(decal>widthSlide-10)
		decal=widthSlide-10;
	decal=decal-clipping.left;
	if(posAbs>tmpSrc.left&&widthSlide>10){
		if(decal>0){
			//print [
			tmp.right=tmp.left+decal;
			if(tmp.right>positionAbsolute.right)
				tmp.right=positionAbsolute.right;
			tmpSrc.left=(state+1)*widthSlide+clipping.left;
			tmpSrc.right=tmpSrc.left+decal;
			if(tmpSrc.right>=(state+2)*widthSlide)
				tmpSrc.right=(state+2)*widthSlide-1;
			hres= gi->window->BltFast(lpDDraw,&tmp, slideSurf,&tmpSrc, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
			if (hres != DD_OK)
				LocalisedString::explainFailDirectDraw(hres,L"MySlider Blt(input [);");
			//for middle :
			tmp.left=tmp.right;
		}

		tmp.right=x+this->getLeft()+posAbs;
		if(tmp.left<tmp.right){
			//print middle :(
			tmpSrc.left=(state+2)*widthSlide-10;
			tmpSrc.right=tmpSrc.left+1;
			hres= gi->window->BltFast(lpDDraw,&tmp, slideSurf,&tmpSrc, DDBLT_WAITNOTBUSY|DDBLT_KEYSRC,NULL);
			if (hres != DD_OK)
				LocalisedString::explainFailDirectDraw(hres,L"MySlider Blt(input mdl);");
		}
	}

	int top=y+this->getTop()+(heightSlide-heightBtn)/2;
	int left=x+this->getLeft()+posAbs-widthBtn/2;
	RECT posBtn={left,top,
		left+widthBtn,top+heightBtn};
	RECT srcBtn={0,0,widthBtn,heightBtn};
	if(state!=0){
		srcBtn.left+=widthBtn;
		srcBtn.right+=widthBtn;
	}

	/*hres=btnSurf->Draw(hdc, &posBtn, NULL);
	if(hres!=S_OK)
		LocalisedString::explainFailIImage(hres,L"BTN MySlider");
		*/
	gi->window->BltFast(lpDDraw,&posBtn, btnSurf,&srcBtn, NULL,NULL);
/*
	if(posClipping.right-posClipping.left>0&&
		posClipping.bottom-posClipping.top){
		hres= gi->window->BltFast(lpDDraw,&posClipping, gi->backBuffer,&posClipping, DDBLT_WAITNOTBUSY,NULL);
		if (hres != DD_OK)
			LocalisedString::explainFailDirectDraw(hres,L"MySlider Blt(backBuffer);");
	}
	*/

	//set the real positions...
	positionAbsolute.top=this->getTop()+y;
	positionAbsolute.left=this->getLeft()+x;
};


int MySlider::mouseGesture(){

	if(!mouseEvent->isMouseDown()){
		mySpeed=mouseEvent->getMouseDXMean()*MS_PER_FRAME;
		if(mySpeed>20)
			mySpeed=20;
		this->unClick();
		return 0;
	}

	int x,y;
	mouseEvent->getMousePosition(x,y);
	int newX=maxVal*(x-widthBtn/2-this->getLeft())/(this->getWidth()-widthBtn)+minVal;
	if(newX<minVal)
		newX=minVal;
	if(newX>maxVal)
		newX=maxVal;
		
	this->updatePosition(newX);
	return 0;
};
void MySlider::updatePosition(int newPos){
	if(isSliding&&newPos<0){
		if(mySpeed>0){
			mySpeed-=mySpeed/2.0+1;
			newPos=position+mySpeed;
		}else{
			newPos=position-(position-minVal)/2-1;
			if (newPos<=minVal)
			{
				newPos=minVal;
				isSliding=false;
				gi->mustRedraw=false;
				// stop timer
				KillTimer(gi->m_hWnd, 2);
			}
		}
	}
	if(position==newPos)
		return;
	double posAbs=widthBtn/2+(this->getWidth()-widthBtn)*(position-minVal)/(double)maxVal;
	position=newPos;
	if(position>maxVal)
		position=maxVal;
	if(position<minVal)
       		position=minVal;
	double posAbs1=widthBtn/2+(this->getWidth()-widthBtn)*(position-minVal)/(double)maxVal;
	if(posAbs==posAbs1)
		return;
	RECT prev=gi->rcUpdateRegion;
	if(positionAbsolute.bottom>positionAbsolute.top){//must be redraw:
		gi->mustRedraw=true;
		if(posAbs1>posAbs){
			RECT update={getLeft()+posAbs-widthBtn/2,positionAbsolute.top,
				getLeft()+posAbs1+widthBtn/2,positionAbsolute.top+heightSlide};
			//InvalidateRect(gi->m_hWnd,&update,false);
			gi->window->addToRedraw(update,false);
		}else{
			RECT update={getLeft()+posAbs1-widthBtn/2,positionAbsolute.top,
				getLeft()+posAbs+widthBtn/2,positionAbsolute.top+heightSlide};
			//InvalidateRect(gi->m_hWnd,&update,false);
			gi->window->addToRedraw(update,false);
		}
		gi->rcUpdateRegion=prev;
	}
	getGestEvent()->messageProc(this,EVENT_VALUE_CHANGED);
	static int heightBtn;
};