#include "../../Library/SDK_Manila_Sense.h"

DIRECTDRAW_GDI *Section::bkgSurface=NULL;
GDI_OVERLAY *Section::scrollBar=NULL;
int Section::TITLE_SECTION_HEIGHT=0;
int Section::TITLE_SECTION_WIDTH=0;
bool Section::scrollVisible=false;
LPCRITICAL_SECTION Section::criticAdd;

void Section::loadSurf(){
	if(criticAdd==NULL){
		criticAdd=new CRITICAL_SECTION;
		InitializeCriticalSection(criticAdd);
	}
	DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
	DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);
	if(gi->backBuffer==NULL){
		DDSURFACEDESC DDSurfDesc;
		memset(&DDSurfDesc, 0, sizeof(DDSurfDesc));
		DDSurfDesc.dwSize = sizeof(DDSurfDesc);
		DDSurfDesc.dwFlags = DDSD_WIDTH | DDSD_HEIGHT;
		DDSurfDesc.dwWidth = dwWidth;
		DDSurfDesc.dwHeight = dwHeight;

		gi->backBuffer=new DIRECTDRAW_GDI;
		//HRESULT hret=(*gi->ldDDraw)->CreateSurface(&DDSurfDesc, &gi->backBuffer->directDrawSurface, NULL );
		HRESULT hret=DirectDrawWarp::createSurf(&DDSurfDesc, gi->backBuffer);
		if (hret != DD_OK)
			LocalisedString::explainFailDirectDraw(hret,L"Section::loadSurf 0");
	}

	if(bkgSurface==NULL&&!title.empty()){
		const WCHAR * tmp=gi->bg_common_titlebar->c_str();
		bkgSurface=loadImage(gi->bg_common_titlebar);
		TITLE_SECTION_HEIGHT=bkgSurface->height;
		TITLE_SECTION_WIDTH=bkgSurface->width;
	}

	if(scrollBar==NULL){
		DDSURFACEDESC ddsd;
		memset(&ddsd, 0, sizeof(ddsd));
		ddsd.dwSize = sizeof(ddsd);
		ddsd.dwFlags = DDSD_CAPS |DDSD_HEIGHT |DDSD_WIDTH;
		ddsd.dwWidth = SCROLL_WIDTH+1;
		ddsd.dwHeight = dwHeight;
		ddsd.ddsCaps.dwCaps = DDSCAPS_OVERLAY;
		//scrollBar=new GDI_OVERLAY;
		scrollBar = DirectDrawWarp::createOverlay(&ddsd);
		//HRESULT hRet = (*gi->ldDDraw)->CreateSurface(&ddsd, &scrollBar->directDrawSurf, NULL );
		if (scrollBar != NULL){
			DDBLTFX ddbltfx;
			memset(&ddbltfx, 0, sizeof(ddbltfx));
			ddbltfx.dwSize = sizeof(ddbltfx);
			ddbltfx.dwFillColor = 0xA514;
			HRESULT hRet = Section::scrollBar->directDrawSurf->Blt(NULL,NULL,NULL, DDBLT_WAITNOTBUSY|DDBLT_COLORFILL, &ddbltfx);
			if (hRet != DD_OK)
				LocalisedString::explainFailDirectDraw(hRet,L"Fill scrollBar");

			scrollBar->visible=true;
			scrollVisible=true;
		}else{
			delete scrollBar;
			scrollBar=NULL;
		}
	}

	if(this->getRight()==dwHeight){
		this->setRight(dwWidth);
		rcTitle.right=dwWidth;
	}
	gi->rs.top=gi->rcVisibleDesktopTOP.top+TITLE_SECTION_HEIGHT;
}

Section::Section(int idElement, int x,int y,int width,wstring title):Element(idElement,x,y,TYPE_SECTION)
{
	canScroll=true;
	posOverlay=0;
	selectedElement=NULL;
	mouseAnalysePrev=NULL;

	this->title=title;
	if(bkgSurface==NULL){
		loadSurf();
	}
	this->components.clear();
	//for now, Section contain only title :
	this->setWidth(width);
	if(title.empty())
		this->setHeight(0);
	else
		this->setHeight(TITLE_SECTION_HEIGHT);
	positionAbsolute.left=0;
	positionAbsolute.top=0;
	positionAbsolute.right=0;
	positionAbsolute.bottom=0;
	recopiePosition(rcTitle);

	//load background for title :

	if(gi->hFontTitle==NULL&&!title.empty()){
		//------------------------Create new font :--------------------------------

		HDC hdc=gi->backBuffer->deviceInterface;
		// Gets current font
		gi->hFontTitle = (HFONT) GetCurrentObject(hdc, OBJ_FONT);

		// Gets LOGFONT structure corresponding to current font
		LOGFONT LogFont;
		if (GetObject(gi->hFontTitle, sizeof(LOGFONT), &LogFont) == 0)
			return;

		// set the font to 12 :
		LogFont.lfHeight = -((12 * GetDeviceCaps(hdc, LOGPIXELSY))/ 72);
		LogFont.lfWeight = 300;
		//LogFont.lfOutPrecision=OUT_RASTER_PRECIS;
		LogFont.lfQuality=ANTIALIASED_QUALITY;
		LogFont.lfCharSet=DEFAULT_CHARSET;
		wcsncpy(LogFont.lfFaceName,L"HelveticaNeue LT 35 Thin\0",32);
		//LogFont.lfPitchAndFamily=FF_ROMAN|VARIABLE_PITCH;

		// Creates and sets font to device context
		gi->hFontTitle = CreateFontIndirect(&LogFont);
	}
	mouseEvent->setMouseAnalyse(this);
	if(title.empty())
		gi->rs.top=gi->rcVisibleDesktopTOP.top;
	else
		gi->rs.top=gi->rcVisibleDesktopTOP.top+TITLE_SECTION_HEIGHT;
	prevPos=0;
	prevOverlay=100;

	gi->mustRedraw=true;
	drawingHook=NULL;
}

Section::~Section(void)
{
	int taille=this->components.size();
	for(int i=0;i<taille;i++){
		if(this->components[i]!=NULL){
			delete this->components[i];
			this->components[i]=NULL;
		}
	}
	if(scrollBar!=NULL){
		DestroyWindow(scrollBar->windowOverlay);
	}
}

void Section::computeBkgSurface(){

	/*
	//old method... May be faster (memory and access to files) but HTC choose another approach
    HDC hdcImage;
    HDC hdc;
    DDSURFACEDESC ddsd;
    HRESULT hr;
	RECT rec={0,0,rcTitle.right-rcTitle.left,TITLE_SECTION_HEIGHT};
	
    BITMAP bm;

    if (bkgTitle == NULL || gi->ldDDraw == NULL)
        return;

    memset( &ddsd, 0, sizeof( ddsd ) );
    ddsd.dwSize = sizeof( ddsd );
    ddsd.dwFlags = DDSD_WIDTH | DDSD_HEIGHT;
	ddsd.dwWidth = rec.right;
	ddsd.dwHeight = TITLE_SECTION_HEIGHT;

    hr = (*gi->ldDDraw)->CreateSurface(&ddsd, &bkgSurface, NULL );
    if (hr != DD_OK)
    {
		LocalisedString::explainFailDirectDraw(hr,L"CreateSurface(bkgSurface)");
		return;
    }


    //
    // Select bitmap into a memoryDC so we can use it.
    //
    hdcImage = CreateCompatibleDC(NULL);
    if (!hdcImage) {
		LocalisedString::explainFail(LocalisedString::szGetDC,L"CreateCompatibleDC(NULL)");
        return;
    }
    SelectObject(hdcImage, bkgTitle);

    //
    // Get size of the bitmap
    //
    GetObject(bkgTitle, sizeof(bm), &bm);


	HBRUSH brush=CreatePatternBrush(bkgTitle);
    if ((hr = bkgSurface->GetDC(&hdc)) == DD_OK)
    {
		FillRect(hdc,&rec,brush);//&rcTitle
        bkgSurface->ReleaseDC(hdc);
    }else{
		LocalisedString::explainFailDirectDraw(hr,L"bkgSurface->GetDC(&hdc)");
		return;
	}
    DeleteDC(hdcImage);
	DeleteObject(brush);
	*/
}

Element* Section::isClicked(int x,int y){
	//can't be clicked directly... but the other componnents :------------------------
	Element* out=NULL;

	int taille=this->components.size();
	for(int i=0;i<taille;i++){
		if(this->components[i]!=NULL){
			out=this->components[i]->isClicked(x,y);
			if(out!=NULL)
				return out;
		}
	}
	return out;
};



void Section::printScrollBar(DIRECTDRAW_GDI* lpDDraw){
	HRESULT hres;
	if(prevOverlay==posOverlay){
		return;//no change for the scroll bar...
	}
	prevOverlay=posOverlay;
	int heightTitle=0;
	if(!title.empty())
		heightTitle=TITLE_SECTION_HEIGHT;
	double percent=((double)(gi->rs.bottom-gi->rs.top)/(double)(this->getHeight()-heightTitle));
	if(percent<0.8){//size is toller than screen, scroll bar is usefull :
		overlayVisibility(true);
		canScroll=true;
		DWORD dwWidth = GetSystemMetrics(SM_CXSCREEN);
		DWORD dwHeight = GetSystemMetrics(SM_CYSCREEN);
		double paddingtop=dwHeight-gi->rs.bottom;
		if(gi->hasMenuBar){
			paddingtop=paddingtop-(gi->window->hMenuArea.bottom-gi->window->hMenuArea.top);
			dwHeight=dwHeight-(gi->window->hMenuArea.bottom-gi->window->hMenuArea.top);
		}

		int heightScroll=(int)((gi->rs.bottom-gi->rs.top)*percent);
		double position=-((double)posOverlay*1000.0)/((double)(this->getHeight()-heightTitle)-(gi->rs.bottom-gi->rs.top));//posOverlay is <0
		int realPos=gi->rs.top+(int)(position*(gi->rs.bottom-heightScroll-gi->rs.top)/1000.0);


		if(prevPos==0){//first shoot
			prevOverlay=posOverlay;
			prevPos=realPos;
		}else{

			int posRealPrev=prevPos-(prevOverlay-posOverlay);
			if(posRealPrev+heightScroll>gi->rs.bottom)
				posRealPrev=gi->rs.bottom-heightScroll;
			if(posRealPrev<gi->rs.top)
					posRealPrev=gi->rs.top;
		}

		RECT pos={dwWidth-SCROLL_WIDTH-1,paddingtop+realPos,dwWidth-1,paddingtop+realPos+heightScroll};
		RECT overSrc={0,0,SCROLL_WIDTH,heightScroll};
		if(pos.top-paddingtop<gi->rs.top)
			pos.top=gi->rs.top+paddingtop;
		if(pos.bottom>dwHeight)
			pos.bottom=dwHeight-1;
		// Update the overlay parameters.
		if(pos.bottom-pos.top>0){
			hres = scrollBar->directDrawSurf->UpdateOverlay(&overSrc,
				gi->primaryBuffer->directDrawSurf, &pos, DDOVER_SHOW, NULL);
			//hres = gi->window->BltOverlay(&overSrc,&pos);
			if (hres != DD_OK){
				LocalisedString::explainFailDirectDraw(hres,L"show scrollBar");
			}
		}
		pos.top=gi->rs.top;
	}else{
		overlayVisibility(false);
	}
};
void Section::overlayVisibility(bool visib){
	if(scrollBar==NULL)
		return;
	scrollBar->visible=visib;
	
	if (visib)
	{
		if(!scrollVisible){
			//ShowWindow(scrollBar->windowOverlay,SW_SHOW);
			// Update the overlay parameters.
			scrollBar->directDrawSurf->UpdateOverlay(NULL, gi->primaryBuffer->directDrawSurf, NULL, DDOVER_SHOW, NULL);
		}
	}else{
		if(scrollVisible){
			//ShowWindow(scrollBar->windowOverlay,SW_HIDE);
			// Update the overlay parameters.
			scrollBar->directDrawSurf->UpdateOverlay(NULL, gi->primaryBuffer->directDrawSurf, NULL, DDOVER_HIDE, NULL);
		}
	}
	scrollVisible=visib;
}

void Section::paint(DIRECTDRAW_GDI* lpDDraw,int x,int y){
	if(drawingHook!=NULL){
		int heightTitle=0;
		if(!title.empty())
			heightTitle=TITLE_SECTION_HEIGHT;
		drawingHook->paint(lpDDraw,x+this->getLeft(),rcTitle.bottom+posOverlay+heightTitle);
		return;
	}
	HRESULT hres;/*
	if(gi->mustRedraw&&
		gi->rcUpdateRegion.bottom-gi->rcUpdateRegion.top>0){
		DDBLTFX ddbltfx;
		memset(&ddbltfx, 0, sizeof(ddbltfx));
		ddbltfx.dwSize = sizeof(ddbltfx);
		ddbltfx.dwFillColor = BACKGROUND_COLOR_MANILA;

		hres= gi->window->BltFast(lpDDraw,&gi->rcUpdateRegion,NULL,NULL, DDBLT_COLORFILL, &ddbltfx);
		if (hres != DD_OK){
			LocalisedString::explainFailDirectDraw(hres,L"lpDDraw->Blt(&bkgSurface)");
			return;
		}
	}
	*/
	//--------------------------print the other components :------------------------
	y=posOverlay+gi->rs.top;
	x+=this->getLeft();
	if(this->components.size()>0&&this->components[0]!=NULL){
		this->components[0]->paint(lpDDraw,x,y);
		int taille=this->components.size();
		for(int i=1;i<taille;i++){
			y+=this->components[i-1]->getBottom();
			if(this->components[i]!=NULL){
				this->components[i]->paint(lpDDraw,x,y);
			}
		}
	}
	gi->mustRedraw=false;


	//---------------------------print the scroll bar :--------------------
	if(scrollBar!=NULL)
		printScrollBar(lpDDraw);

	//-----------------------------print the title :------------------------
	//are we in the window ?
	//if out of screen, do nothing...

	int heightTitle=0;
	if(!title.empty())
		heightTitle=TITLE_SECTION_HEIGHT;
	if(gi->rcVisibleDesktopTOP.top+heightTitle<=gi->rcUpdateRegion.top||
		gi->rcUpdateRegion.bottom<gi->rcUpdateRegion.top)
		return;

	HDC hdc;
	positionAbsolute=gi->rs;
	positionAbsolute.top-=heightTitle;
	positionAbsolute.bottom=rcTitle.bottom+positionAbsolute.top;

	clipping.top=0;
	clipping.bottom=rcTitle.bottom-rcTitle.top;
	clipping.left=0;
	clipping.right=TITLE_SECTION_WIDTH;


	//now print background :
	//is the background for Title computed ?
/*	if(bkgSurface==NULL){
		computeBkgSurface();
	}*/
	hres= gi->window->BltFast(lpDDraw,&positionAbsolute, bkgSurface,&clipping,NULL,NULL);
	//hres= gi->window->BltFast(lpDDraw,&positionAbsolute, bkgSurface,&clipping,NULL,NULL);
	if (hres != DD_OK)
		LocalisedString::explainFailDirectDraw(hres,L"lpDDraw->Blt(&bkgSurface)");

	hdc=lpDDraw->deviceInterface;

	//font change :
	HFONT hOldFont = (HFONT) SelectObject(hdc, gi->hFontTitle);
	SetTextColor(hdc,RGB(32,32,32));
	SetBkMode(hdc,TRANSPARENT);

	//draw text
	DrawText(hdc,title.c_str(),title.length(),&positionAbsolute,DT_CENTER|DT_SINGLELINE|DT_VCENTER);
	SelectObject(hdc, hOldFont);

/*
	hres= gi->window->BltFast(lpDDraw,&positionAbsolute, gi->backBuffer,&positionAbsolute,NULL,NULL);
	if (hres != DD_OK)
		LocalisedString::explainFailDirectDraw(hres,L"lpDDraw->Blt(backBuffer)");
*/	
};

void Section::updateScreen(){
	if(this->owner==NULL){
		gi->rcUpdateRegion=gi->rs;
		this->paint(gi->primaryBuffer,0,0);
	}
}

void Section::add(Element* e,int minHeight,int pos,bool mixWithOther){
	ASSERT(mixWithOther==false);

	EnterCriticalSection(criticAdd);
	this->setBottom(this->getBottom()+e->getBottom());

	e->owner=this;
	int cSize=components.size();
	int heightElem=e->getBottom();
	if(heightElem<minHeight){
		heightElem=minHeight;
	}
	if(pos<0||pos>=cSize){
		this->components.push_back(e);
	}else{
		if(pos>=0){
			components.push_back(NULL);
			//move items :
			for(int i=cSize;i>pos;i--){
				components[i]=components[i-1];
			}
			components[pos]=e;
		}
	}
	LeaveCriticalSection(criticAdd);
};

void Section::remove(unsigned int pos){
	if(pos>=this->components.size())
		return;
	EnterCriticalSection(criticAdd);
	int height=this->components[pos]->getHeight();
	delete this->components[pos];
	int taille=this->components.size();
	for(int i=pos;i<taille-1;i++){
		this->components[i]=this->components[i+1];
	}
	this->components[taille-1]=NULL;
	this->components.pop_back();
	//What is the new size?
	this->setBottom(this->getBottom()-height);
	LeaveCriticalSection(criticAdd);
};


int Section::mouseGesture(){
	/*
	if(!mouseEvent->pickChange())
		return 0;//nothing to do...
*/
	if (mouseEvent->isRightClicked())
	{
		int posX,posY;
		this->mouseEvent->getMousePosition(posX,posY);
		this->selectedElement=isClicked(posX,posY);
		if(this->selectedElement!=NULL){
			this->selectedElement->run(true);
			this->selectedElement=NULL;
		}
	}
	if(mouseEvent->isDblClicked()){//nothing to do...
		if(this->selectedElement!=NULL){
			this->selectedElement->unClick();
			this->selectedElement=NULL;
		}
		return 0;
	}

	bool isDragged=mouseEvent->isMouseDown();
	if(mouseEvent->isClicked()){
		if(this->selectedElement!=NULL){
			if(this->selectedElement->run()){
				this->selectedElement=NULL;
				return 0;//selectedElement has taken control of mouse
			}
		}
		this->selectedElement=NULL;
	}

	if(mouseEvent->isSelected()){
		if(this->selectedElement==NULL){
			int posX,posY;
			this->mouseEvent->getMousePosition(posX,posY);
			this->selectedElement=isClicked(posX,posY);
		}
	}else{
		if(this->selectedElement!=NULL){
			this->selectedElement->unClick();
			this->selectedElement=NULL;
		}
	}

	if(gi->mustRedraw)
		return 0;

	int heightTitle=0;
	if(!title.empty())
		heightTitle=TITLE_SECTION_HEIGHT;
	double percent=((double)(gi->rs.bottom-gi->rs.top)/(double)(this->getHeight()-heightTitle));

	if (percent>1){//size is bigger than screen, scroll bar isn't usefull:
		if(!canScroll){
			mouseEvent->stopScroll();
			return 0;
		}
	}
	//--------------------------scrolling behavior:

	if(this->mouseEvent->isSlidingLeft()){
		//is this section a subsection ?
		if(this->owner!=NULL){
			//someone owns this section, it's probably a subsection !
			//so we render the control:
			this->owner->run();
			return 0;
		}
	}

	return verifScrollingRange(this->mouseEvent->getMouseDY(),isDragged);

};

int Section::verifScrollingRange(int dY,bool isDragged)
{
	int out=0;
	bool isOut=false;
	//if((getHeight()>gi->rs.bottom-gi->rcVisibleDesktopTOP.top)&&//is tall enough :
	int maxSize=(gi->rs.bottom-gi->rcVisibleDesktopTOP.top);
	if(maxSize>getHeight())
		maxSize=getHeight();
	if(getHeight()+posOverlay+dY<maxSize&&!isDragged){
		out= maxSize-getHeight()-posOverlay;
		posOverlay = maxSize-getHeight();
		isOut=true;
	}else{	
		if(posOverlay+dY>0&&!isDragged){
			out= -posOverlay;
			posOverlay = 0;
			isOut=true;
		}
	}

	if(!isOut){
		this->posOverlay+=dY;
		out= dY;
	}else{
		mouseEvent->stopScroll();
	}
	return out;
}

void Section::setDrawingHook(Element* e){
	this->drawingHook=e;
};

void Section::sizeChanged(Element* src,int w,int h){
	int prevHeight=src->getHeight();
	if(prevHeight<h){
		setHeight(getHeight()+(h-prevHeight));
	}
}

void Section::goToTop() 
{
	posOverlay=0;
}